/* A Bison parser, made by GNU Bison 3.7.6.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30706

/* Bison version string.  */
#define YYBISON_VERSION "3.7.6"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 2

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 30 "parser.yy"


// generated code contains some useless casts
#pragma GCC diagnostic ignored "-Wuseless-cast"

#define yyerror Lily_parser::parser_error

/* We use custom location type: Input objects */
#define YYLTYPE Input
#define YYSTYPE SCM
#define YYLLOC_DEFAULT(Current,Rhs,N) \
	((Current).set_location ((Rhs)[1], (Rhs)[N]))

#define YYPRINT(file, type, value)					\
	do {								\
		if (scm_is_eq (value, SCM_UNSPECIFIED))			\
			break;						\
		SCM s = Display::value_to_lily_string (value);		\
		char *p = scm_to_locale_string (s);			\
		fputs (p, file);					\
		free (p);						\
	} while (0)

#line 101 "parser.yy"
 // -*-Fundamental-*-

/*
FIXME:

   * The rules for who is protecting what are very shady.  Uniformise
     this.

   * There are too many lexical modes?
*/

#include "config.hh"

#include <cctype>
#include <cstdlib>
#include <cstdio>

#include "book.hh"
#include "context.hh"
#include "context-def.hh"
#include "context-mod.hh"
#include "dimensions.hh"
#include "file-path.hh"
#include "input.hh"
#include "international.hh"
#include "lily-guile.hh"
#include "lily-lexer.hh"
#include "lily-parser.hh"
#include "ly-module.hh"
#include "ly-scm-list.hh"
#include "main.hh"
#include "misc.hh"
#include "music.hh"
#include "output-def.hh"
#include "paper-book.hh"
#include "scm-hash.hh"
#include "score.hh"
#include "text-interface.hh"
#include "warn.hh"
#include "lily-imports.hh"

void
Lily_parser::parser_error (Input const *i, Lily_parser *parser, SCM *, const std::string &s)
{
	parser->parser_error (*i, s);
}

// The following are somewhat precarious constructs as they may change
// the value of the lookahead token.  That implies that the lookahead
// token must not yet have made an impact on the state stack other
// than causing the reduction of the current rule, or switching the
// lookahead token while Bison is mulling it over will cause trouble.

#define MYBACKUP(Token, Value, Location)				\
	do {								\
		if (yychar != YYEMPTY)					\
			parser->lexer_->push_extra_token		\
				(yylloc, yychar, yylval);		\
		parser->lexer_->push_extra_token			\
			(Location, Token, Value);			\
		parser->lexer_->push_extra_token (Location, BACKUP);	\
		yychar = YYEMPTY;					\
	} while (0)


#define MYREPARSE(Location, Pred, Token, Value)				\
	do {								\
		if (yychar != YYEMPTY)					\
			parser->lexer_->push_extra_token		\
				(yylloc, yychar, yylval);		\
		parser->lexer_->push_extra_token			\
			(Location, Token, Value);			\
		parser->lexer_->push_extra_token			\
			(Location, REPARSE, Pred);			\
		yychar = YYEMPTY;					\
	} while (0)

#line 181 "parser.yy"


#define MY_MAKE_MUSIC(x, spot) \
	make_music_with_input (ly_symbol2scm (x), \
			       parser->lexer_->override_input (spot))

/* ES TODO:
- delay application of the function
*/

#define LOWLEVEL_MAKE_SYNTAX(location, proc, ...)			\
	with_location							\
		(parser->lexer_->override_input (location).smobbed_copy (), \
		 proc,							\
		 ##__VA_ARGS__)

/* Syntactic Sugar. */
#define MAKE_SYNTAX(name, location, ...)				\
	LOWLEVEL_MAKE_SYNTAX (location, Syntax::name, ##__VA_ARGS__)

#define START_MAKE_SYNTAX(name, ...)					\
	scm_list_n (Syntax::name, ##__VA_ARGS__, SCM_UNDEFINED)

#define FINISH_MAKE_SYNTAX(start, location, ...)			\
	LOWLEVEL_MAKE_SYNTAX						\
		(location,						\
		 Guile_user::apply,					\
		 scm_car (start),					\
		 scm_append_x						\
		 (scm_list_2 (scm_cdr (start),				\
			      scm_list_n (__VA_ARGS__, SCM_UNDEFINED))))

#undef _
#if !HAVE_GETTEXT
#define _(x) x
#else
#include <libintl.h>
#define _(x) gettext (x)
#endif

using std::string;

static Music *make_music_with_input (SCM name, Input where);
bool add_post_events (Music *music, SCM events);
SCM reverse_music_list (Lily_parser *parser, Input loc, SCM lst, bool preserve, bool compress);
SCM check_scheme_arg (Lily_parser *parser, Input loc,
		      SCM arg, SCM args, SCM pred, SCM disp = SCM_UNDEFINED);
SCM make_music_from_simple (Lily_parser *parser, Input loc, SCM pitch);
SCM loc_on_copy (Lily_parser *parser, Input loc, SCM arg);
SCM make_chord_elements (Input loc, SCM pitch, SCM dur, SCM modification_list);
SCM make_chord_step (SCM step, Rational alter);
SCM make_simple_markup (SCM a);
SCM make_duration (SCM t, int dots = 0, SCM factor = SCM_UNDEFINED);
bool is_regular_identifier (SCM id, bool multiple=false);
SCM make_reverse_key_list (SCM keys);
SCM try_word_variants (SCM pred, SCM str);
SCM try_string_variants (SCM pred, SCM str);
SCM post_event_cons (SCM ev, SCM tail);
int yylex (YYSTYPE *s, YYLTYPE *loc, Lily_parser *parser);


#line 235 "./out/parser.cc"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "parser.hh"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of input"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_PREC_BOT = 3,                   /* PREC_BOT  */
  YYSYMBOL_COMPOSITE = 4,                  /* COMPOSITE  */
  YYSYMBOL_5_ = 5,                         /* ':'  */
  YYSYMBOL_6_ = 6,                         /* '^'  */
  YYSYMBOL_7___ = 7,                       /* '_'  */
  YYSYMBOL_8_ = 8,                         /* '!'  */
  YYSYMBOL_9_ = 9,                         /* '\''  */
  YYSYMBOL_10_ = 10,                       /* ','  */
  YYSYMBOL_PREC_TOP = 11,                  /* PREC_TOP  */
  YYSYMBOL_ACCEPTS = 12,                   /* "\\accepts"  */
  YYSYMBOL_ADDLYRICS = 13,                 /* "\\addlyrics"  */
  YYSYMBOL_ALIAS = 14,                     /* "\\alias"  */
  YYSYMBOL_ALTERNATIVE = 15,               /* "\\alternative"  */
  YYSYMBOL_BOOK = 16,                      /* "\\book"  */
  YYSYMBOL_BOOKPART = 17,                  /* "\\bookpart"  */
  YYSYMBOL_CHANGE = 18,                    /* "\\change"  */
  YYSYMBOL_CHORDMODE = 19,                 /* "\\chordmode"  */
  YYSYMBOL_CHORDS = 20,                    /* "\\chords"  */
  YYSYMBOL_CONSISTS = 21,                  /* "\\consists"  */
  YYSYMBOL_CONTEXT = 22,                   /* "\\context"  */
  YYSYMBOL_DEFAULT = 23,                   /* "\\default"  */
  YYSYMBOL_DEFAULTCHILD = 24,              /* "\\defaultchild"  */
  YYSYMBOL_DENIES = 25,                    /* "\\denies"  */
  YYSYMBOL_DESCRIPTION = 26,               /* "\\description"  */
  YYSYMBOL_DRUMMODE = 27,                  /* "\\drummode"  */
  YYSYMBOL_DRUMS = 28,                     /* "\\drums"  */
  YYSYMBOL_ETC = 29,                       /* "\\etc"  */
  YYSYMBOL_FIGUREMODE = 30,                /* "\\figuremode"  */
  YYSYMBOL_FIGURES = 31,                   /* "\\figures"  */
  YYSYMBOL_HEADER = 32,                    /* "\\header"  */
  YYSYMBOL_INVALID = 33,                   /* "\\version-error"  */
  YYSYMBOL_LAYOUT = 34,                    /* "\\layout"  */
  YYSYMBOL_LYRICMODE = 35,                 /* "\\lyricmode"  */
  YYSYMBOL_LYRICS = 36,                    /* "\\lyrics"  */
  YYSYMBOL_LYRICSTO = 37,                  /* "\\lyricsto"  */
  YYSYMBOL_MARKUP = 38,                    /* "\\markup"  */
  YYSYMBOL_MARKUPLIST = 39,                /* "\\markuplist"  */
  YYSYMBOL_MIDI = 40,                      /* "\\midi"  */
  YYSYMBOL_NAME = 41,                      /* "\\name"  */
  YYSYMBOL_NOTEMODE = 42,                  /* "\\notemode"  */
  YYSYMBOL_OVERRIDE = 43,                  /* "\\override"  */
  YYSYMBOL_PAPER = 44,                     /* "\\paper"  */
  YYSYMBOL_REMOVE = 45,                    /* "\\remove"  */
  YYSYMBOL_REPEAT = 46,                    /* "\\repeat"  */
  YYSYMBOL_REST = 47,                      /* "\\rest"  */
  YYSYMBOL_REVERT = 48,                    /* "\\revert"  */
  YYSYMBOL_SCORE = 49,                     /* "\\score"  */
  YYSYMBOL_SCORELINES = 50,                /* "\\score-lines"  */
  YYSYMBOL_SEQUENTIAL = 51,                /* "\\sequential"  */
  YYSYMBOL_SET = 52,                       /* "\\set"  */
  YYSYMBOL_SIMULTANEOUS = 53,              /* "\\simultaneous"  */
  YYSYMBOL_TEMPO = 54,                     /* "\\tempo"  */
  YYSYMBOL_TYPE = 55,                      /* "\\type"  */
  YYSYMBOL_UNSET = 56,                     /* "\\unset"  */
  YYSYMBOL_WITH = 57,                      /* "\\with"  */
  YYSYMBOL_NEWCONTEXT = 58,                /* "\\new"  */
  YYSYMBOL_CHORD_BASS = 59,                /* "/+"  */
  YYSYMBOL_CHORD_CARET = 60,               /* "^"  */
  YYSYMBOL_CHORD_COLON = 61,               /* ":"  */
  YYSYMBOL_CHORD_MINUS = 62,               /* "-"  */
  YYSYMBOL_CHORD_SLASH = 63,               /* "/"  */
  YYSYMBOL_ANGLE_OPEN = 64,                /* "<"  */
  YYSYMBOL_ANGLE_CLOSE = 65,               /* ">"  */
  YYSYMBOL_DOUBLE_ANGLE_OPEN = 66,         /* "<<"  */
  YYSYMBOL_DOUBLE_ANGLE_CLOSE = 67,        /* ">>"  */
  YYSYMBOL_E_BACKSLASH = 68,               /* "\\\\"  */
  YYSYMBOL_E_EXCLAMATION = 69,             /* "\\!"  */
  YYSYMBOL_E_PLUS = 70,                    /* "\\+"  */
  YYSYMBOL_EXTENDER = 71,                  /* "__"  */
  YYSYMBOL_FIGURE_CLOSE = 72,              /* FIGURE_CLOSE  */
  YYSYMBOL_FIGURE_OPEN = 73,               /* FIGURE_OPEN  */
  YYSYMBOL_FIGURE_SPACE = 74,              /* "_"  */
  YYSYMBOL_HYPHEN = 75,                    /* "--"  */
  YYSYMBOL_MULTI_MEASURE_REST = 76,        /* MULTI_MEASURE_REST  */
  YYSYMBOL_E_UNSIGNED = 77,                /* E_UNSIGNED  */
  YYSYMBOL_UNSIGNED = 78,                  /* UNSIGNED  */
  YYSYMBOL_EXPECT_MARKUP = 79,             /* "markup?"  */
  YYSYMBOL_EXPECT_SCM = 80,                /* "scheme?"  */
  YYSYMBOL_BACKUP = 81,                    /* "(backed-up?)"  */
  YYSYMBOL_REPARSE = 82,                   /* "(reparsed?)"  */
  YYSYMBOL_EXPECT_MARKUP_LIST = 83,        /* "markup-list?"  */
  YYSYMBOL_EXPECT_OPTIONAL = 84,           /* "optional?"  */
  YYSYMBOL_EXPECT_NO_MORE_ARGS = 85,       /* EXPECT_NO_MORE_ARGS  */
  YYSYMBOL_EMBEDDED_LILY = 86,             /* "#{"  */
  YYSYMBOL_BOOK_IDENTIFIER = 87,           /* BOOK_IDENTIFIER  */
  YYSYMBOL_CHORD_MODIFIER = 88,            /* CHORD_MODIFIER  */
  YYSYMBOL_CHORD_REPETITION = 89,          /* CHORD_REPETITION  */
  YYSYMBOL_DRUM_PITCH = 90,                /* DRUM_PITCH  */
  YYSYMBOL_DURATION_ARG = 91,              /* DURATION_ARG  */
  YYSYMBOL_DURATION_IDENTIFIER = 92,       /* DURATION_IDENTIFIER  */
  YYSYMBOL_EVENT_IDENTIFIER = 93,          /* EVENT_IDENTIFIER  */
  YYSYMBOL_EVENT_FUNCTION = 94,            /* EVENT_FUNCTION  */
  YYSYMBOL_FRACTION = 95,                  /* FRACTION  */
  YYSYMBOL_LOOKUP_IDENTIFIER = 96,         /* LOOKUP_IDENTIFIER  */
  YYSYMBOL_LYRIC_ELEMENT = 97,             /* LYRIC_ELEMENT  */
  YYSYMBOL_MARKUP_FUNCTION = 98,           /* MARKUP_FUNCTION  */
  YYSYMBOL_MARKUP_LIST_FUNCTION = 99,      /* MARKUP_LIST_FUNCTION  */
  YYSYMBOL_MARKUP_IDENTIFIER = 100,        /* MARKUP_IDENTIFIER  */
  YYSYMBOL_MARKUPLIST_IDENTIFIER = 101,    /* MARKUPLIST_IDENTIFIER  */
  YYSYMBOL_MUSIC_FUNCTION = 102,           /* MUSIC_FUNCTION  */
  YYSYMBOL_MUSIC_IDENTIFIER = 103,         /* MUSIC_IDENTIFIER  */
  YYSYMBOL_NOTENAME_PITCH = 104,           /* NOTENAME_PITCH  */
  YYSYMBOL_NUMBER_IDENTIFIER = 105,        /* NUMBER_IDENTIFIER  */
  YYSYMBOL_PITCH_IDENTIFIER = 106,         /* PITCH_IDENTIFIER  */
  YYSYMBOL_REAL = 107,                     /* REAL  */
  YYSYMBOL_RESTNAME = 108,                 /* RESTNAME  */
  YYSYMBOL_SCM_ARG = 109,                  /* SCM_ARG  */
  YYSYMBOL_SCM_FUNCTION = 110,             /* SCM_FUNCTION  */
  YYSYMBOL_SCM_IDENTIFIER = 111,           /* SCM_IDENTIFIER  */
  YYSYMBOL_SCM_TOKEN = 112,                /* SCM_TOKEN  */
  YYSYMBOL_STRING = 113,                   /* STRING  */
  YYSYMBOL_SYMBOL_LIST = 114,              /* SYMBOL_LIST  */
  YYSYMBOL_TONICNAME_PITCH = 115,          /* TONICNAME_PITCH  */
  YYSYMBOL_SYMBOL = 116,                   /* SYMBOL  */
  YYSYMBOL_117_ = 117,                     /* '-'  */
  YYSYMBOL_118_ = 118,                     /* '+'  */
  YYSYMBOL_UNARY_MINUS = 119,              /* UNARY_MINUS  */
  YYSYMBOL_120_ = 120,                     /* '.'  */
  YYSYMBOL_121_ = 121,                     /* '{'  */
  YYSYMBOL_122_ = 122,                     /* '}'  */
  YYSYMBOL_123_ = 123,                     /* '='  */
  YYSYMBOL_124_ = 124,                     /* '*'  */
  YYSYMBOL_125_ = 125,                     /* ']'  */
  YYSYMBOL_126_ = 126,                     /* '/'  */
  YYSYMBOL_127_ = 127,                     /* '['  */
  YYSYMBOL_128_ = 128,                     /* '?'  */
  YYSYMBOL_YYACCEPT = 129,                 /* $accept  */
  YYSYMBOL_start_symbol = 130,             /* start_symbol  */
  YYSYMBOL_131_1 = 131,                    /* $@1  */
  YYSYMBOL_lilypond = 132,                 /* lilypond  */
  YYSYMBOL_toplevel_expression = 133,      /* toplevel_expression  */
  YYSYMBOL_lookup = 134,                   /* lookup  */
  YYSYMBOL_embedded_scm_bare = 135,        /* embedded_scm_bare  */
  YYSYMBOL_embedded_scm_active = 136,      /* embedded_scm_active  */
  YYSYMBOL_embedded_scm_bare_arg = 137,    /* embedded_scm_bare_arg  */
  YYSYMBOL_embedded_scm = 138,             /* embedded_scm  */
  YYSYMBOL_embedded_scm_arg = 139,         /* embedded_scm_arg  */
  YYSYMBOL_scm_function_call = 140,        /* scm_function_call  */
  YYSYMBOL_embedded_lilypond_number = 141, /* embedded_lilypond_number  */
  YYSYMBOL_embedded_lilypond = 142,        /* embedded_lilypond  */
  YYSYMBOL_lilypond_header_body = 143,     /* lilypond_header_body  */
  YYSYMBOL_lilypond_header = 144,          /* lilypond_header  */
  YYSYMBOL_header_block = 145,             /* header_block  */
  YYSYMBOL_146_2 = 146,                    /* $@2  */
  YYSYMBOL_assignment_id = 147,            /* assignment_id  */
  YYSYMBOL_assignment = 148,               /* assignment  */
  YYSYMBOL_identifier_init = 149,          /* identifier_init  */
  YYSYMBOL_identifier_init_nonumber = 150, /* identifier_init_nonumber  */
  YYSYMBOL_partial_function_scriptable = 151, /* partial_function_scriptable  */
  YYSYMBOL_partial_function = 152,         /* partial_function  */
  YYSYMBOL_context_def_spec_block = 153,   /* context_def_spec_block  */
  YYSYMBOL_context_mod_arg = 154,          /* context_mod_arg  */
  YYSYMBOL_155_3 = 155,                    /* $@3  */
  YYSYMBOL_context_def_spec_body = 156,    /* context_def_spec_body  */
  YYSYMBOL_book_block = 157,               /* book_block  */
  YYSYMBOL_book_body = 158,                /* book_body  */
  YYSYMBOL_159_4 = 159,                    /* $@4  */
  YYSYMBOL_bookpart_block = 160,           /* bookpart_block  */
  YYSYMBOL_bookpart_body = 161,            /* bookpart_body  */
  YYSYMBOL_162_5 = 162,                    /* $@5  */
  YYSYMBOL_score_block = 163,              /* score_block  */
  YYSYMBOL_score_body = 164,               /* score_body  */
  YYSYMBOL_score_item = 165,               /* score_item  */
  YYSYMBOL_score_items = 166,              /* score_items  */
  YYSYMBOL_167_6 = 167,                    /* $@6  */
  YYSYMBOL_paper_block = 168,              /* paper_block  */
  YYSYMBOL_output_def = 169,               /* output_def  */
  YYSYMBOL_output_def_head = 170,          /* output_def_head  */
  YYSYMBOL_output_def_head_with_mode_switch = 171, /* output_def_head_with_mode_switch  */
  YYSYMBOL_music_or_context_def = 172,     /* music_or_context_def  */
  YYSYMBOL_output_def_body = 173,          /* output_def_body  */
  YYSYMBOL_174_7 = 174,                    /* $@7  */
  YYSYMBOL_tempo_event = 175,              /* tempo_event  */
  YYSYMBOL_music_list = 176,               /* music_list  */
  YYSYMBOL_braced_music_list = 177,        /* braced_music_list  */
  YYSYMBOL_music = 178,                    /* music  */
  YYSYMBOL_pitch_as_music = 179,           /* pitch_as_music  */
  YYSYMBOL_music_embedded = 180,           /* music_embedded  */
  YYSYMBOL_music_embedded_backup = 181,    /* music_embedded_backup  */
  YYSYMBOL_music_assign = 182,             /* music_assign  */
  YYSYMBOL_repeated_music = 183,           /* repeated_music  */
  YYSYMBOL_sequential_music = 184,         /* sequential_music  */
  YYSYMBOL_simultaneous_music = 185,       /* simultaneous_music  */
  YYSYMBOL_simple_music = 186,             /* simple_music  */
  YYSYMBOL_context_modification = 187,     /* context_modification  */
  YYSYMBOL_188_8 = 188,                    /* $@8  */
  YYSYMBOL_context_modification_arg = 189, /* context_modification_arg  */
  YYSYMBOL_optional_context_mods = 190,    /* optional_context_mods  */
  YYSYMBOL_context_modification_mods_list = 191, /* context_modification_mods_list  */
  YYSYMBOL_context_mod_list = 192,         /* context_mod_list  */
  YYSYMBOL_context_prefix = 193,           /* context_prefix  */
  YYSYMBOL_new_lyrics = 194,               /* new_lyrics  */
  YYSYMBOL_basic_music = 195,              /* basic_music  */
  YYSYMBOL_contextable_music = 196,        /* contextable_music  */
  YYSYMBOL_contexted_basic_music = 197,    /* contexted_basic_music  */
  YYSYMBOL_composite_music = 198,          /* composite_music  */
  YYSYMBOL_music_bare = 199,               /* music_bare  */
  YYSYMBOL_grouped_music_list = 200,       /* grouped_music_list  */
  YYSYMBOL_symbol_list_arg = 201,          /* symbol_list_arg  */
  YYSYMBOL_symbol_list_rev = 202,          /* symbol_list_rev  */
  YYSYMBOL_symbol_list_part = 203,         /* symbol_list_part  */
  YYSYMBOL_symbol_list_element = 204,      /* symbol_list_element  */
  YYSYMBOL_symbol_list_part_bare = 205,    /* symbol_list_part_bare  */
  YYSYMBOL_function_arglist_nonbackup = 206, /* function_arglist_nonbackup  */
  YYSYMBOL_reparsed_rhythm = 207,          /* reparsed_rhythm  */
  YYSYMBOL_function_arglist_nonbackup_reparse = 208, /* function_arglist_nonbackup_reparse  */
  YYSYMBOL_function_arglist_backup = 209,  /* function_arglist_backup  */
  YYSYMBOL_function_arglist = 210,         /* function_arglist  */
  YYSYMBOL_function_arglist_skip_nonbackup = 211, /* function_arglist_skip_nonbackup  */
  YYSYMBOL_function_arglist_partial = 212, /* function_arglist_partial  */
  YYSYMBOL_function_arglist_partial_optional = 213, /* function_arglist_partial_optional  */
  YYSYMBOL_function_arglist_common = 214,  /* function_arglist_common  */
  YYSYMBOL_function_arglist_common_reparse = 215, /* function_arglist_common_reparse  */
  YYSYMBOL_function_arglist_optional = 216, /* function_arglist_optional  */
  YYSYMBOL_function_arglist_skip_backup = 217, /* function_arglist_skip_backup  */
  YYSYMBOL_music_function_call = 218,      /* music_function_call  */
  YYSYMBOL_optional_id = 219,              /* optional_id  */
  YYSYMBOL_lyric_mode_music = 220,         /* lyric_mode_music  */
  YYSYMBOL_221_9 = 221,                    /* $@9  */
  YYSYMBOL_mode_changed_music = 222,       /* mode_changed_music  */
  YYSYMBOL_mode_changing_head = 223,       /* mode_changing_head  */
  YYSYMBOL_mode_changing_head_with_context = 224, /* mode_changing_head_with_context  */
  YYSYMBOL_context_change = 225,           /* context_change  */
  YYSYMBOL_property_path = 226,            /* property_path  */
  YYSYMBOL_property_operation = 227,       /* property_operation  */
  YYSYMBOL_revert_arg = 228,               /* revert_arg  */
  YYSYMBOL_revert_arg_backup = 229,        /* revert_arg_backup  */
  YYSYMBOL_revert_arg_part = 230,          /* revert_arg_part  */
  YYSYMBOL_context_def_mod = 231,          /* context_def_mod  */
  YYSYMBOL_context_mod = 232,              /* context_mod  */
  YYSYMBOL_grob_prop_spec = 233,           /* grob_prop_spec  */
  YYSYMBOL_grob_prop_path = 234,           /* grob_prop_path  */
  YYSYMBOL_context_prop_spec = 235,        /* context_prop_spec  */
  YYSYMBOL_simple_revert_context = 236,    /* simple_revert_context  */
  YYSYMBOL_music_property_def = 237,       /* music_property_def  */
  YYSYMBOL_string = 238,                   /* string  */
  YYSYMBOL_text = 239,                     /* text  */
  YYSYMBOL_simple_string = 240,            /* simple_string  */
  YYSYMBOL_symbol = 241,                   /* symbol  */
  YYSYMBOL_scalar = 242,                   /* scalar  */
  YYSYMBOL_event_chord = 243,              /* event_chord  */
  YYSYMBOL_note_chord_element = 244,       /* note_chord_element  */
  YYSYMBOL_chord_body = 245,               /* chord_body  */
  YYSYMBOL_chord_body_elements = 246,      /* chord_body_elements  */
  YYSYMBOL_chord_body_element = 247,       /* chord_body_element  */
  YYSYMBOL_music_function_chord_body = 248, /* music_function_chord_body  */
  YYSYMBOL_event_function_event = 249,     /* event_function_event  */
  YYSYMBOL_post_events = 250,              /* post_events  */
  YYSYMBOL_post_event_nofinger = 251,      /* post_event_nofinger  */
  YYSYMBOL_post_event = 252,               /* post_event  */
  YYSYMBOL_string_number_event = 253,      /* string_number_event  */
  YYSYMBOL_direction_less_event = 254,     /* direction_less_event  */
  YYSYMBOL_direction_reqd_event = 255,     /* direction_reqd_event  */
  YYSYMBOL_octave_check = 256,             /* octave_check  */
  YYSYMBOL_quotes = 257,                   /* quotes  */
  YYSYMBOL_erroneous_quotes = 258,         /* erroneous_quotes  */
  YYSYMBOL_sup_quotes = 259,               /* sup_quotes  */
  YYSYMBOL_sub_quotes = 260,               /* sub_quotes  */
  YYSYMBOL_steno_pitch = 261,              /* steno_pitch  */
  YYSYMBOL_steno_tonic_pitch = 262,        /* steno_tonic_pitch  */
  YYSYMBOL_pitch = 263,                    /* pitch  */
  YYSYMBOL_pitch_or_tonic_pitch = 264,     /* pitch_or_tonic_pitch  */
  YYSYMBOL_gen_text_def = 265,             /* gen_text_def  */
  YYSYMBOL_fingering = 266,                /* fingering  */
  YYSYMBOL_script_abbreviation = 267,      /* script_abbreviation  */
  YYSYMBOL_script_dir = 268,               /* script_dir  */
  YYSYMBOL_maybe_notemode_duration = 269,  /* maybe_notemode_duration  */
  YYSYMBOL_optional_notemode_duration = 270, /* optional_notemode_duration  */
  YYSYMBOL_steno_duration = 271,           /* steno_duration  */
  YYSYMBOL_duration = 272,                 /* duration  */
  YYSYMBOL_dots = 273,                     /* dots  */
  YYSYMBOL_multiplier_scm = 274,           /* multiplier_scm  */
  YYSYMBOL_multipliers = 275,              /* multipliers  */
  YYSYMBOL_tremolo_type = 276,             /* tremolo_type  */
  YYSYMBOL_bass_number = 277,              /* bass_number  */
  YYSYMBOL_figured_bass_alteration = 278,  /* figured_bass_alteration  */
  YYSYMBOL_bass_figure = 279,              /* bass_figure  */
  YYSYMBOL_figured_bass_modification = 280, /* figured_bass_modification  */
  YYSYMBOL_br_bass_figure = 281,           /* br_bass_figure  */
  YYSYMBOL_figure_list = 282,              /* figure_list  */
  YYSYMBOL_optional_rest = 283,            /* optional_rest  */
  YYSYMBOL_pitch_or_music = 284,           /* pitch_or_music  */
  YYSYMBOL_simple_element = 285,           /* simple_element  */
  YYSYMBOL_lyric_element = 286,            /* lyric_element  */
  YYSYMBOL_lyric_element_music = 287,      /* lyric_element_music  */
  YYSYMBOL_new_chord = 288,                /* new_chord  */
  YYSYMBOL_chord_items = 289,              /* chord_items  */
  YYSYMBOL_chord_separator = 290,          /* chord_separator  */
  YYSYMBOL_chord_item = 291,               /* chord_item  */
  YYSYMBOL_step_numbers = 292,             /* step_numbers  */
  YYSYMBOL_step_number = 293,              /* step_number  */
  YYSYMBOL_tempo_range = 294,              /* tempo_range  */
  YYSYMBOL_number_expression = 295,        /* number_expression  */
  YYSYMBOL_number_term = 296,              /* number_term  */
  YYSYMBOL_number_factor = 297,            /* number_factor  */
  YYSYMBOL_bare_number_common = 298,       /* bare_number_common  */
  YYSYMBOL_bare_number = 299,              /* bare_number  */
  YYSYMBOL_unsigned_number = 300,          /* unsigned_number  */
  YYSYMBOL_exclamations = 301,             /* exclamations  */
  YYSYMBOL_questions = 302,                /* questions  */
  YYSYMBOL_full_markup_list = 303,         /* full_markup_list  */
  YYSYMBOL_304_10 = 304,                   /* $@10  */
  YYSYMBOL_markup_mode = 305,              /* markup_mode  */
  YYSYMBOL_markup_mode_word = 306,         /* markup_mode_word  */
  YYSYMBOL_full_markup = 307,              /* full_markup  */
  YYSYMBOL_partial_markup = 308,           /* partial_markup  */
  YYSYMBOL_markup_top = 309,               /* markup_top  */
  YYSYMBOL_markup_scm = 310,               /* markup_scm  */
  YYSYMBOL_311_11 = 311,                   /* $@11  */
  YYSYMBOL_markup_list = 312,              /* markup_list  */
  YYSYMBOL_markup_uncomposed_list = 313,   /* markup_uncomposed_list  */
  YYSYMBOL_314_12 = 314,                   /* $@12  */
  YYSYMBOL_markup_composed_list = 315,     /* markup_composed_list  */
  YYSYMBOL_markup_braced_list = 316,       /* markup_braced_list  */
  YYSYMBOL_markup_braced_list_body = 317,  /* markup_braced_list_body  */
  YYSYMBOL_markup_command_list = 318,      /* markup_command_list  */
  YYSYMBOL_markup_command_embedded_lilypond = 319, /* markup_command_embedded_lilypond  */
  YYSYMBOL_320_13 = 320,                   /* $@13  */
  YYSYMBOL_markup_command_basic_arguments = 321, /* markup_command_basic_arguments  */
  YYSYMBOL_markup_command_list_arguments = 322, /* markup_command_list_arguments  */
  YYSYMBOL_markup_partial_function = 323,  /* markup_partial_function  */
  YYSYMBOL_markup_arglist_partial = 324,   /* markup_arglist_partial  */
  YYSYMBOL_markup_head_1_item = 325,       /* markup_head_1_item  */
  YYSYMBOL_markup_head_1_list = 326,       /* markup_head_1_list  */
  YYSYMBOL_markup_word = 327,              /* markup_word  */
  YYSYMBOL_simple_markup = 328,            /* simple_markup  */
  YYSYMBOL_simple_markup_noword = 329,     /* simple_markup_noword  */
  YYSYMBOL_330_14 = 330,                   /* $@14  */
  YYSYMBOL_markup = 331                    /* markup  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  5
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   4629

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  129
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  203
/* YYNRULES -- Number of rules.  */
#define YYNRULES  606
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  894

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   366


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     8,     2,     2,     2,     2,     2,     9,
       2,     2,   124,   118,    10,   117,   120,   126,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     5,     2,
       2,   123,     2,   128,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   127,     2,   125,     6,     7,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   121,     2,   122,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   119
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   388,   388,   389,   389,   397,   398,   400,   402,   405,
     412,   415,   419,   423,   430,   434,   438,   442,   446,   450,
     485,   501,   502,   510,   514,   518,   519,   520,   524,   525,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   545,   546,   547,   560,   561,   562,   566,   573,   577,
     578,   586,   593,   594,   595,   600,   612,   630,   634,   642,
     643,   646,   650,   659,   665,   665,   676,   680,   687,   691,
     696,   711,   712,   713,   717,   721,   737,   738,   739,   740,
     741,   742,   743,   744,   745,   746,   747,   748,   749,   750,
     751,   761,   765,   769,   773,   777,   781,   785,   789,   793,
     800,   801,   811,   821,   831,   842,   852,   858,   867,   880,
     882,   882,   894,   897,   907,   918,   946,   958,   968,   971,
     975,   979,   983,   987,   991,   995,   999,  1028,  1027,  1031,
    1040,  1048,  1053,  1056,  1059,  1063,  1067,  1071,  1075,  1079,
    1109,  1108,  1115,  1123,  1130,  1147,  1153,  1154,  1155,  1160,
    1163,  1223,  1222,  1245,  1258,  1268,  1274,  1279,  1288,  1300,
    1301,  1305,  1312,  1316,  1345,  1352,  1351,  1369,  1375,  1378,
    1381,  1390,  1393,  1397,  1407,  1413,  1414,  1415,  1419,  1431,
    1432,  1433,  1437,  1441,  1456,  1474,  1475,  1479,  1483,  1490,
    1493,  1499,  1502,  1510,  1511,  1512,  1517,  1516,  1524,  1543,
    1544,  1552,  1566,  1569,  1582,  1585,  1589,  1603,  1606,  1612,
    1615,  1637,  1638,  1639,  1640,  1643,  1650,  1651,  1652,  1656,
    1663,  1667,  1674,  1675,  1676,  1683,  1684,  1685,  1689,  1690,
    1747,  1748,  1752,  1759,  1760,  1764,  1773,  1774,  1786,  1790,
    1795,  1804,  1811,  1812,  1816,  1828,  1834,  1840,  1850,  1854,
    1864,  1868,  1872,  1876,  1880,  1884,  1892,  1906,  1923,  1934,
    1945,  1962,  1979,  1992,  2015,  2033,  2034,  2049,  2059,  2075,
    2091,  2100,  2127,  2138,  2148,  2167,  2178,  2188,  2202,  2217,
    2232,  2247,  2257,  2262,  2267,  2272,  2279,  2280,  2287,  2288,
    2307,  2311,  2315,  2319,  2326,  2330,  2334,  2338,  2345,  2348,
    2358,  2363,  2368,  2373,  2378,  2383,  2393,  2398,  2403,  2408,
    2415,  2433,  2444,  2455,  2473,  2491,  2505,  2528,  2540,  2556,
    2565,  2566,  2570,  2574,  2575,  2582,  2590,  2591,  2603,  2603,
    2610,  2614,  2625,  2636,  2641,  2647,  2652,  2659,  2666,  2671,
    2676,  2682,  2689,  2696,  2702,  2705,  2708,  2719,  2748,  2755,
    2767,  2768,  2772,  2776,  2783,  2784,  2786,  2787,  2788,  2790,
    2791,  2792,  2793,  2797,  2798,  2801,  2804,  2822,  2840,  2848,
    2863,  2895,  2913,  2922,  2925,  2934,  2945,  2946,  2947,  2951,
    2952,  2953,  2954,  2965,  2966,  2967,  2979,  2982,  2988,  3004,
    3005,  3006,  3007,  3015,  3019,  3020,  3024,  3031,  3038,  3042,
    3046,  3047,  3052,  3070,  3076,  3083,  3084,  3091,  3117,  3127,
    3143,  3147,  3148,  3149,  3153,  3160,  3163,  3169,  3172,  3184,
    3189,  3194,  3204,  3211,  3218,  3228,  3229,  3236,  3244,  3245,
    3248,  3253,  3257,  3260,  3281,  3282,  3287,  3290,  3291,  3296,
    3303,  3306,  3312,  3315,  3321,  3336,  3347,  3348,  3359,  3360,
    3364,  3369,  3375,  3382,  3390,  3398,  3401,  3404,  3407,  3410,
    3413,  3416,  3422,  3423,  3424,  3428,  3431,  3439,  3447,  3455,
    3461,  3467,  3470,  3476,  3477,  3482,  3485,  3492,  3500,  3513,
    3516,  3528,  3529,  3530,  3531,  3532,  3547,  3548,  3549,  3553,
    3557,  3568,  3572,  3583,  3591,  3594,  3597,  3600,  3606,  3609,
    3616,  3619,  3625,  3626,  3634,  3693,  3713,  3720,  3736,  3741,
    3746,  3751,  3755,  3765,  3771,  3778,  3781,  3787,  3790,  3793,
    3796,  3802,  3805,  3808,  3814,  3815,  3821,  3824,  3827,  3833,
    3836,  3848,  3851,  3854,  3858,  3861,  3864,  3870,  3873,  3877,
    3878,  3879,  3886,  3887,  3888,  3894,  3895,  3904,  3916,  3917,
    3933,  3934,  3945,  3944,  3953,  3969,  3978,  3982,  3989,  3997,
    4000,  4005,  4012,  4011,  4026,  4029,  4033,  4036,  4039,  4043,
    4043,  4059,  4066,  4072,  4073,  4076,  4082,  4088,  4088,  4098,
    4101,  4104,  4108,  4111,  4114,  4117,  4123,  4124,  4130,  4134,
    4142,  4146,  4150,  4154,  4161,  4167,  4170,  4176,  4177,  4181,
    4185,  4189,  4189,  4202,  4205,  4212,  4217
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of input\"", "error", "\"invalid token\"", "PREC_BOT",
  "COMPOSITE", "':'", "'^'", "'_'", "'!'", "'\\''", "','", "PREC_TOP",
  "\"\\\\accepts\"", "\"\\\\addlyrics\"", "\"\\\\alias\"",
  "\"\\\\alternative\"", "\"\\\\book\"", "\"\\\\bookpart\"",
  "\"\\\\change\"", "\"\\\\chordmode\"", "\"\\\\chords\"",
  "\"\\\\consists\"", "\"\\\\context\"", "\"\\\\default\"",
  "\"\\\\defaultchild\"", "\"\\\\denies\"", "\"\\\\description\"",
  "\"\\\\drummode\"", "\"\\\\drums\"", "\"\\\\etc\"", "\"\\\\figuremode\"",
  "\"\\\\figures\"", "\"\\\\header\"", "\"\\\\version-error\"",
  "\"\\\\layout\"", "\"\\\\lyricmode\"", "\"\\\\lyrics\"",
  "\"\\\\lyricsto\"", "\"\\\\markup\"", "\"\\\\markuplist\"",
  "\"\\\\midi\"", "\"\\\\name\"", "\"\\\\notemode\"", "\"\\\\override\"",
  "\"\\\\paper\"", "\"\\\\remove\"", "\"\\\\repeat\"", "\"\\\\rest\"",
  "\"\\\\revert\"", "\"\\\\score\"", "\"\\\\score-lines\"",
  "\"\\\\sequential\"", "\"\\\\set\"", "\"\\\\simultaneous\"",
  "\"\\\\tempo\"", "\"\\\\type\"", "\"\\\\unset\"", "\"\\\\with\"",
  "\"\\\\new\"", "\"/+\"", "\"^\"", "\":\"", "\"-\"", "\"/\"", "\"<\"",
  "\">\"", "\"<<\"", "\">>\"", "\"\\\\\\\\\"", "\"\\\\!\"", "\"\\\\+\"",
  "\"__\"", "FIGURE_CLOSE", "FIGURE_OPEN", "\"_\"", "\"--\"",
  "MULTI_MEASURE_REST", "E_UNSIGNED", "UNSIGNED", "\"markup?\"",
  "\"scheme?\"", "\"(backed-up?)\"", "\"(reparsed?)\"", "\"markup-list?\"",
  "\"optional?\"", "EXPECT_NO_MORE_ARGS", "\"#{\"", "BOOK_IDENTIFIER",
  "CHORD_MODIFIER", "CHORD_REPETITION", "DRUM_PITCH", "DURATION_ARG",
  "DURATION_IDENTIFIER", "EVENT_IDENTIFIER", "EVENT_FUNCTION", "FRACTION",
  "LOOKUP_IDENTIFIER", "LYRIC_ELEMENT", "MARKUP_FUNCTION",
  "MARKUP_LIST_FUNCTION", "MARKUP_IDENTIFIER", "MARKUPLIST_IDENTIFIER",
  "MUSIC_FUNCTION", "MUSIC_IDENTIFIER", "NOTENAME_PITCH",
  "NUMBER_IDENTIFIER", "PITCH_IDENTIFIER", "REAL", "RESTNAME", "SCM_ARG",
  "SCM_FUNCTION", "SCM_IDENTIFIER", "SCM_TOKEN", "STRING", "SYMBOL_LIST",
  "TONICNAME_PITCH", "SYMBOL", "'-'", "'+'", "UNARY_MINUS", "'.'", "'{'",
  "'}'", "'='", "'*'", "']'", "'/'", "'['", "'?'", "$accept",
  "start_symbol", "$@1", "lilypond", "toplevel_expression", "lookup",
  "embedded_scm_bare", "embedded_scm_active", "embedded_scm_bare_arg",
  "embedded_scm", "embedded_scm_arg", "scm_function_call",
  "embedded_lilypond_number", "embedded_lilypond", "lilypond_header_body",
  "lilypond_header", "header_block", "$@2", "assignment_id", "assignment",
  "identifier_init", "identifier_init_nonumber",
  "partial_function_scriptable", "partial_function",
  "context_def_spec_block", "context_mod_arg", "$@3",
  "context_def_spec_body", "book_block", "book_body", "$@4",
  "bookpart_block", "bookpart_body", "$@5", "score_block", "score_body",
  "score_item", "score_items", "$@6", "paper_block", "output_def",
  "output_def_head", "output_def_head_with_mode_switch",
  "music_or_context_def", "output_def_body", "$@7", "tempo_event",
  "music_list", "braced_music_list", "music", "pitch_as_music",
  "music_embedded", "music_embedded_backup", "music_assign",
  "repeated_music", "sequential_music", "simultaneous_music",
  "simple_music", "context_modification", "$@8",
  "context_modification_arg", "optional_context_mods",
  "context_modification_mods_list", "context_mod_list", "context_prefix",
  "new_lyrics", "basic_music", "contextable_music",
  "contexted_basic_music", "composite_music", "music_bare",
  "grouped_music_list", "symbol_list_arg", "symbol_list_rev",
  "symbol_list_part", "symbol_list_element", "symbol_list_part_bare",
  "function_arglist_nonbackup", "reparsed_rhythm",
  "function_arglist_nonbackup_reparse", "function_arglist_backup",
  "function_arglist", "function_arglist_skip_nonbackup",
  "function_arglist_partial", "function_arglist_partial_optional",
  "function_arglist_common", "function_arglist_common_reparse",
  "function_arglist_optional", "function_arglist_skip_backup",
  "music_function_call", "optional_id", "lyric_mode_music", "$@9",
  "mode_changed_music", "mode_changing_head",
  "mode_changing_head_with_context", "context_change", "property_path",
  "property_operation", "revert_arg", "revert_arg_backup",
  "revert_arg_part", "context_def_mod", "context_mod", "grob_prop_spec",
  "grob_prop_path", "context_prop_spec", "simple_revert_context",
  "music_property_def", "string", "text", "simple_string", "symbol",
  "scalar", "event_chord", "note_chord_element", "chord_body",
  "chord_body_elements", "chord_body_element", "music_function_chord_body",
  "event_function_event", "post_events", "post_event_nofinger",
  "post_event", "string_number_event", "direction_less_event",
  "direction_reqd_event", "octave_check", "quotes", "erroneous_quotes",
  "sup_quotes", "sub_quotes", "steno_pitch", "steno_tonic_pitch", "pitch",
  "pitch_or_tonic_pitch", "gen_text_def", "fingering",
  "script_abbreviation", "script_dir", "maybe_notemode_duration",
  "optional_notemode_duration", "steno_duration", "duration", "dots",
  "multiplier_scm", "multipliers", "tremolo_type", "bass_number",
  "figured_bass_alteration", "bass_figure", "figured_bass_modification",
  "br_bass_figure", "figure_list", "optional_rest", "pitch_or_music",
  "simple_element", "lyric_element", "lyric_element_music", "new_chord",
  "chord_items", "chord_separator", "chord_item", "step_numbers",
  "step_number", "tempo_range", "number_expression", "number_term",
  "number_factor", "bare_number_common", "bare_number", "unsigned_number",
  "exclamations", "questions", "full_markup_list", "$@10", "markup_mode",
  "markup_mode_word", "full_markup", "partial_markup", "markup_top",
  "markup_scm", "$@11", "markup_list", "markup_uncomposed_list", "$@12",
  "markup_composed_list", "markup_braced_list", "markup_braced_list_body",
  "markup_command_list", "markup_command_embedded_lilypond", "$@13",
  "markup_command_basic_arguments", "markup_command_list_arguments",
  "markup_partial_function", "markup_arglist_partial",
  "markup_head_1_item", "markup_head_1_list", "markup_word",
  "simple_markup", "simple_markup_noword", "$@14", "markup", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,    58,    94,    95,    33,    39,
      44,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,    45,    43,   366,
      46,   123,   125,    61,    42,    93,    47,    91,    63
};
#endif

#define YYPACT_NINF (-623)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-593)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      22,  -623,   123,  1898,  1554,  -623,  -623,   -22,    53,  -623,
    -623,   830,  -623,  -623,  -623,  -623,  -623,  -623,  -623,  -623,
     900,  -623,  -623,  -623,  -623,  -623,   915,    63,    76,    76,
     830,  -623,  -623,   103,   263,  -623,   263,  -623,  -623,  -623,
    -623,  -623,  -623,  -623,  -623,  -623,  -623,   206,    34,  -623,
    -623,  -623,  -623,  -623,  -623,   170,  1177,  -623,  -623,  -623,
    -623,  4416,   269,  -623,  -623,  -623,  -623,  -623,  -623,   279,
    -623,  -623,  3807,   171,  -623,  -623,   240,   245,   245,   830,
     714,  1317,   694,   694,   694,    80,   694,   655,  -623,  -623,
    -623,  -623,    54,  -623,   229,    54,    54,  -623,  -623,   327,
    -623,  -623,   422,   439,  -623,   439,   246,    54,   656,  -623,
    -623,    97,   439,   100,    82,  -623,  -623,   128,  -623,  -623,
    -623,  -623,  -623,  -623,   324,  -623,  -623,  -623,  -623,  -623,
    -623,  -623,  -623,  3498,   275,   136,  -623,  -623,  -623,  -623,
    -623,  -623,  -623,  -623,    54,  -623,  -623,   137,  -623,  -623,
    -623,    54,  -623,  1013,  -623,  -623,  -623,   140,  -623,    54,
    -623,  -623,  -623,  -623,  4466,  -623,   141,  -623,   271,   290,
    -623,  -623,  -623,   239,   243,   267,   270,   295,   292,   527,
    -623,  -623,  -623,   214,  -623,  -623,  -623,   239,  2142,   694,
     668,   333,  -623,  -623,   336,  -623,  -623,   341,  -623,  1780,
     307,  -623,   694,  3385,  -623,  -623,  -623,  -623,  -623,  -623,
    4352,   177,   171,  -623,  -623,   269,  -623,  -623,  -623,  -623,
     420,  -623,   279,   379,  -623,  -623,   469,   566,  -623,  -623,
    -623,  -623,  -623,   361,  -623,  -623,  -623,  -623,  -623,  -623,
    3807,  -623,  -623,  3385,  -623,  -623,  -623,  -623,   351,  -623,
    -623,  -623,  -623,  -623,  -623,    75,  -623,  -623,  -623,   694,
     362,  -623,   694,    75,   366,  -623,  -623,  -623,  -623,    54,
     370,  -623,  -623,  -623,  -623,   338,  -623,  3839,  2055,  -623,
    -623,  -623,  -623,   344,  -623,  -623,   344,   712,   392,  -623,
    -623,   712,   416,  -623,  -623,  -623,  -623,   495,   498,  -623,
    -623,  -623,   712,   432,  -623,  -623,   229,  -623,  -623,  -623,
     694,   694,   263,  -623,  -623,   245,  -623,  -623,  -623,  -623,
    3776,  -623,  -623,   268,  -623,   571,   979,   514,  -623,  -623,
    -623,  -623,  -623,  -623,  -623,  -623,  -623,  -623,  -623,  -623,
    -623,  -623,  -623,  -623,  4466,  -623,   401,   959,  1068,  -623,
    1068,   595,   500,  4492,  -623,  1938,  -623,  2034,   915,  -623,
    -623,  -623,   279,   915,   452,   436,  -623,   527,  -623,  -623,
    -623,  4260,   143,  4160,  -623,  -623,  -623,  -623,    75,   466,
     386,  -623,  3272,   474,   724,  3919,  4394,  -623,  -623,    75,
     435,   165,   111,   112,   349,  -623,  -623,  -623,  -623,   114,
    -623,  -623,   365,  -623,   187,  -623,  -623,  -623,  -623,  -623,
    -623,   420,   295,  -623,  -623,  -623,   446,   450,   566,   566,
     566,  -623,  -623,   566,  -623,  -623,  3752,   497,  -623,  -623,
    -623,  -623,  -623,  -623,  -623,  -623,   915,  3934,   694,   694,
    -623,  3610,  -623,  -623,   501,  -623,  3722,   461,   214,  -623,
    -623,  -623,  -623,  -623,  -623,  -623,  -623,  -623,  -623,  -623,
    -623,  -623,  -623,  -623,  -623,  -623,   932,  -623,  -623,   659,
    -623,  -623,  1068,  -623,  1068,   712,   506,  -623,  2707,   802,
    2707,   802,  -623,  -623,  2707,   802,   467,   472,  1436,  1068,
    -623,  1068,   477,  -623,  -623,   477,  -623,  -623,   151,  -623,
     330,  -623,  1068,   794,   794,  -623,  -623,   595,  -623,  -623,
    -623,  -623,   206,  -623,  -623,  -623,  -623,  -623,  -623,  -623,
    -623,  -623,  -623,  -623,   206,  -623,  -623,  -623,  -623,  -623,
    -623,  -623,  -623,   295,   592,  -623,  -623,  -623,  -623,   206,
    -623,  -623,  -623,   821,  1050,  -623,  -623,  -623,  -623,  -623,
    -623,  -623,  -623,   373,  -623,  -623,  -623,  -623,  -623,  -623,
    -623,  -623,  -623,  -623,  -623,  -623,  -623,  -623,  -623,  -623,
    -623,  -623,  -623,  -623,   529,  2820,   605,  -623,  -623,   158,
    -623,  -623,  -623,  -623,  -623,  -623,  -623,  -623,  -623,  -623,
    -623,  -623,  -623,   871,  3385,  -623,   537,   266,  -623,   694,
     694,  1068,   266,   266,   266,   266,  -623,   295,  -623,  -623,
    -623,  2001,   527,  1036,  -623,  -623,  3807,  -623,  -623,  -623,
    -623,  -623,  -623,  -623,  -623,  -623,  -623,  -623,   694,  -623,
     694,  -623,   830,  -623,   270,  -623,  -623,  4508,  -623,  -623,
     819,  -623,   535,  -623,  -623,  -623,  -623,    50,  -623,   349,
    -623,  -623,   161,  -623,  -623,   210,  -623,  -623,    68,  -623,
    -623,   214,  -623,   543,  3959,  1068,   514,   659,  -623,  -623,
    -623,  -623,  -623,  -623,  -623,  -623,  -623,  -623,  -623,  2933,
     892,  -623,   712,   572,  2368,  -623,  -623,  2368,  -623,  2368,
    4060,  4060,  -623,  -623,   862,   439,  -623,    54,  -623,  -623,
    -623,  -623,  -623,   794,   639,  -623,  2001,  -623,  -623,  -623,
    -623,  -623,    76,  -623,   590,  2481,   649,  -623,  -623,  -623,
    -623,  -623,  -623,  -623,  -623,   724,  -623,  -623,  -623,  -623,
    -623,   393,  -623,  -623,  -623,  -623,  -623,  -623,  -623,   344,
     694,   694,  -623,  -623,  -623,  -623,  -623,  -623,  -623,  -623,
    -623,  -623,  -623,  -623,   146,   155,  -623,  -623,  -623,  -623,
    -623,  -623,  -623,   579,  1036,  -623,  -623,   559,  -623,  -623,
    -623,  -623,  -623,  -623,  4060,   712,   609,  -623,   694,   694,
     101,   124,   593,   708,  -623,  -623,   214,  -623,  -623,  -623,
     151,   614,  2255,  -623,  3046,   802,  -623,  -623,  -623,   349,
      58,  -623,  -623,  -623,   581,  -623,  -623,   439,  1036,  -623,
     821,  -623,  -623,  -623,  -623,  -623,  -623,  -623,   440,  -623,
    -623,  -623,  -623,  -623,  -623,  -623,  -623,  -623,  -623,   401,
      75,    75,  -623,  -623,  1667,  4060,  -623,   533,   894,  -623,
    -623,   712,   625,   712,   636,   455,   634,   694,   694,  -623,
    -623,  -623,   892,  2594,  -623,  -623,   645,  -623,   695,  -623,
    -623,  -623,  -623,  1068,   622,  -623,   694,   694,  -623,   667,
     533,   533,   894,   533,   894,   794,   455,  -623,  -623,  1068,
    -623,  -623,  -623,  -623,   633,   652,   894,   533,   533,  -623,
    1068,   533,   533,  3159
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       5,     3,     0,     0,     0,     1,     8,     0,     0,   336,
     340,     0,   334,   338,   335,   339,     9,   157,   337,   341,
       0,   554,   552,   156,   333,   155,     0,     0,     0,     0,
       0,   171,    13,    21,     0,   226,     0,    25,    18,    66,
      67,   171,     6,    27,    19,    26,    10,     0,     0,     7,
      11,    12,    14,    20,   158,     0,     0,   190,   212,   229,
     228,     0,   222,   223,    15,   213,   227,   211,   225,     0,
     202,    17,     0,   557,    16,    57,   479,   463,   462,     0,
       0,     0,     0,     0,     0,     0,     0,   196,   405,   420,
     500,   419,   465,   427,   471,   465,   465,   471,   429,     0,
      84,   511,     0,   436,   540,   436,   539,   465,     0,    24,
      23,   510,   436,   509,   464,    43,    41,   184,    42,    53,
       4,    76,    52,   100,     0,    81,    78,    79,    77,    80,
     400,   179,   177,     0,   181,   175,   185,    89,   186,   195,
     194,    85,   193,   401,   465,   431,   425,   180,   428,   417,
     446,   465,   548,   107,   475,   415,   430,   178,   415,   465,
     176,   415,    49,    88,     0,   557,   508,    87,   117,   131,
     386,   387,   388,   326,   383,   384,   385,   328,     0,     0,
     383,   384,   385,     0,   149,   189,   191,   326,     0,     0,
       0,     0,   298,   286,     0,   325,   242,     0,    47,     0,
       0,    65,     0,    64,   161,   167,   164,   154,   163,   162,
       0,     0,     0,   217,   216,   220,   221,   218,   178,   202,
     224,   331,     0,   201,   601,   569,     0,     0,   597,   598,
     573,   562,   556,     0,   559,   565,   564,   566,   567,   595,
       0,   555,   561,    64,   480,   454,   423,   424,     0,   112,
      58,   239,   238,   240,   237,   367,   233,   241,   236,   368,
       0,   371,     0,   370,     0,   471,   379,   380,   382,   170,
       0,   381,   375,   200,   199,     0,   198,     0,     0,   467,
     415,   466,    50,   468,   415,   506,   469,     0,     0,   414,
      92,     0,     0,    91,   440,   442,   444,   438,   437,   447,
     541,   507,     0,     0,    93,   445,   454,    48,   426,    90,
       0,     0,     0,   510,   509,   464,   184,   171,   175,   180,
       0,   415,   508,     0,   415,   513,     0,   550,   455,   461,
     458,   459,   451,   452,   457,   456,   460,   453,   106,   418,
     422,   421,   432,   433,     0,   450,   470,   183,   397,   415,
     505,     0,     0,     0,   118,     0,   132,     0,     0,   202,
     330,   214,     0,     0,     0,     0,   553,     0,   545,   546,
     547,     0,     0,   144,   202,   173,   192,   172,    22,     0,
     320,   265,    64,     0,     0,     0,     0,   174,    59,   343,
       0,   543,   376,   377,   464,    86,    68,    71,    82,     0,
     415,    83,    72,   533,   534,   542,   538,   378,   160,   166,
     159,   219,   328,   202,   332,   203,     0,     0,     0,     0,
       0,   585,   603,     0,   586,   576,     0,     0,   604,   568,
     571,   596,   599,   560,   600,    70,     0,   110,     0,     0,
     369,    64,   350,   373,     0,   349,    64,     0,     0,   204,
     403,   415,   412,   413,   411,   406,   409,   410,   449,   448,
     548,   404,   489,   481,   482,   483,     0,   485,   490,   498,
     501,   484,   399,   472,   398,     0,     0,   291,    64,     0,
      64,     0,   441,   443,    64,     0,     0,     0,     0,   183,
     182,   402,     0,   518,   517,     0,   515,   549,   434,   105,
       0,   416,   512,     0,     0,   588,   558,     0,   129,   125,
     116,   126,     0,   120,   121,   119,   153,   122,   124,   123,
     142,   138,   130,   139,     0,   134,   133,   135,   137,   136,
     327,   207,   329,   328,   187,   145,   143,   146,   150,     0,
     148,   147,   208,     0,     0,   316,   317,    30,    28,   310,
      29,   313,   314,   464,    40,    44,   299,    45,    34,    36,
      37,    38,    35,    39,    46,    33,   301,   312,   311,   300,
      32,   315,    31,   322,     0,    64,     0,   471,   253,   230,
     255,   251,   250,   249,   254,   252,   303,   309,   308,   307,
     305,   304,   306,     0,    64,   544,   543,     0,   537,     0,
       0,    75,     0,     0,     0,     0,   209,   328,   149,   149,
     594,     0,     0,     0,   572,   575,     0,   606,   574,   563,
     342,   356,   359,   354,   357,   358,   361,   362,     0,   355,
       0,   360,     0,   108,    41,   109,   115,     0,   114,   363,
       0,   113,     0,   235,   234,   463,   462,     0,   391,   464,
     389,   103,     0,   394,   372,   107,   390,   392,     0,   104,
     374,     0,   168,   529,   110,   408,   550,   499,   488,   497,
     495,   494,   486,   487,   491,   496,   492,   493,   295,    64,
       0,    95,     0,     0,    64,   293,    94,    64,    96,    64,
      64,    64,   520,   519,   514,   436,   551,   465,   476,   477,
     473,   474,   478,     0,   594,   590,   593,   591,   589,   128,
     141,   215,     0,   152,     0,   323,   324,   285,   284,   283,
     281,   282,   318,   302,   319,     0,   263,   264,   257,   260,
     261,   464,   247,   243,   259,   258,   248,   262,   287,   475,
       0,     0,    61,    63,    62,    60,    69,    74,    73,   532,
     531,   535,   536,   210,     0,     0,   583,   584,   577,   580,
     582,   581,   579,     0,     0,   587,   605,     0,   347,   345,
     111,   364,   365,   366,    64,     0,     0,   393,     0,     0,
       0,     0,     0,     0,   348,   169,     0,   197,   206,   205,
     434,     0,   323,   297,    64,     0,    98,    97,    99,     0,
     526,   523,   521,   516,   522,   524,   435,   436,   592,   188,
       0,   271,   277,   273,   272,   278,   279,   280,   464,   266,
     267,   269,   268,   270,   321,   289,   244,   246,   245,   415,
     232,   231,   602,   570,     0,    64,   344,   290,     0,   396,
     395,     0,     0,     0,     0,     0,     0,     0,     0,   353,
     530,   415,     0,    64,   528,   527,     0,   439,   502,   324,
     274,   276,   275,   256,     0,   346,     0,     0,   464,     0,
     292,   290,     0,   290,     0,     0,     0,   352,   351,   407,
     525,   503,   415,   578,     0,     0,     0,   292,   292,   593,
     504,   101,   102,    64
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -623,  -623,  -623,  -623,  -623,     6,   217,   -28,  -623,   430,
     318,    19,   648,   -73,  -623,  -345,    -1,  -623,  -623,   -27,
    -191,  -157,  -117,   424,     3,   115,  -623,  -623,     8,  -623,
    -623,    17,  -623,  -623,    12,   -52,  -623,  -623,  -623,   421,
       2,  -623,  -623,  -623,  -623,  -623,  -623,    38,    13,  -228,
     720,   -57,  -623,    26,  -623,  -623,  -623,  -623,    21,  -623,
    -623,  -118,  -623,  -623,  -623,   567,   726,  -623,   738,    32,
    -623,   -21,  -323,    29,    -9,  -623,  -170,    89,  -341,  -623,
    -482,    56,  -622,   -42,  -426,  -139,  -623,  -177,  -408,   -47,
     615,  -300,  -623,  -520,  -623,  -623,  -623,  -190,  -623,  -297,
    -623,  -623,  -623,   148,  -623,  -293,   -72,  -623,  -623,  -369,
    -623,    33,    99,  -382,   740,  -623,  -623,  -623,  -623,  -623,
    -623,  -114,   179,    28,  -623,   -59,  -623,    25,   -81,  -623,
    -623,  -623,  -623,   265,   310,  -623,  -623,   523,  -623,    46,
    -128,   350,    11,     0,   -54,  -623,    83,  -623,  -623,  -623,
     357,  -623,  -623,  -623,  -623,     9,  -623,  -623,   -36,  -623,
    -623,   159,  -623,  -623,    -4,   195,  -623,    59,  -289,    35,
    -158,  -164,   404,   209,    23,  -623,   815,    31,    -3,    14,
    -623,   -53,  -623,  -142,  -184,  -623,  -623,  -623,  -623,  -623,
    -623,  -623,  -161,  -365,   697,  -436,  -202,   -62,    -2,  -200,
      16,  -623,   463
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     2,     4,     3,    42,   115,   116,    44,   555,   231,
     556,   118,   119,   120,   593,   201,   558,    47,    48,    49,
     396,   122,   123,   124,   559,   636,   637,   437,   560,   355,
     512,   561,   357,   524,   562,   372,   538,   373,   539,   515,
     563,    54,    55,   409,    56,   210,   130,   188,    57,   131,
     132,   133,   134,   564,    58,    59,    60,   136,   565,   275,
     276,   222,   223,   664,    61,   220,    62,   215,    63,   138,
      65,    66,   580,   389,   256,   257,   258,   193,   581,   194,
     380,   195,   576,   685,   477,   196,   197,   382,   383,    67,
     359,   361,   362,    68,    69,    70,   139,   390,   639,   443,
     444,   445,   640,   641,   259,   260,   264,   262,   140,   141,
     269,   177,   173,   654,   142,   143,   144,   277,   455,   456,
     145,   347,   146,   501,   148,   149,   341,   697,   296,   858,
     297,   298,   150,   151,   152,   460,   342,   308,   343,   320,
     279,   280,   154,   281,   283,   702,   346,   156,   468,   676,
     469,   677,   470,   278,   882,   218,   158,   159,   160,   161,
     694,   496,   803,   804,   805,   662,   402,   403,   404,   405,
     406,   663,   327,   498,   570,   179,   164,   165,   322,   572,
     232,   233,   427,   234,   235,   417,   236,   237,   426,   238,
     761,   834,   424,   425,   499,   505,   239,   353,   432,   617,
     434,   416,   765
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      74,   166,    46,   121,   155,    53,   129,   125,   250,    43,
     240,    50,   126,   157,   272,    52,   128,   486,   167,   371,
      51,   127,    45,   325,   299,   137,    71,   163,   208,   209,
     135,   305,   147,   399,    73,    64,   338,   366,   431,   162,
     433,   185,   186,   286,   348,   588,   397,   350,   221,   678,
     153,   381,   435,   610,   611,   612,   430,   290,   613,   183,
     293,   715,    43,   587,   660,   422,   304,   705,   707,   440,
     241,   708,   653,   399,   261,    45,   317,   653,   166,   199,
     121,   155,   271,   129,   125,   438,   397,   212,   242,   126,
     157,   760,   198,   128,   340,   167,   270,  -376,   127,   168,
    -377,   412,   137,   825,   163,   598,   339,   135,     1,   147,
     478,   255,   606,   263,   480,   263,   162,   367,    21,   178,
     854,  -238,  -240,     5,   599,   484,   365,   153,   -86,   187,
     775,   377,   265,   321,   776,   716,   -82,   -54,   704,   706,
     -83,  -378,   377,   534,   535,   541,    97,   535,   381,   162,
     345,   431,   381,   433,   202,   289,   535,   203,   265,   318,
     306,   319,   241,   381,   198,   431,   472,   709,   740,   430,
     474,   778,    97,   825,   169,  -239,   855,   783,   248,   710,
     242,   841,   579,   430,   184,   842,   760,   104,   321,   106,
     422,   109,   110,   266,   713,   439,   267,    41,   792,   321,
     407,   414,   121,   718,   843,   129,   125,   489,   844,   241,
     491,   126,   401,   408,   318,   128,   319,   167,   378,  -376,
     127,   717,  -377,   189,   137,   318,   163,   319,   172,   398,
     454,  -238,  -240,   711,   600,   502,   410,   176,   200,   487,
     407,   531,   121,   182,   415,   129,   125,   172,    21,   153,
     -86,   126,   401,   442,   793,   128,   542,   167,   -82,   -54,
     127,   340,   -83,  -378,   137,   536,   163,   705,   832,   398,
     595,   652,   716,   339,   695,   471,   652,   833,   741,   696,
     447,   779,   219,   657,   615,  -239,   601,   490,   657,   153,
     228,   204,   368,   229,   243,   607,   172,   172,   679,   254,
     254,   254,   268,   254,   647,   457,    21,   753,   598,   660,
      33,   604,   780,   605,   365,   751,   752,   345,   244,   369,
     781,   653,   653,   245,    36,   109,   110,   511,   715,   523,
      28,   767,    29,   768,   282,   784,   381,   665,   808,   255,
     263,   532,   241,   190,   596,    31,   422,   191,   192,   584,
     591,   300,   519,   309,   529,   488,   323,   516,   354,   516,
     242,    43,   358,    43,   616,   101,  -386,   514,   289,   525,
     792,   104,   513,   106,    45,   540,    45,   356,   518,   571,
     528,   313,   400,   597,   314,   582,   589,   517,   554,   527,
    -387,   530,   836,  -388,   583,   590,   533,   318,   360,   318,
      41,   557,   859,   746,   381,   653,   254,   287,   698,   747,
     748,   288,   192,   384,   431,   363,   766,   569,   385,   254,
     585,   592,   400,   386,   399,   699,   793,   596,   388,   643,
     644,   377,   430,   413,   117,   700,    87,   397,   407,   707,
     708,   109,   110,   407,   859,   284,   285,   554,   294,   295,
     656,   722,   554,   865,   104,   656,   106,   301,   638,   449,
     557,   428,   429,   471,   473,   557,   653,  -323,   544,   620,
     762,   826,   479,   575,   436,   571,   254,   571,   723,   254,
     724,   571,   602,   603,   554,   441,   554,   655,   321,   446,
     554,   777,   655,   448,   324,   467,   481,   557,   827,   557,
     828,   326,   291,   557,   482,   794,   292,   192,   483,   349,
     889,   117,   485,   569,   318,   569,   319,   274,   860,   569,
     652,   652,   497,   739,   153,   500,   153,   254,   254,   506,
     153,   418,   657,   657,   503,   875,   642,   429,   338,   645,
     646,   381,   458,   381,   719,   861,   543,   862,   418,   419,
     367,   764,   420,   720,   421,   573,   754,   755,   594,   365,
     763,   566,   431,   316,   766,   744,   745,   608,   684,   807,
     687,   609,   737,   884,   689,   182,   866,   225,   619,   721,
     182,   554,   658,   337,   661,   867,   680,   459,   839,   840,
     690,   407,   112,   121,   557,   691,   129,   125,   837,    43,
     246,   247,   126,   401,   652,   290,   128,   712,   167,   725,
     736,   127,    45,   370,   806,   137,   657,   163,   316,   442,
     398,   442,   850,    33,   212,   364,   227,   647,   738,   316,
    -467,  -467,  -467,   395,  -467,   780,   381,    36,   109,   110,
     153,   777,   595,   781,   431,   423,   419,   567,   230,   420,
     868,   421,   795,   182,   634,   254,   254,   566,   774,   566,
     786,   749,   750,   566,   871,   652,   873,   668,  -592,   770,
     810,   381,   824,   395,   503,   504,   571,   657,   420,   428,
     421,   737,   835,   467,   737,   554,   737,   407,   407,   838,
     554,   845,   568,   554,   852,   554,   554,   554,   557,   656,
     656,   856,   381,   557,   381,   872,   557,   453,   557,   557,
     557,   763,   823,   381,   569,   863,   874,   701,   847,   736,
     846,   554,   736,   800,   736,   809,   857,   669,   670,   671,
     153,   769,   876,   153,   557,   153,   302,   879,   293,   304,
     303,   192,   881,   567,   883,   567,   764,   886,   190,   567,
     337,    33,   379,   192,   733,   763,   891,   692,   273,   650,
     693,   864,   307,   642,   650,    36,   109,   110,   890,   830,
     831,   407,   251,   400,   849,   892,   672,   673,   526,   788,
     554,   213,   411,   656,   674,   675,   251,   214,   568,   823,
     568,   571,   475,   557,   568,   885,   476,   192,   554,   216,
     554,   217,   374,   537,   190,   109,   110,   252,   574,   192,
     253,   557,   789,   557,   575,   851,   254,   254,    72,   109,
     110,   252,   829,   667,   253,   109,   110,   170,   848,   569,
     171,   166,   407,   121,   155,   249,   129,   125,   877,   878,
     734,   554,   126,   157,   656,   254,   128,   254,   167,   172,
     737,   127,   880,   802,   557,   137,   785,   163,   566,   554,
     135,   352,   147,   733,   666,   651,   733,   635,   733,   162,
     659,   211,   557,   703,   504,   790,     0,   420,   370,   421,
     153,   634,   682,   655,   853,   735,   683,   192,   736,   618,
     737,     0,     0,   732,   820,   255,   263,     0,     0,   554,
      72,   190,   681,     0,   686,   714,   192,     0,   688,    21,
       0,     0,   557,     0,     0,    33,   655,   655,   316,   655,
       0,   492,   493,   494,     0,   495,     0,   870,   736,    36,
     109,   110,   771,   655,   655,   772,     0,   655,   655,     0,
     800,   109,   110,   170,   567,     0,   171,     0,    72,   734,
     801,     0,   734,     0,   734,     0,     0,   254,   254,   -55,
       0,   887,     0,   888,    76,    77,    78,    33,   344,     0,
      21,   820,   475,   566,   682,   893,   791,   192,   869,   192,
     821,    36,    37,   742,    39,     0,     0,    40,     0,   568,
       0,     0,     0,   743,   735,   254,   254,   735,     0,   735,
     254,     0,   732,    72,     0,   732,   462,   732,   650,   650,
     463,   109,   110,   174,    72,     0,   175,     0,    76,   328,
     329,   330,     0,     0,   395,   822,   109,   110,   180,     0,
      89,   181,   733,   819,    91,     0,    93,     0,   492,   493,
     494,   759,   495,   109,   110,   464,     0,     0,   465,     0,
       0,    21,    98,   312,     0,     0,     0,   821,     0,   567,
       0,     0,     0,     0,   254,   254,     0,     0,     0,     0,
     773,     0,   733,    76,    77,    78,   315,     0,   331,     0,
       0,   -55,     0,   254,   254,   224,     0,     0,     0,     0,
      93,   370,   650,    72,   635,     0,     0,     0,     0,     0,
       0,     0,   822,     0,   568,     0,    98,    99,   796,    33,
     819,   797,     0,   798,     0,   102,     0,     0,   734,     0,
       0,     0,     0,   108,   109,   110,   332,     0,   265,   333,
     334,   335,    33,   336,   226,    72,   759,     0,    72,    89,
       0,   577,    97,    91,     0,    93,    36,   109,   110,   228,
       0,     0,   229,   650,   103,   104,   105,   106,   734,     0,
       0,    98,   312,   735,   579,   112,     0,     0,     0,     0,
      72,   732,    72,     0,     0,     0,     0,     0,   205,     0,
       0,     0,     0,     0,     0,   315,    72,     0,    72,     0,
       0,     0,     0,     0,     0,  -165,  -165,  -165,     0,  -165,
      72,    72,     0,   735,  -165,  -165,     0,  -165,  -165,     0,
       0,   732,  -165,  -165,  -165,    21,   370,     0,     0,  -165,
    -165,     0,     0,  -165,     0,  -165,     0,     0,  -165,  -165,
    -165,  -165,     0,  -165,     0,  -165,     0,     0,     0,     0,
       0,  -165,     0,  -165,     0,     0,     0,     0,     0,     0,
    -165,     0,     0,  -165,     0,     0,     0,     0,     0,     0,
       0,   681,     0,     0,   117,     0,  -165,  -165,     0,     0,
       0,     0,     0,    33,     0,     0,     0,     0,     0,  -165,
    -165,    72,     0,     0,     0,  -165,     0,    36,    37,   206,
      39,     0,     0,    40,   796,   686,     0,   688,  -165,   207,
       0,     0,     0,    72,     0,     0,     0,     0,     0,     0,
       0,   797,   798,     0,     0,   651,   659,   -51,    75,     0,
       0,     0,    76,    77,    78,     0,     0,     0,     0,     0,
       0,     0,     0,     7,     8,    79,     9,    10,     0,    80,
       0,     0,     0,     0,    12,    13,     0,    14,    15,   -64,
      81,    17,    18,    19,    20,    21,    22,    23,     0,    24,
      82,    25,     0,    26,     0,    83,    27,     0,    28,    84,
      29,    85,     0,    86,    87,    30,     0,     0,     0,     0,
       0,    88,     0,    31,     0,     0,     0,     0,    89,     0,
      90,     0,    91,    92,    93,    94,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    95,    96,   211,    97,
      98,    99,   100,    33,   101,     0,     0,     0,     0,   102,
      35,   103,   104,   105,   106,   107,     0,   108,   109,   110,
     111,     0,   112,   113,   114,     0,   -56,   375,    41,   -51,
       0,    76,    77,    78,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    79,     9,    10,     0,    11,     0,
       0,     0,     0,    12,    13,     0,    14,    15,     0,     0,
     782,    18,    19,    20,    21,     0,     0,     0,    24,   310,
       0,     0,    26,     0,    83,     0,     0,    28,   311,    29,
      85,     0,    86,     0,    30,     0,     0,     0,     0,     0,
      88,     0,    31,     0,     0,     0,     0,    89,     0,    90,
       0,    91,    92,    93,   265,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    95,    96,     0,    97,    98,
     312,     0,    33,   101,     0,     0,     0,     0,    34,    35,
     103,     0,   105,     0,   107,     0,    36,   109,   110,   313,
       0,   112,   314,   315,   -51,    75,     0,    41,   -56,    76,
      77,    78,     0,     0,     0,     0,     0,     0,     0,     0,
       7,     8,    79,     9,    10,     0,    80,     0,     0,     0,
       0,    12,    13,     0,    14,    15,   -64,    81,    17,    18,
      19,    20,    21,    22,    23,     0,    24,    82,    25,     0,
      26,     0,    83,    27,     0,    28,    84,    29,    85,     0,
      86,    87,    30,     0,     0,     0,     0,     0,    88,     0,
      31,     0,     0,     0,     0,    89,     0,    90,     0,    91,
      92,    93,    94,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    95,    96,     0,    97,    98,    99,   100,
      33,   101,     0,     0,     0,     0,   102,    35,   103,   104,
     105,   106,   107,     0,   108,   109,   110,   111,    75,   112,
     113,   114,    76,    77,    78,    41,     0,     0,     0,     0,
       0,     0,     0,     7,     8,    79,     9,    10,     0,    80,
       0,     0,     0,     0,    12,    13,     0,    14,    15,   -64,
      81,    17,    18,    19,    20,    21,    22,    23,     0,    24,
      82,    25,     0,    26,     0,    83,    27,     0,    28,    84,
      29,    85,     0,    86,    87,    30,     0,     0,     0,     0,
       0,    88,     0,    31,     0,     0,     0,     0,    89,     0,
      90,     0,    91,    92,    93,    94,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    95,    96,     0,    97,
      98,    99,   100,    33,   101,     0,     0,     0,     0,   102,
      35,   103,   104,   105,   106,   107,     0,   108,   109,   110,
     111,   375,   112,   113,   114,    76,    77,    78,    41,   -51,
       0,     0,     0,     0,     0,     0,     0,     0,    79,     9,
      10,     0,    11,     0,     0,     0,     0,    12,    13,     0,
      14,    15,     0,     0,     0,    18,    19,    20,    21,     0,
       0,     0,    24,   310,     0,     0,    26,     0,    83,     0,
       0,    28,   311,    29,    85,     0,    86,     0,    30,     0,
       0,     0,     0,     0,    88,     0,    31,     0,     0,     0,
       0,    89,     0,    90,     0,    91,    92,    93,   265,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    95,
      96,     0,    97,    98,   312,     0,    33,   101,     0,     0,
       0,     0,    34,    35,   103,     0,   105,     0,   107,     0,
      36,   109,   110,   313,     0,   112,   314,   315,    -2,     6,
       0,    41,   387,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     7,     8,     0,     9,    10,     0,
      11,     0,     0,     0,     0,    12,    13,     0,    14,    15,
     -64,    16,    17,    18,    19,    20,    21,    22,    23,   508,
      24,     0,    25,     0,    26,     0,     0,    27,     0,    28,
       0,    29,     0,     0,     0,     8,    30,     9,    10,     0,
      11,     0,     0,     0,    31,    12,    13,     0,    14,    15,
    -127,     0,    17,    18,    19,    20,    21,    22,    23,     0,
      24,     0,    25,     0,    26,    32,     0,    27,     0,    28,
       0,    29,     0,     0,    33,     0,    30,     0,     0,     0,
      34,    35,     0,     0,    31,     0,     0,     0,    36,    37,
      38,    39,     0,     0,    40,     0,     0,     0,     0,    41,
       9,    10,     0,     0,     0,     0,     0,     0,    12,    13,
       0,    14,    15,     0,    33,   520,    18,    19,     0,     0,
      34,    35,     0,    24,     0,     0,     0,     0,    36,    37,
     509,     0,     0,     9,    10,     0,    11,     0,     0,    41,
     510,    12,    13,     0,    14,    15,  -140,     0,    17,    18,
      19,    20,    21,    22,    23,     0,    24,     0,    25,     0,
      26,     0,     0,    27,     0,    28,     0,    29,     0,     0,
       0,     0,    30,    21,     0,     0,     0,    33,     0,     0,
      31,     0,     0,     0,   756,     0,     0,     0,     0,     0,
       0,    36,   109,   110,   757,     0,     0,     0,     0,     0,
       0,     0,   758,     0,     0,     0,     0,   461,     0,   462,
      33,     0,     0,   463,     0,     0,    34,    35,     0,     0,
       0,     0,     0,   375,    36,    37,   521,    76,    77,    78,
       0,     0,     0,     0,     0,    41,   522,     0,     0,     0,
      79,     9,    10,     0,    11,     0,   109,   110,   464,    12,
      13,   465,    14,    15,     0,     0,     0,    18,    19,    20,
      21,     0,   466,     0,    24,   310,     0,     0,    26,     0,
      83,     0,     0,    28,   311,    29,    85,     0,    86,     0,
      30,     0,     0,     0,     0,     0,    88,     0,    31,   376,
       0,     0,     0,    89,     0,    90,     0,    91,    92,    93,
     265,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    95,    96,     0,    97,    98,   312,     0,    33,   101,
       0,     0,     0,     0,    34,    35,   103,     0,   105,     0,
     107,     0,    36,   109,   110,   313,     0,   112,   314,   315,
      76,    77,    78,    41,     0,     0,     0,     0,     0,     0,
       0,     7,     8,    79,     9,    10,     0,    80,     0,     0,
       0,     0,    12,    13,  -296,    14,    15,   -64,     0,    17,
      18,    19,    20,    21,    22,    23,     0,    24,   310,    25,
       0,    26,     0,    83,    27,     0,    28,   311,    29,    85,
       0,    86,    87,    30,     0,     0,     0,     0,     0,    88,
       0,    31,     0,     0,     0,     0,    89,     0,    90,     0,
      91,    92,    93,   811,     0,     0,     0,   544,     0,     0,
       0,     0,     0,     0,    95,    96,     0,   812,    98,   312,
     547,    33,     0,     0,     0,     0,     0,    34,    35,   103,
     813,   105,   814,   107,   548,    36,   815,   550,   816,     0,
     112,   817,   818,    76,    77,    78,    41,     0,     0,     0,
       0,     0,     0,     0,     7,     8,    79,     9,    10,     0,
      80,  -288,     0,     0,     0,    12,    13,  -292,    14,    15,
       0,     0,    17,    18,    19,    20,    21,    22,    23,     0,
      24,    82,    25,     0,    26,     0,    83,    27,     0,    28,
      84,    29,    85,     0,    86,    87,    30,     0,     0,     0,
       0,     0,    88,     0,    31,     0,     0,     0,     0,    89,
       0,    90,     0,    91,    92,    93,   726,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    95,    96,     0,
     727,    98,    99,   547,    33,     0,     0,     0,     0,     0,
     102,    35,   103,   104,   105,   106,   107,   548,   108,   728,
     550,   729,     0,   112,   730,   731,    76,    77,    78,    41,
       0,     0,     0,     0,     0,     0,     0,     7,     8,    79,
       9,    10,     0,    80,     0,     0,     0,     0,    12,    13,
       0,    14,    15,   -64,     0,    17,    18,    19,    20,    21,
      22,    23,     0,    24,   310,    25,     0,    26,     0,    83,
      27,     0,    28,   311,    29,    85,     0,    86,    87,    30,
       0,     0,     0,     0,     0,    88,     0,    31,     0,     0,
       0,     0,    89,     0,    90,     0,    91,    92,    93,   811,
       0,     0,     0,   544,     0,     0,     0,     0,     0,     0,
      95,    96,     0,   812,    98,   312,   547,    33,     0,     0,
       0,     0,     0,    34,    35,   103,   813,   105,   814,   107,
     548,    36,   815,   550,   816,     0,   112,   817,   818,    76,
      77,    78,    41,     0,     0,     0,     0,     0,     0,     0,
       7,     8,    79,     9,    10,     0,    80,  -288,     0,     0,
       0,    12,    13,  -292,    14,    15,     0,     0,    17,    18,
      19,    20,    21,    22,    23,     0,    24,   310,    25,     0,
      26,     0,    83,    27,     0,    28,   311,    29,    85,     0,
      86,    87,    30,     0,     0,     0,     0,     0,    88,     0,
      31,     0,     0,     0,     0,    89,     0,    90,     0,    91,
      92,    93,   726,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    95,    96,     0,   727,    98,   312,   547,
      33,     0,     0,     0,     0,     0,    34,    35,   103,   104,
     105,   106,   107,   548,    36,   728,   550,   729,     0,   112,
     730,   731,    76,    77,    78,    41,     0,     0,     0,     0,
       0,     0,     0,     7,     8,    79,     9,    10,     0,    80,
       0,     0,     0,     0,    12,    13,  -290,    14,    15,     0,
       0,    17,    18,    19,    20,    21,    22,    23,     0,    24,
      82,    25,     0,    26,     0,    83,    27,     0,    28,    84,
      29,    85,     0,    86,    87,    30,     0,     0,     0,     0,
       0,    88,     0,    31,     0,     0,     0,     0,    89,     0,
      90,     0,    91,    92,    93,   545,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    95,    96,     0,   546,
      98,    99,   547,    33,     0,     0,     0,     0,     0,   102,
      35,   103,   104,   105,   106,   107,   548,   108,   549,   550,
     551,     0,   112,   552,   553,    76,    77,    78,    41,     0,
       0,     0,     0,     0,     0,     0,     7,     8,    79,     9,
      10,     0,    80,  -288,     0,     0,     0,    12,    13,     0,
      14,    15,     0,     0,    17,    18,    19,    20,    21,    22,
      23,     0,    24,   310,    25,     0,    26,     0,    83,    27,
       0,    28,   311,    29,    85,     0,    86,    87,    30,     0,
       0,     0,     0,     0,    88,     0,    31,     0,     0,     0,
       0,    89,     0,    90,     0,    91,    92,    93,   726,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    95,
      96,     0,   727,    98,   312,   547,    33,     0,     0,     0,
       0,     0,    34,    35,   103,   104,   105,   106,   107,   548,
      36,   728,   550,   729,     0,   112,   730,   731,    76,    77,
      78,    41,     0,     0,     0,     0,     0,     0,     0,     7,
       8,    79,     9,    10,     0,    80,     0,     0,     0,     0,
      12,    13,  -294,    14,    15,     0,     0,    17,    18,    19,
      20,    21,    22,    23,     0,    24,   310,    25,     0,    26,
       0,    83,    27,     0,    28,   311,    29,    85,     0,    86,
      87,    30,     0,     0,     0,     0,     0,    88,     0,    31,
       0,     0,     0,     0,    89,     0,    90,     0,    91,    92,
      93,   545,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    95,    96,     0,   546,    98,   312,   547,    33,
       0,     0,     0,     0,     0,    34,    35,   103,   104,   105,
     106,   107,   548,    36,   549,   550,   551,     0,   112,   552,
     553,    76,    77,    78,    41,     0,     0,     0,     0,     0,
       0,     0,     7,     8,    79,     9,    10,     0,    80,     0,
       0,     0,     0,    12,    13,  -290,    14,    15,     0,     0,
      17,    18,    19,    20,    21,    22,    23,     0,    24,   310,
      25,     0,    26,     0,    83,    27,     0,    28,   311,    29,
      85,     0,    86,    87,    30,     0,     0,     0,     0,     0,
      88,     0,    31,     0,     0,     0,     0,    89,     0,    90,
       0,    91,    92,    93,   545,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    95,    96,     0,   546,    98,
     312,   547,    33,     0,     0,     0,     0,     0,    34,    35,
     103,   104,   105,   106,   107,   548,    36,   549,   550,   551,
       0,   112,   552,   553,    76,    77,    78,    41,     0,     0,
       0,     0,     0,     0,     0,     7,     8,    79,     9,    10,
       0,    80,     0,     0,     0,     0,    12,    13,  -292,    14,
      15,     0,     0,    17,    18,    19,    20,    21,    22,    23,
       0,    24,   310,    25,     0,    26,     0,    83,    27,     0,
      28,   311,    29,    85,     0,    86,    87,    30,     0,     0,
       0,     0,     0,    88,     0,    31,     0,     0,     0,     0,
      89,     0,    90,     0,    91,    92,    93,   726,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    95,    96,
       0,   727,    98,   312,   547,    33,     0,     0,     0,     0,
       0,    34,    35,   103,   104,   105,   106,   107,   548,    36,
     728,   550,   729,     0,   112,   730,   731,    76,    77,    78,
      41,     0,     0,     0,     0,     0,     0,     0,     7,     8,
      79,     9,    10,     0,    80,     0,     0,     0,     0,    12,
      13,     0,    14,    15,     0,     0,    17,    18,    19,    20,
      21,    22,    23,     0,    24,   310,    25,     0,    26,     0,
      83,    27,     0,    28,   311,    29,    85,     0,    86,    87,
      30,     0,     0,     0,     0,     0,    88,     0,    31,     0,
       0,     0,     0,    89,     0,    90,     0,    91,    92,    93,
     545,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    95,    96,     0,   546,    98,   312,   547,    33,     0,
       0,     0,     0,     0,    34,    35,   103,   104,   105,   106,
     107,   548,    36,   549,   550,   551,     0,   112,   552,   553,
      76,    77,    78,    41,     0,     0,     0,     0,     0,     0,
       0,     7,     8,    79,     9,    10,     0,    80,     0,     0,
       0,     0,    12,    13,     0,    14,    15,     0,     0,    17,
      18,    19,    20,    21,    22,    23,     0,    24,    82,    25,
       0,    26,     0,    83,    27,     0,    28,    84,    29,    85,
       0,    86,    87,    30,     0,     0,     0,     0,     0,    88,
       0,    31,     0,     0,     0,     0,    89,     0,    90,     0,
      91,    92,    93,   391,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    95,    96,     0,     0,    98,    99,
     100,    33,     0,     0,     0,     0,     0,   102,    35,   103,
     104,   105,   106,   107,     0,   108,   109,   110,   392,     0,
     112,   393,   394,    76,    77,    78,    41,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    79,     9,    10,     0,
      11,     0,     0,     0,     0,    12,    13,     0,    14,    15,
       0,     0,     0,    18,    19,    20,    21,     0,     0,     0,
      24,   310,     0,     0,    26,     0,    83,     0,     0,    28,
     311,    29,    85,     0,    86,     0,    30,     0,     0,     0,
       0,     0,    88,     0,    31,     0,     0,     0,     0,    89,
       0,    90,     0,    91,    92,    93,   265,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    95,    96,     0,
      97,    98,   312,     0,    33,   101,     0,     0,     0,     0,
      34,    35,   103,     0,   105,     0,   107,     0,    36,   109,
     110,   313,     0,   112,   314,   315,   645,   646,     0,    41,
       0,     0,     0,     0,     0,     0,     7,     8,    79,     9,
      10,     0,    80,     0,     0,     0,     0,    12,    13,  -101,
      14,    15,     0,     0,    17,    18,    19,    20,    21,    22,
      23,     0,    24,    82,    25,     0,    26,     0,    83,    27,
       0,    28,    84,    29,    85,     0,    86,    87,    30,     0,
       0,     0,     0,     0,    88,     0,    31,     0,     0,     0,
       0,     0,     0,    90,     0,     0,    92,     0,   391,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    95,
      96,     0,     0,     0,   647,   547,    33,     0,     0,     0,
       0,     0,   102,    35,   103,   104,   105,   106,   107,   548,
     108,   648,   550,   392,     0,   112,   393,   649,   645,   646,
       0,    41,     0,     0,     0,     0,     0,     0,     7,     8,
      79,     9,    10,     0,    80,     0,     0,     0,     0,    12,
      13,  -102,    14,    15,     0,     0,    17,    18,    19,    20,
      21,    22,    23,     0,    24,    82,    25,     0,    26,     0,
      83,    27,     0,    28,    84,    29,    85,     0,    86,    87,
      30,    76,   328,   329,   330,     0,    88,     0,    31,     0,
       0,     0,     0,     0,     0,    90,     0,     0,    92,     0,
     391,   224,   225,     0,     0,     0,     0,     0,     0,     0,
       0,    95,    96,     0,    21,     0,   647,   547,    33,     0,
       0,     0,     0,     0,   102,    35,   103,   104,   105,   106,
     107,   548,   108,   648,   550,   392,     0,   112,   393,   649,
       0,   331,     0,    41,    76,    77,    78,     0,    33,     0,
     226,   227,     0,    93,     0,     0,   224,   225,     0,     0,
       0,     0,    36,   109,   110,   228,     0,     0,   229,    98,
     312,     0,    33,   230,   614,     0,     0,     0,    34,     0,
       0,     0,     0,     0,     0,     0,    36,   109,   110,   332,
       0,     0,   333,   334,   335,     0,   336,     0,     0,     0,
       0,     0,     0,    33,   450,   226,   227,     0,     0,     0,
      89,     0,     0,     0,    91,     0,    93,    36,   109,   110,
     228,     0,     0,   229,     0,     0,     0,     0,   230,   451,
       0,     0,    98,   312,     0,    33,     0,     0,     0,     0,
       0,    34,   452,   103,     0,   105,   621,     0,   622,    36,
     109,   110,     0,     0,   112,   623,   315,    21,   624,   625,
     626,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   621,     0,   622,     0,   627,     0,   628,     0,   629,
     623,     0,   630,   624,   625,   626,     0,     0,     0,   631,
     632,    87,     0,     0,     0,     0,     0,   265,     0,     0,
     627,     0,   628,     0,   629,     0,     0,   630,     0,     0,
     577,    97,     0,     0,   631,   632,   101,     0,     0,     0,
       0,     0,     0,   103,   104,   105,   106,     0,   578,     0,
      33,     0,   313,   579,   112,   314,     0,     0,     0,     0,
       0,     0,     0,     0,    36,   109,   110,   170,     0,     0,
     171,     0,     0,     0,     0,    33,   633,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    36,
     109,   110,   170,     0,     0,   171,     7,     8,    79,     9,
      10,   787,    80,     0,     0,     0,     0,    12,    13,     0,
      14,    15,     0,     0,    17,    18,    19,    20,    21,    22,
      23,     0,    24,   310,    25,     0,    26,     0,    83,    27,
       0,    28,   311,    29,    85,     0,    86,    87,    30,     0,
       0,     0,     0,     0,    88,     0,    31,     0,     0,     0,
       0,     0,     0,    90,     0,     0,    92,     0,   391,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    95,
      96,     0,     0,     0,     0,   547,    33,     0,     0,     0,
       0,     0,    34,    35,   103,   104,   105,   106,   107,   548,
      36,   648,   550,   392,     0,   112,   393,   799,    79,     9,
      10,    41,    11,     0,     0,     0,     0,    12,    13,     0,
      14,    15,  -151,     0,    17,    18,    19,    20,    21,     0,
      23,     0,    24,   310,    25,     0,    26,     0,    83,     0,
       0,    28,   311,    29,    85,     0,    86,     0,    30,     0,
       0,     0,     0,     0,    88,     0,    31,     0,     0,     0,
       0,     0,     0,    90,     0,     0,    92,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    95,
      96,     0,     0,     0,     0,     0,    33,   101,     0,     0,
       0,     0,    34,    35,   103,     0,   105,     0,   107,     0,
      36,   109,   110,   313,     0,   112,   314,     0,    79,     9,
      10,    41,    11,     0,     0,     0,     0,    12,    13,     0,
      14,    15,     0,     0,     0,    18,    19,    20,    21,     0,
       0,     0,    24,   310,     0,     0,    26,     0,    83,     0,
       0,    28,   311,    29,    85,     0,    86,     0,    30,     0,
       0,     0,     0,     0,    88,     0,    31,     0,     0,     0,
       0,     0,     0,    90,     0,     0,    92,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    95,
      96,     0,     0,     0,     0,     0,     0,   101,     0,     0,
       0,     0,    34,    35,   103,     0,   105,     0,   107,     0,
      79,     9,    10,   313,    80,   112,   314,     0,     0,    12,
      13,    41,    14,    15,     0,     0,     0,    18,    19,    20,
       0,     0,     0,     0,    24,   310,     0,     0,    26,     0,
      83,     0,     0,    28,   311,    29,    85,     0,    86,     0,
      30,     0,     0,     0,     0,     0,    88,     0,    31,     0,
       0,     0,     0,     0,     0,    90,     0,     0,    92,     0,
       0,     0,    21,     0,     0,     9,    10,     0,    11,     0,
       0,    95,    96,    12,    13,     0,    14,    15,     0,     0,
       0,    18,    19,    20,    34,    35,     0,     0,    24,     0,
     107,     0,    26,     0,     0,     0,     0,    28,     0,    29,
      85,     0,   265,    41,    30,     0,     0,     0,     0,     0,
      88,     0,    31,     0,     0,   577,    97,     0,     0,    90,
       0,   101,    92,     0,     0,     0,     0,     0,   103,   104,
     105,   106,     0,   586,     0,    95,    96,   313,   579,   112,
     314,     0,     0,     0,     0,   224,   225,     0,    34,    35,
     103,     0,   105,     0,   107,     0,     0,     9,    10,     0,
      11,   112,     0,     0,     0,    12,    13,    41,    14,    15,
       0,   224,   225,    18,    19,    20,     0,     0,     0,     0,
      24,     0,     0,     0,    26,     0,     0,     0,     0,    28,
       0,    29,    33,     0,   351,   227,    30,     0,     0,     0,
       0,     0,     0,     0,    31,     0,    36,   109,   110,   228,
       0,     0,   229,     0,     0,     0,     0,   230,    33,     0,
     507,   227,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    36,   109,   110,   228,     0,     0,   229,     0,
      34,    35,     0,   230,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    41
};

static const yytype_int16 yycheck[] =
{
       3,     4,     3,     4,     4,     3,     4,     4,    81,     3,
      72,     3,     4,     4,    86,     3,     4,   310,     4,   183,
       3,     4,     3,   151,   105,     4,     3,     4,    56,    56,
       4,   112,     4,   203,     3,     3,   153,   179,   240,     4,
     240,    28,    29,    97,   158,   386,   203,   161,    69,   475,
       4,   190,   243,   418,   419,   420,   240,    99,   423,    26,
     102,   543,    56,   386,   446,   226,   108,   503,   504,   259,
      72,   507,   441,   243,    83,    56,   133,   446,    81,    41,
      81,    81,    85,    81,    81,    10,   243,    56,    72,    81,
      81,   611,    36,    81,   153,    81,    85,     0,    81,   121,
       0,   219,    81,   725,    81,   394,   153,    81,    86,    81,
     287,    82,   412,    84,   291,    86,    81,   179,    38,    20,
      62,    10,    10,     0,    10,   302,   179,    81,     0,    30,
      80,   188,    78,   133,    84,   543,     0,     0,   503,   504,
       0,     0,   199,   371,     1,   373,    92,     1,   287,   114,
     153,   353,   291,   353,   120,    99,     1,   123,    78,   133,
      78,   133,   164,   302,   108,   367,   280,   512,    10,   353,
     284,    10,    92,   795,   121,    10,   118,   109,    79,   524,
     164,    80,   114,   367,   121,    84,   706,   105,   188,   107,
     351,   111,   112,   113,   539,   120,   116,   121,   680,   199,
     203,   222,   203,   544,    80,   203,   203,   321,    84,   211,
     324,   203,   203,   210,   188,   203,   188,   203,   189,   122,
     203,   544,   122,   120,   203,   199,   203,   199,    11,   203,
     277,   120,   120,   533,   120,   349,   210,    20,    32,   311,
     243,   359,   243,    26,   223,   243,   243,    30,    38,   203,
     122,   243,   243,   262,   680,   243,   374,   243,   122,   122,
     243,   320,   122,   122,   243,   122,   243,   703,   122,   243,
     105,   441,   680,   320,   123,   278,   446,   122,   120,   128,
     269,   120,    13,   441,   426,   120,   400,   323,   446,   243,
     113,   121,    78,   116,   123,   413,    79,    80,   475,    82,
      83,    84,    85,    86,    94,   277,    38,   607,   597,   691,
      96,   124,   102,   126,   367,   604,   605,   320,    78,   105,
     110,   690,   691,    78,   110,   111,   112,   355,   810,   357,
      51,   628,    53,   630,   105,   658,   475,   451,   703,   310,
     311,   362,   344,    80,    78,    66,   507,    84,    85,   385,
     386,   105,   355,    29,   357,   317,    81,   355,    87,   357,
     344,   355,   123,   357,   426,    97,   123,   355,   312,   357,
     852,   105,   355,   107,   355,   373,   357,    87,   355,   382,
     357,   113,   203,   117,   116,   385,   386,   355,   382,   357,
     123,   358,   774,   123,   385,   386,   363,   371,   103,   373,
     121,   382,   810,   594,   543,   774,   189,    80,    78,   599,
     600,    84,    85,    80,   616,   123,   616,   382,    82,   202,
     385,   386,   243,    82,   594,    95,   852,    78,   121,   438,
     439,   488,   616,    13,     4,   105,    57,   594,   441,   875,
     876,   111,   112,   446,   852,    95,    96,   441,     9,    10,
     441,    78,   446,   835,   105,   446,   107,   107,   437,   121,
     441,   100,   101,   466,   120,   446,   835,    81,    82,   436,
     612,    78,    80,   384,   123,   478,   259,   480,   105,   262,
     107,   484,   117,   118,   478,   123,   480,   441,   488,   123,
     484,   649,   446,   123,   144,   278,    80,   478,   105,   480,
     107,   151,    80,   484,     9,   682,    84,    85,    10,   159,
     875,    81,    80,   478,   488,   480,   488,    87,    78,   484,
     690,   691,     8,   577,   478,   124,   480,   310,   311,    29,
     484,    79,   690,   691,    79,    80,   437,   101,   655,     6,
       7,   680,   277,   682,   544,   105,    80,   107,    79,    80,
     612,   613,    83,   544,    85,    81,   608,   609,   123,   612,
     613,   382,   764,   133,   764,   593,   593,   121,   479,   697,
     481,   121,   575,   866,   485,   358,    43,    50,    81,   544,
     363,   575,    81,   153,   123,    52,    80,   277,   778,   779,
     123,   594,   115,   594,   575,   123,   594,   594,   775,   593,
      77,    78,   594,   594,   774,   647,   594,    15,   594,    80,
     575,   594,   593,   183,   695,   594,   774,   594,   188,   628,
     594,   630,   786,    96,   593,    98,    99,    94,    23,   199,
      59,    60,    61,   203,    63,   102,   775,   110,   111,   112,
     594,   799,   105,   110,   846,    79,    80,   382,   121,    83,
     117,    85,    80,   436,   437,   438,   439,   478,   123,   480,
     117,   602,   603,   484,   841,   835,   843,     8,    29,   637,
      80,   810,    23,   243,    79,    80,   679,   835,    83,   100,
      85,   684,   123,   466,   687,   679,   689,   690,   691,    80,
     684,    98,   382,   687,    80,   689,   690,   691,   679,   690,
     691,   120,   841,   684,   843,    80,   687,   277,   689,   690,
     691,   764,   715,   852,   679,   829,    80,   500,    10,   684,
     782,   715,   687,    78,   689,   712,   807,    68,    69,    70,
     684,   632,    98,   687,   715,   689,    80,   851,   780,   781,
      84,    85,    47,   478,   122,   480,   808,    80,    80,   484,
     320,    96,    84,    85,   575,   808,   123,   492,   103,   441,
     495,   834,   114,   664,   446,   110,   111,   112,   882,   740,
     741,   774,    78,   594,   783,   123,   117,   118,   357,   664,
     774,    61,   215,   774,   125,   126,    78,    61,   478,   792,
     480,   794,    80,   774,   484,   867,    84,    85,   792,    61,
     794,    61,   187,   373,    80,   111,   112,   113,    84,    85,
     116,   792,   664,   794,   725,   790,   599,   600,     3,   111,
     112,   113,   739,   466,   116,   111,   112,   113,   120,   794,
     116,   834,   835,   834,   834,   121,   834,   834,   847,   848,
     575,   835,   834,   834,   835,   628,   834,   630,   834,   632,
     853,   834,   856,   694,   835,   834,   661,   834,   679,   853,
     834,   164,   834,   684,   460,   441,   687,   437,   689,   834,
     446,    56,   853,    79,    80,   666,    -1,    83,   448,    85,
     834,   664,    80,   837,   795,   575,    84,    85,   853,   426,
     893,    -1,    -1,   575,   715,   866,   867,    -1,    -1,   893,
      85,    80,   478,    -1,   480,    84,    85,    -1,   484,    38,
      -1,    -1,   893,    -1,    -1,    96,   870,   871,   488,   873,
      -1,    59,    60,    61,    -1,    63,    -1,   838,   893,   110,
     111,   112,   113,   887,   888,   116,    -1,   891,   892,    -1,
      78,   111,   112,   113,   679,    -1,   116,    -1,   133,   684,
      88,    -1,   687,    -1,   689,    -1,    -1,   740,   741,     0,
      -1,   872,    -1,   874,     5,     6,     7,    96,   153,    -1,
      38,   792,    80,   794,    80,   886,    84,    85,    84,    85,
     715,   110,   111,   112,   113,    -1,    -1,   116,    -1,   679,
      -1,    -1,    -1,   122,   684,   778,   779,   687,    -1,   689,
     783,    -1,   684,   188,    -1,   687,    74,   689,   690,   691,
      78,   111,   112,   113,   199,    -1,   116,    -1,     5,     6,
       7,     8,    -1,    -1,   594,   715,   111,   112,   113,    -1,
      71,   116,   853,   715,    75,    -1,    77,    -1,    59,    60,
      61,   611,    63,   111,   112,   113,    -1,    -1,   116,    -1,
      -1,    38,    93,    94,    -1,    -1,    -1,   792,    -1,   794,
      -1,    -1,    -1,    -1,   847,   848,    -1,    -1,    -1,    -1,
     640,    -1,   893,     5,     6,     7,   117,    -1,    65,    -1,
      -1,   122,    -1,   866,   867,    49,    -1,    -1,    -1,    -1,
      77,   661,   774,   278,   664,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   792,    -1,   794,    -1,    93,    94,   684,    96,
     792,   687,    -1,   689,    -1,   102,    -1,    -1,   853,    -1,
      -1,    -1,    -1,   110,   111,   112,   113,    -1,    78,   116,
     117,   118,    96,   120,    98,   320,   706,    -1,   323,    71,
      -1,    91,    92,    75,    -1,    77,   110,   111,   112,   113,
      -1,    -1,   116,   835,   104,   105,   106,   107,   893,    -1,
      -1,    93,    94,   853,   114,   115,    -1,    -1,    -1,    -1,
     355,   853,   357,    -1,    -1,    -1,    -1,    -1,     1,    -1,
      -1,    -1,    -1,    -1,    -1,   117,   371,    -1,   373,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    -1,    22,
     385,   386,    -1,   893,    27,    28,    -1,    30,    31,    -1,
      -1,   893,    35,    36,    37,    38,   786,    -1,    -1,    42,
      43,    -1,    -1,    46,    -1,    48,    -1,    -1,    51,    52,
      53,    54,    -1,    56,    -1,    58,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    66,    -1,    -1,    -1,    -1,    -1,    -1,
      73,    -1,    -1,    76,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   837,    -1,    -1,   834,    -1,    89,    90,    -1,    -1,
      -1,    -1,    -1,    96,    -1,    -1,    -1,    -1,    -1,   102,
     103,   466,    -1,    -1,    -1,   108,    -1,   110,   111,   112,
     113,    -1,    -1,   116,   870,   871,    -1,   873,   121,   122,
      -1,    -1,    -1,   488,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   887,   888,    -1,    -1,   891,   892,     0,     1,    -1,
      -1,    -1,     5,     6,     7,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    16,    17,    18,    19,    20,    -1,    22,
      -1,    -1,    -1,    -1,    27,    28,    -1,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      43,    44,    -1,    46,    -1,    48,    49,    -1,    51,    52,
      53,    54,    -1,    56,    57,    58,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    66,    -1,    -1,    -1,    -1,    71,    -1,
      73,    -1,    75,    76,    77,    78,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    89,    90,   593,    92,
      93,    94,    95,    96,    97,    -1,    -1,    -1,    -1,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,   111,   112,
     113,    -1,   115,   116,   117,    -1,     0,     1,   121,   122,
      -1,     5,     6,     7,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    -1,    22,    -1,
      -1,    -1,    -1,    27,    28,    -1,    30,    31,    -1,    -1,
     655,    35,    36,    37,    38,    -1,    -1,    -1,    42,    43,
      -1,    -1,    46,    -1,    48,    -1,    -1,    51,    52,    53,
      54,    -1,    56,    -1,    58,    -1,    -1,    -1,    -1,    -1,
      64,    -1,    66,    -1,    -1,    -1,    -1,    71,    -1,    73,
      -1,    75,    76,    77,    78,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    89,    90,    -1,    92,    93,
      94,    -1,    96,    97,    -1,    -1,    -1,    -1,   102,   103,
     104,    -1,   106,    -1,   108,    -1,   110,   111,   112,   113,
      -1,   115,   116,   117,     0,     1,    -1,   121,   122,     5,
       6,     7,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      16,    17,    18,    19,    20,    -1,    22,    -1,    -1,    -1,
      -1,    27,    28,    -1,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    43,    44,    -1,
      46,    -1,    48,    49,    -1,    51,    52,    53,    54,    -1,
      56,    57,    58,    -1,    -1,    -1,    -1,    -1,    64,    -1,
      66,    -1,    -1,    -1,    -1,    71,    -1,    73,    -1,    75,
      76,    77,    78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    -1,    -1,    -1,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,   111,   112,   113,     1,   115,
     116,   117,     5,     6,     7,   121,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    16,    17,    18,    19,    20,    -1,    22,
      -1,    -1,    -1,    -1,    27,    28,    -1,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      43,    44,    -1,    46,    -1,    48,    49,    -1,    51,    52,
      53,    54,    -1,    56,    57,    58,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    66,    -1,    -1,    -1,    -1,    71,    -1,
      73,    -1,    75,    76,    77,    78,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    89,    90,    -1,    92,
      93,    94,    95,    96,    97,    -1,    -1,    -1,    -1,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,   111,   112,
     113,     1,   115,   116,   117,     5,     6,     7,   121,   122,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    -1,    22,    -1,    -1,    -1,    -1,    27,    28,    -1,
      30,    31,    -1,    -1,    -1,    35,    36,    37,    38,    -1,
      -1,    -1,    42,    43,    -1,    -1,    46,    -1,    48,    -1,
      -1,    51,    52,    53,    54,    -1,    56,    -1,    58,    -1,
      -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    -1,    -1,
      -1,    71,    -1,    73,    -1,    75,    76,    77,    78,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,
      90,    -1,    92,    93,    94,    -1,    96,    97,    -1,    -1,
      -1,    -1,   102,   103,   104,    -1,   106,    -1,   108,    -1,
     110,   111,   112,   113,    -1,   115,   116,   117,     0,     1,
      -1,   121,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    16,    17,    -1,    19,    20,    -1,
      22,    -1,    -1,    -1,    -1,    27,    28,    -1,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,     1,
      42,    -1,    44,    -1,    46,    -1,    -1,    49,    -1,    51,
      -1,    53,    -1,    -1,    -1,    17,    58,    19,    20,    -1,
      22,    -1,    -1,    -1,    66,    27,    28,    -1,    30,    31,
      32,    -1,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    44,    -1,    46,    87,    -1,    49,    -1,    51,
      -1,    53,    -1,    -1,    96,    -1,    58,    -1,    -1,    -1,
     102,   103,    -1,    -1,    66,    -1,    -1,    -1,   110,   111,
     112,   113,    -1,    -1,   116,    -1,    -1,    -1,    -1,   121,
      19,    20,    -1,    -1,    -1,    -1,    -1,    -1,    27,    28,
      -1,    30,    31,    -1,    96,     1,    35,    36,    -1,    -1,
     102,   103,    -1,    42,    -1,    -1,    -1,    -1,   110,   111,
     112,    -1,    -1,    19,    20,    -1,    22,    -1,    -1,   121,
     122,    27,    28,    -1,    30,    31,    32,    -1,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    -1,    44,    -1,
      46,    -1,    -1,    49,    -1,    51,    -1,    53,    -1,    -1,
      -1,    -1,    58,    38,    -1,    -1,    -1,    96,    -1,    -1,
      66,    -1,    -1,    -1,   103,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,   112,   113,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   121,    -1,    -1,    -1,    -1,    72,    -1,    74,
      96,    -1,    -1,    78,    -1,    -1,   102,   103,    -1,    -1,
      -1,    -1,    -1,     1,   110,   111,   112,     5,     6,     7,
      -1,    -1,    -1,    -1,    -1,   121,   122,    -1,    -1,    -1,
      18,    19,    20,    -1,    22,    -1,   111,   112,   113,    27,
      28,   116,    30,    31,    -1,    -1,    -1,    35,    36,    37,
      38,    -1,   127,    -1,    42,    43,    -1,    -1,    46,    -1,
      48,    -1,    -1,    51,    52,    53,    54,    -1,    56,    -1,
      58,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    67,
      -1,    -1,    -1,    71,    -1,    73,    -1,    75,    76,    77,
      78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    89,    90,    -1,    92,    93,    94,    -1,    96,    97,
      -1,    -1,    -1,    -1,   102,   103,   104,    -1,   106,    -1,
     108,    -1,   110,   111,   112,   113,    -1,   115,   116,   117,
       5,     6,     7,   121,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    16,    17,    18,    19,    20,    -1,    22,    -1,    -1,
      -1,    -1,    27,    28,    29,    30,    31,    32,    -1,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    43,    44,
      -1,    46,    -1,    48,    49,    -1,    51,    52,    53,    54,
      -1,    56,    57,    58,    -1,    -1,    -1,    -1,    -1,    64,
      -1,    66,    -1,    -1,    -1,    -1,    71,    -1,    73,    -1,
      75,    76,    77,    78,    -1,    -1,    -1,    82,    -1,    -1,
      -1,    -1,    -1,    -1,    89,    90,    -1,    92,    93,    94,
      95,    96,    -1,    -1,    -1,    -1,    -1,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,    -1,
     115,   116,   117,     5,     6,     7,   121,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    16,    17,    18,    19,    20,    -1,
      22,    23,    -1,    -1,    -1,    27,    28,    29,    30,    31,
      -1,    -1,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    43,    44,    -1,    46,    -1,    48,    49,    -1,    51,
      52,    53,    54,    -1,    56,    57,    58,    -1,    -1,    -1,
      -1,    -1,    64,    -1,    66,    -1,    -1,    -1,    -1,    71,
      -1,    73,    -1,    75,    76,    77,    78,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,    90,    -1,
      92,    93,    94,    95,    96,    -1,    -1,    -1,    -1,    -1,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,    -1,   115,   116,   117,     5,     6,     7,   121,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    16,    17,    18,
      19,    20,    -1,    22,    -1,    -1,    -1,    -1,    27,    28,
      -1,    30,    31,    32,    -1,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    43,    44,    -1,    46,    -1,    48,
      49,    -1,    51,    52,    53,    54,    -1,    56,    57,    58,
      -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    -1,
      -1,    -1,    71,    -1,    73,    -1,    75,    76,    77,    78,
      -1,    -1,    -1,    82,    -1,    -1,    -1,    -1,    -1,    -1,
      89,    90,    -1,    92,    93,    94,    95,    96,    -1,    -1,
      -1,    -1,    -1,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,    -1,   115,   116,   117,     5,
       6,     7,   121,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      16,    17,    18,    19,    20,    -1,    22,    23,    -1,    -1,
      -1,    27,    28,    29,    30,    31,    -1,    -1,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    43,    44,    -1,
      46,    -1,    48,    49,    -1,    51,    52,    53,    54,    -1,
      56,    57,    58,    -1,    -1,    -1,    -1,    -1,    64,    -1,
      66,    -1,    -1,    -1,    -1,    71,    -1,    73,    -1,    75,
      76,    77,    78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    89,    90,    -1,    92,    93,    94,    95,
      96,    -1,    -1,    -1,    -1,    -1,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,    -1,   115,
     116,   117,     5,     6,     7,   121,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    16,    17,    18,    19,    20,    -1,    22,
      -1,    -1,    -1,    -1,    27,    28,    29,    30,    31,    -1,
      -1,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      43,    44,    -1,    46,    -1,    48,    49,    -1,    51,    52,
      53,    54,    -1,    56,    57,    58,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    66,    -1,    -1,    -1,    -1,    71,    -1,
      73,    -1,    75,    76,    77,    78,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    89,    90,    -1,    92,
      93,    94,    95,    96,    -1,    -1,    -1,    -1,    -1,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,    -1,   115,   116,   117,     5,     6,     7,   121,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    16,    17,    18,    19,
      20,    -1,    22,    23,    -1,    -1,    -1,    27,    28,    -1,
      30,    31,    -1,    -1,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    43,    44,    -1,    46,    -1,    48,    49,
      -1,    51,    52,    53,    54,    -1,    56,    57,    58,    -1,
      -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    -1,    -1,
      -1,    71,    -1,    73,    -1,    75,    76,    77,    78,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,
      90,    -1,    92,    93,    94,    95,    96,    -1,    -1,    -1,
      -1,    -1,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,    -1,   115,   116,   117,     5,     6,
       7,   121,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    16,
      17,    18,    19,    20,    -1,    22,    -1,    -1,    -1,    -1,
      27,    28,    29,    30,    31,    -1,    -1,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    43,    44,    -1,    46,
      -1,    48,    49,    -1,    51,    52,    53,    54,    -1,    56,
      57,    58,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,
      -1,    -1,    -1,    -1,    71,    -1,    73,    -1,    75,    76,
      77,    78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    89,    90,    -1,    92,    93,    94,    95,    96,
      -1,    -1,    -1,    -1,    -1,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,    -1,   115,   116,
     117,     5,     6,     7,   121,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    16,    17,    18,    19,    20,    -1,    22,    -1,
      -1,    -1,    -1,    27,    28,    29,    30,    31,    -1,    -1,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    43,
      44,    -1,    46,    -1,    48,    49,    -1,    51,    52,    53,
      54,    -1,    56,    57,    58,    -1,    -1,    -1,    -1,    -1,
      64,    -1,    66,    -1,    -1,    -1,    -1,    71,    -1,    73,
      -1,    75,    76,    77,    78,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    89,    90,    -1,    92,    93,
      94,    95,    96,    -1,    -1,    -1,    -1,    -1,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
      -1,   115,   116,   117,     5,     6,     7,   121,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    16,    17,    18,    19,    20,
      -1,    22,    -1,    -1,    -1,    -1,    27,    28,    29,    30,
      31,    -1,    -1,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    43,    44,    -1,    46,    -1,    48,    49,    -1,
      51,    52,    53,    54,    -1,    56,    57,    58,    -1,    -1,
      -1,    -1,    -1,    64,    -1,    66,    -1,    -1,    -1,    -1,
      71,    -1,    73,    -1,    75,    76,    77,    78,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,    90,
      -1,    92,    93,    94,    95,    96,    -1,    -1,    -1,    -1,
      -1,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,    -1,   115,   116,   117,     5,     6,     7,
     121,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    16,    17,
      18,    19,    20,    -1,    22,    -1,    -1,    -1,    -1,    27,
      28,    -1,    30,    31,    -1,    -1,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    43,    44,    -1,    46,    -1,
      48,    49,    -1,    51,    52,    53,    54,    -1,    56,    57,
      58,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,
      -1,    -1,    -1,    71,    -1,    73,    -1,    75,    76,    77,
      78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    89,    90,    -1,    92,    93,    94,    95,    96,    -1,
      -1,    -1,    -1,    -1,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,    -1,   115,   116,   117,
       5,     6,     7,   121,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    16,    17,    18,    19,    20,    -1,    22,    -1,    -1,
      -1,    -1,    27,    28,    -1,    30,    31,    -1,    -1,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    43,    44,
      -1,    46,    -1,    48,    49,    -1,    51,    52,    53,    54,
      -1,    56,    57,    58,    -1,    -1,    -1,    -1,    -1,    64,
      -1,    66,    -1,    -1,    -1,    -1,    71,    -1,    73,    -1,
      75,    76,    77,    78,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    89,    90,    -1,    -1,    93,    94,
      95,    96,    -1,    -1,    -1,    -1,    -1,   102,   103,   104,
     105,   106,   107,   108,    -1,   110,   111,   112,   113,    -1,
     115,   116,   117,     5,     6,     7,   121,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    -1,
      22,    -1,    -1,    -1,    -1,    27,    28,    -1,    30,    31,
      -1,    -1,    -1,    35,    36,    37,    38,    -1,    -1,    -1,
      42,    43,    -1,    -1,    46,    -1,    48,    -1,    -1,    51,
      52,    53,    54,    -1,    56,    -1,    58,    -1,    -1,    -1,
      -1,    -1,    64,    -1,    66,    -1,    -1,    -1,    -1,    71,
      -1,    73,    -1,    75,    76,    77,    78,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,    90,    -1,
      92,    93,    94,    -1,    96,    97,    -1,    -1,    -1,    -1,
     102,   103,   104,    -1,   106,    -1,   108,    -1,   110,   111,
     112,   113,    -1,   115,   116,   117,     6,     7,    -1,   121,
      -1,    -1,    -1,    -1,    -1,    -1,    16,    17,    18,    19,
      20,    -1,    22,    -1,    -1,    -1,    -1,    27,    28,    29,
      30,    31,    -1,    -1,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    43,    44,    -1,    46,    -1,    48,    49,
      -1,    51,    52,    53,    54,    -1,    56,    57,    58,    -1,
      -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    -1,    -1,
      -1,    -1,    -1,    73,    -1,    -1,    76,    -1,    78,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,
      90,    -1,    -1,    -1,    94,    95,    96,    -1,    -1,    -1,
      -1,    -1,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,    -1,   115,   116,   117,     6,     7,
      -1,   121,    -1,    -1,    -1,    -1,    -1,    -1,    16,    17,
      18,    19,    20,    -1,    22,    -1,    -1,    -1,    -1,    27,
      28,    29,    30,    31,    -1,    -1,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    43,    44,    -1,    46,    -1,
      48,    49,    -1,    51,    52,    53,    54,    -1,    56,    57,
      58,     5,     6,     7,     8,    -1,    64,    -1,    66,    -1,
      -1,    -1,    -1,    -1,    -1,    73,    -1,    -1,    76,    -1,
      78,    49,    50,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    89,    90,    -1,    38,    -1,    94,    95,    96,    -1,
      -1,    -1,    -1,    -1,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,    -1,   115,   116,   117,
      -1,    65,    -1,   121,     5,     6,     7,    -1,    96,    -1,
      98,    99,    -1,    77,    -1,    -1,    49,    50,    -1,    -1,
      -1,    -1,   110,   111,   112,   113,    -1,    -1,   116,    93,
      94,    -1,    96,   121,   122,    -1,    -1,    -1,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
      -1,    -1,   116,   117,   118,    -1,   120,    -1,    -1,    -1,
      -1,    -1,    -1,    96,    65,    98,    99,    -1,    -1,    -1,
      71,    -1,    -1,    -1,    75,    -1,    77,   110,   111,   112,
     113,    -1,    -1,   116,    -1,    -1,    -1,    -1,   121,    90,
      -1,    -1,    93,    94,    -1,    96,    -1,    -1,    -1,    -1,
      -1,   102,   103,   104,    -1,   106,    12,    -1,    14,   110,
     111,   112,    -1,    -1,   115,    21,   117,    38,    24,    25,
      26,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    12,    -1,    14,    -1,    41,    -1,    43,    -1,    45,
      21,    -1,    48,    24,    25,    26,    -1,    -1,    -1,    55,
      56,    57,    -1,    -1,    -1,    -1,    -1,    78,    -1,    -1,
      41,    -1,    43,    -1,    45,    -1,    -1,    48,    -1,    -1,
      91,    92,    -1,    -1,    55,    56,    97,    -1,    -1,    -1,
      -1,    -1,    -1,   104,   105,   106,   107,    -1,   109,    -1,
      96,    -1,   113,   114,   115,   116,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,    -1,    -1,
     116,    -1,    -1,    -1,    -1,    96,   122,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,
     111,   112,   113,    -1,    -1,   116,    16,    17,    18,    19,
      20,   122,    22,    -1,    -1,    -1,    -1,    27,    28,    -1,
      30,    31,    -1,    -1,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    43,    44,    -1,    46,    -1,    48,    49,
      -1,    51,    52,    53,    54,    -1,    56,    57,    58,    -1,
      -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    -1,    -1,
      -1,    -1,    -1,    73,    -1,    -1,    76,    -1,    78,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,
      90,    -1,    -1,    -1,    -1,    95,    96,    -1,    -1,    -1,
      -1,    -1,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,    -1,   115,   116,   117,    18,    19,
      20,   121,    22,    -1,    -1,    -1,    -1,    27,    28,    -1,
      30,    31,    32,    -1,    34,    35,    36,    37,    38,    -1,
      40,    -1,    42,    43,    44,    -1,    46,    -1,    48,    -1,
      -1,    51,    52,    53,    54,    -1,    56,    -1,    58,    -1,
      -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    -1,    -1,
      -1,    -1,    -1,    73,    -1,    -1,    76,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,
      90,    -1,    -1,    -1,    -1,    -1,    96,    97,    -1,    -1,
      -1,    -1,   102,   103,   104,    -1,   106,    -1,   108,    -1,
     110,   111,   112,   113,    -1,   115,   116,    -1,    18,    19,
      20,   121,    22,    -1,    -1,    -1,    -1,    27,    28,    -1,
      30,    31,    -1,    -1,    -1,    35,    36,    37,    38,    -1,
      -1,    -1,    42,    43,    -1,    -1,    46,    -1,    48,    -1,
      -1,    51,    52,    53,    54,    -1,    56,    -1,    58,    -1,
      -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    -1,    -1,
      -1,    -1,    -1,    73,    -1,    -1,    76,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,
      90,    -1,    -1,    -1,    -1,    -1,    -1,    97,    -1,    -1,
      -1,    -1,   102,   103,   104,    -1,   106,    -1,   108,    -1,
      18,    19,    20,   113,    22,   115,   116,    -1,    -1,    27,
      28,   121,    30,    31,    -1,    -1,    -1,    35,    36,    37,
      -1,    -1,    -1,    -1,    42,    43,    -1,    -1,    46,    -1,
      48,    -1,    -1,    51,    52,    53,    54,    -1,    56,    -1,
      58,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,
      -1,    -1,    -1,    -1,    -1,    73,    -1,    -1,    76,    -1,
      -1,    -1,    38,    -1,    -1,    19,    20,    -1,    22,    -1,
      -1,    89,    90,    27,    28,    -1,    30,    31,    -1,    -1,
      -1,    35,    36,    37,   102,   103,    -1,    -1,    42,    -1,
     108,    -1,    46,    -1,    -1,    -1,    -1,    51,    -1,    53,
      54,    -1,    78,   121,    58,    -1,    -1,    -1,    -1,    -1,
      64,    -1,    66,    -1,    -1,    91,    92,    -1,    -1,    73,
      -1,    97,    76,    -1,    -1,    -1,    -1,    -1,   104,   105,
     106,   107,    -1,   109,    -1,    89,    90,   113,   114,   115,
     116,    -1,    -1,    -1,    -1,    49,    50,    -1,   102,   103,
     104,    -1,   106,    -1,   108,    -1,    -1,    19,    20,    -1,
      22,   115,    -1,    -1,    -1,    27,    28,   121,    30,    31,
      -1,    49,    50,    35,    36,    37,    -1,    -1,    -1,    -1,
      42,    -1,    -1,    -1,    46,    -1,    -1,    -1,    -1,    51,
      -1,    53,    96,    -1,    98,    99,    58,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    66,    -1,   110,   111,   112,   113,
      -1,    -1,   116,    -1,    -1,    -1,    -1,   121,    96,    -1,
      98,    99,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,   113,    -1,    -1,   116,    -1,
     102,   103,    -1,   121,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   121
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,    86,   130,   132,   131,     0,     1,    16,    17,    19,
      20,    22,    27,    28,    30,    31,    33,    34,    35,    36,
      37,    38,    39,    40,    42,    44,    46,    49,    51,    53,
      58,    66,    87,    96,   102,   103,   110,   111,   112,   113,
     116,   121,   133,   134,   136,   140,   145,   146,   147,   148,
     157,   160,   163,   169,   170,   171,   173,   177,   183,   184,
     185,   193,   195,   197,   198,   199,   200,   218,   222,   223,
     224,   303,   305,   306,   307,     1,     5,     6,     7,    18,
      22,    33,    43,    48,    52,    54,    56,    57,    64,    71,
      73,    75,    76,    77,    78,    89,    90,    92,    93,    94,
      95,    97,   102,   104,   105,   106,   107,   108,   110,   111,
     112,   113,   115,   116,   117,   134,   135,   138,   140,   141,
     142,   145,   150,   151,   152,   153,   157,   160,   163,   169,
     175,   178,   179,   180,   181,   182,   186,   187,   198,   225,
     237,   238,   243,   244,   245,   249,   251,   252,   253,   254,
     261,   262,   263,   268,   271,   272,   276,   284,   285,   286,
     287,   288,   298,   303,   305,   306,   307,   308,   121,   121,
     113,   116,   135,   241,   113,   116,   135,   240,   241,   304,
     113,   116,   135,   240,   121,   177,   177,   241,   176,   120,
      80,    84,    85,   206,   208,   210,   214,   215,   210,   176,
      32,   144,   120,   123,   121,     1,   112,   122,   136,   148,
     174,   305,   306,   179,   195,   196,   197,   243,   284,    13,
     194,   200,   190,   191,    49,    50,    98,    99,   113,   116,
     121,   138,   309,   310,   312,   313,   315,   316,   318,   325,
     326,   327,   329,   123,    78,    78,   266,   266,   241,   121,
     142,    78,   113,   116,   135,   202,   203,   204,   205,   233,
     234,   203,   236,   202,   235,    78,   113,   116,   135,   239,
     271,   307,   235,   103,   138,   188,   189,   246,   282,   269,
     270,   272,   105,   273,   270,   270,   273,    80,    84,   210,
     212,    80,    84,   212,     9,    10,   257,   259,   260,   257,
     105,   270,    80,    84,   212,   257,    78,   141,   266,    29,
      43,    52,    94,   113,   116,   117,   138,   180,   182,   252,
     268,   272,   307,    81,   270,   269,   270,   301,     6,     7,
       8,    65,   113,   116,   117,   118,   120,   138,   151,   218,
     254,   255,   265,   267,   305,   307,   275,   250,   250,   270,
     250,    98,   323,   326,    87,   158,    87,   161,   123,   219,
     103,   220,   221,   123,    98,   310,   312,   326,    78,   105,
     138,   300,   164,   166,   219,     1,    67,   180,   202,    84,
     209,   214,   216,   217,    80,    82,    82,   122,   121,   202,
     226,    78,   113,   116,   117,   138,   149,   150,   182,   205,
     251,   284,   295,   296,   297,   298,   299,   307,   153,   172,
     182,   194,   190,    13,   200,   187,   330,   314,    79,    80,
      83,    85,   321,    79,   321,   322,   317,   311,   100,   101,
     313,   325,   327,   328,   329,   149,   123,   156,    10,   120,
     226,   123,   203,   228,   229,   230,   123,   271,   123,   121,
      65,    90,   103,   138,   218,   247,   248,   252,   262,   263,
     264,    72,    74,    78,   113,   116,   127,   135,   277,   279,
     281,   307,   250,   120,   250,    80,    84,   213,   216,    80,
     216,    80,     9,    10,   216,    80,   234,   235,   176,   250,
     287,   250,    59,    60,    61,    63,   290,     8,   302,   323,
     124,   252,   250,    79,    80,   324,    29,    98,     1,   112,
     122,   136,   159,   160,   163,   168,   169,   198,   303,   307,
       1,   112,   122,   136,   162,   163,   168,   198,   303,   307,
     240,   190,   200,   240,   178,     1,   122,   138,   165,   167,
     169,   178,   190,    80,    82,    78,    92,    95,   109,   111,
     112,   113,   116,   117,   134,   137,   139,   140,   145,   153,
     157,   160,   163,   169,   182,   187,   251,   262,   263,   298,
     303,   307,   308,    81,    84,   206,   211,    91,   109,   114,
     201,   207,   272,   284,   287,   298,   109,   201,   207,   272,
     284,   287,   298,   143,   123,   105,    78,   117,   297,    10,
     120,   250,   117,   118,   124,   126,   220,   190,   121,   121,
     322,   322,   322,   322,   122,   312,   326,   328,   331,    81,
     240,    12,    14,    21,    24,    25,    26,    41,    43,    45,
      48,    55,    56,   122,   135,   138,   154,   155,   187,   227,
     231,   232,   241,   203,   203,     6,     7,    94,   111,   117,
     139,   152,   205,   238,   242,   268,   284,   299,    81,   152,
     242,   123,   294,   300,   192,   250,   301,   279,     8,    68,
      69,    70,   117,   118,   125,   126,   278,   280,   213,   216,
      80,   152,    80,    84,   206,   212,   152,   206,   152,   206,
     123,   123,   262,   262,   289,   123,   128,   256,    78,    95,
     105,   135,   274,    79,   322,   324,   322,   324,   324,   144,
     144,   220,    15,   144,    84,   209,   217,   201,   207,   272,
     284,   298,    78,   105,   107,    80,    78,    92,   111,   113,
     116,   117,   139,   251,   262,   263,   298,   307,    23,   273,
      10,   120,   112,   122,   136,   148,   149,   226,   226,   296,
     296,   297,   297,   220,   164,   164,   103,   113,   121,   138,
     222,   319,   312,   310,   326,   331,   328,   228,   228,   241,
     198,   113,   116,   138,   123,    80,    84,   299,    10,   120,
     102,   110,   305,   109,   201,   294,   117,   122,   154,   232,
     302,    84,   209,   213,   216,    80,   152,   152,   152,   117,
      78,    88,   290,   291,   292,   293,   257,   269,   322,   177,
      80,    78,    92,   105,   107,   111,   113,   116,   117,   139,
     251,   262,   263,   307,    23,   211,    78,   105,   107,   275,
     202,   202,   122,   122,   320,   123,   242,   216,    80,   226,
     226,    80,    84,    80,    84,    98,   326,    10,   120,   203,
     300,   256,    80,   206,    62,   118,   120,   257,   258,   217,
      78,   105,   107,   250,   142,   242,    43,    52,   117,    84,
     206,   216,    80,   216,    80,    80,    98,   203,   203,   250,
     293,    47,   283,   122,   234,   235,    80,   206,   206,   322,
     250,   123,   123,   206
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int16 yyr1[] =
{
       0,   129,   130,   131,   130,   132,   132,   132,   132,   132,
     133,   133,   133,   133,   133,   133,   133,   133,   133,   133,
     133,   134,   134,   135,   135,   136,   136,   136,   137,   137,
     137,   137,   137,   137,   137,   137,   137,   137,   137,   137,
     137,   138,   138,   138,   139,   139,   139,   140,   141,   141,
     141,   142,   142,   142,   142,   142,   142,   142,   142,   143,
     143,   143,   143,   144,   146,   145,   147,   147,   148,   148,
     148,   149,   149,   149,   149,   149,   150,   150,   150,   150,
     150,   150,   150,   150,   150,   150,   150,   150,   150,   150,
     150,   151,   151,   151,   151,   151,   151,   151,   151,   151,
     152,   152,   152,   152,   152,   152,   152,   152,   153,   154,
     155,   154,   156,   156,   156,   156,   157,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   159,   158,   158,
     160,   161,   161,   161,   161,   161,   161,   161,   161,   161,
     162,   161,   161,   163,   164,   164,   165,   165,   165,   166,
     166,   167,   166,   168,   169,   170,   170,   170,   171,   172,
     172,   173,   173,   173,   173,   174,   173,   173,   175,   175,
     175,   176,   176,   176,   177,   178,   178,   178,   179,   180,
     180,   180,   180,   180,   181,   182,   182,   183,   183,   184,
     184,   185,   185,   186,   186,   186,   188,   187,   187,   189,
     189,   190,   191,   191,   192,   192,   192,   193,   193,   194,
     194,   195,   195,   195,   195,   195,   196,   196,   196,   197,
     197,   197,   198,   198,   198,   199,   199,   199,   200,   200,
     201,   201,   201,   202,   202,   202,   203,   203,   204,   204,
     205,   205,   206,   206,   206,   206,   206,   206,   206,   206,
     206,   206,   206,   206,   206,   206,   207,   208,   208,   208,
     208,   208,   208,   208,   208,   209,   209,   209,   209,   209,
     209,   209,   209,   209,   209,   209,   209,   209,   209,   209,
     209,   209,   209,   209,   209,   209,   210,   210,   211,   211,
     212,   212,   212,   212,   213,   213,   213,   213,   214,   214,
     214,   214,   214,   214,   214,   214,   214,   214,   214,   214,
     215,   215,   215,   215,   215,   215,   215,   215,   215,   215,
     216,   216,   216,   217,   217,   218,   219,   219,   221,   220,
     220,   222,   222,   223,   223,   223,   223,   223,   224,   224,
     224,   224,   225,   226,   227,   227,   227,   227,   228,   229,
     230,   230,   230,   230,   231,   231,   231,   231,   231,   231,
     231,   231,   231,   232,   232,   232,   232,   233,   234,   234,
     235,   236,   237,   237,   237,   237,   238,   238,   238,   239,
     239,   239,   239,   240,   240,   240,   241,   241,   241,   242,
     242,   242,   242,   242,   242,   242,   242,   243,   243,   243,
     243,   243,   244,   245,   245,   246,   246,   247,   247,   247,
     247,   248,   248,   248,   249,   250,   250,   251,   251,   251,
     251,   251,   251,   251,   251,   252,   252,   253,   254,   254,
     254,   254,   255,   255,   256,   256,   257,   257,   257,   258,
     259,   259,   260,   260,   261,   262,   263,   263,   264,   264,
     265,   265,   265,   265,   266,   267,   267,   267,   267,   267,
     267,   267,   268,   268,   268,   269,   269,   270,   271,   271,
     272,   273,   273,   274,   274,   275,   275,   275,   275,   276,
     276,   277,   277,   277,   277,   277,   278,   278,   278,   279,
     279,   279,   279,   279,   280,   280,   280,   280,   281,   281,
     282,   282,   283,   283,   284,   284,   285,   285,   286,   286,
     286,   286,   287,   288,   288,   289,   289,   290,   290,   290,
     290,   291,   291,   291,   292,   292,   293,   293,   293,   294,
     294,   295,   295,   295,   296,   296,   296,   297,   297,   298,
     298,   298,   299,   299,   299,   300,   300,   300,   301,   301,
     302,   302,   304,   303,   305,   306,   307,   307,   308,   309,
     309,   309,   311,   310,   312,   312,   313,   313,   313,   314,
     313,   315,   316,   317,   317,   317,   318,   320,   319,   321,
     321,   321,   321,   321,   321,   321,   322,   322,   323,   323,
     324,   324,   324,   324,   325,   326,   326,   327,   327,   328,
     328,   330,   329,   329,   329,   331,   331
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     0,     3,     0,     2,     2,     2,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     2,     1,
       2,     0,     1,     1,     1,     2,     3,     1,     2,     0,
       2,     2,     2,     4,     0,     2,     1,     1,     3,     5,
       3,     1,     1,     3,     3,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     2,     2,     2,     4,     4,     4,     5,     5,     5,
       1,     3,     3,     4,     4,     3,     2,     1,     4,     1,
       0,     2,     0,     2,     2,     2,     4,     0,     1,     2,
       2,     2,     2,     2,     2,     2,     2,     0,     3,     2,
       4,     0,     1,     2,     2,     2,     2,     2,     2,     2,
       0,     3,     2,     4,     1,     2,     1,     1,     1,     0,
       2,     0,     3,     1,     2,     1,     1,     1,     1,     1,
       1,     2,     2,     2,     2,     0,     3,     2,     4,     5,
       2,     0,     2,     2,     3,     1,     1,     1,     1,     1,
       1,     1,     3,     2,     1,     1,     1,     4,     6,     2,
       1,     2,     3,     1,     1,     1,     0,     5,     2,     1,
       1,     1,     0,     2,     0,     2,     2,     4,     4,     3,
       4,     1,     1,     1,     3,     5,     1,     1,     1,     3,
       2,     2,     1,     1,     2,     1,     1,     1,     1,     1,
       1,     3,     3,     1,     3,     3,     1,     1,     1,     1,
       1,     1,     1,     4,     5,     5,     5,     4,     4,     3,
       3,     3,     3,     3,     3,     3,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     1,     4,     4,     4,     4,
       4,     4,     4,     4,     5,     5,     5,     4,     4,     4,
       4,     3,     3,     3,     3,     3,     1,     4,     1,     3,
       2,     2,     3,     3,     2,     2,     3,     3,     1,     3,
       3,     3,     4,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     4,     4,
       1,     4,     2,     1,     3,     2,     0,     2,     0,     2,
       1,     2,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     4,     1,     3,     2,     4,     2,     3,     1,
       1,     5,     5,     4,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     2,     2,     1,     1,     2,
       1,     1,     4,     3,     4,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     1,     3,     3,     2,     3,     3,
       1,     1,     3,     3,     3,     0,     2,     5,     2,     1,
       1,     1,     1,     1,     2,     0,     2,     1,     2,     1,
       1,     2,     2,     2,     2,     1,     2,     1,     1,     1,
       1,     1,     1,     1,     0,     2,     0,     1,     1,     1,
       1,     2,     1,     2,     2,     2,     1,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     0,     1,     1,     2,     2,
       2,     0,     2,     1,     1,     0,     3,     3,     3,     1,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     2,     2,     1,     1,     1,     1,     1,     2,
       0,     2,     0,     1,     8,     2,     2,     2,     1,     1,
       1,     1,     3,     2,     4,     0,     2,     1,     1,     2,
       2,     1,     1,     1,     1,     3,     1,     2,     2,     1,
       3,     3,     3,     1,     1,     3,     3,     2,     1,     1,
       1,     2,     1,     1,     2,     1,     1,     1,     0,     2,
       0,     2,     0,     3,     1,     2,     2,     1,     3,     1,
       2,     1,     0,     3,     1,     1,     1,     1,     2,     0,
       5,     2,     3,     0,     2,     2,     2,     0,     4,     3,
       3,     3,     3,     3,     3,     1,     1,     3,     2,     3,
       2,     2,     2,     2,     3,     1,     2,     1,     1,     1,
       1,     0,     5,     2,     2,     2,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (&yylloc, parser, retval, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# ifndef YY_LOCATION_PRINT
#  if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#   define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

#  else
#   define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#  endif
# endif /* !defined YY_LOCATION_PRINT */


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, Location, parser, retval); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, Lily_parser *parser, SCM *retval)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (yylocationp);
  YY_USE (parser);
  YY_USE (retval);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, Lily_parser *parser, SCM *retval)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  YY_LOCATION_PRINT (yyo, *yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yykind, yyvaluep, yylocationp, parser, retval);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp,
                 int yyrule, Lily_parser *parser, SCM *retval)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)],
                       &(yylsp[(yyi + 1) - (yynrhs)]), parser, retval);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule, parser, retval); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yysymbol_kind_t yytoken;
  YYLTYPE *yylloc;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  int yyn = yypact[+*yyctx->yyssp];
  if (!yypact_value_is_default (yyn))
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  In other words, skip the first -YYN actions for
         this state because they are default actions.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;
      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yyx;
      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
        if (yycheck[yyx + yyn] == yyx && yyx != YYSYMBOL_YYerror
            && !yytable_value_is_error (yytable[yyx + yyn]))
          {
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = YY_CAST (yysymbol_kind_t, yyx);
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, Lily_parser *parser, SCM *retval)
{
  YY_USE (yyvaluep);
  YY_USE (yylocationp);
  YY_USE (parser);
  YY_USE (retval);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}






/*----------.
| yyparse.  |
`----------*/

int
yyparse (Lily_parser *parser, SCM *retval)
{
/* Lookahead token kind.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

/* Location data for the lookahead symbol.  */
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
YYLTYPE yylloc = yyloc_default;

    /* Number of syntax errors so far.  */
    int yynerrs = 0;

    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    /* The location stack: array, bottom, top.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls = yylsa;
    YYLTYPE *yylsp = yyls;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[3];

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex (&yylval, &yylloc, parser);
    }

  if (yychar <= END_OF_FILE)
    {
      yychar = END_OF_FILE;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      yyerror_range[1] = yylloc;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 3: /* $@1: %empty  */
#line 389 "parser.yy"
                        {
		parser->lexer_->push_note_state (Lily::pitchnames);
	}
#line 3453 "./out/parser.cc"
    break;

  case 4: /* start_symbol: "#{" $@1 embedded_lilypond  */
#line 391 "parser.yy"
                            {
		parser->lexer_->pop_state ();
                *retval = yyvsp[0];
 	}
#line 3462 "./out/parser.cc"
    break;

  case 5: /* lilypond: %empty  */
#line 397 "parser.yy"
                            { yyval = SCM_UNSPECIFIED; }
#line 3468 "./out/parser.cc"
    break;

  case 6: /* lilypond: lilypond toplevel_expression  */
#line 398 "parser.yy"
                                       {
	}
#line 3475 "./out/parser.cc"
    break;

  case 7: /* lilypond: lilypond assignment  */
#line 400 "parser.yy"
                              {
	}
#line 3482 "./out/parser.cc"
    break;

  case 8: /* lilypond: lilypond error  */
#line 402 "parser.yy"
                         {
		parser->error_level_ = 1;
	}
#line 3490 "./out/parser.cc"
    break;

  case 9: /* lilypond: lilypond "\\version-error"  */
#line 405 "parser.yy"
                                {
		parser->error_level_ = 1;
	}
#line 3498 "./out/parser.cc"
    break;

  case 10: /* toplevel_expression: header_block  */
#line 412 "parser.yy"
                     {
		parser->lexer_->set_identifier (ly_symbol2scm ("$defaultheader"), yyvsp[0]);
	}
#line 3506 "./out/parser.cc"
    break;

  case 11: /* toplevel_expression: book_block  */
#line 415 "parser.yy"
                     {
		SCM proc = parser->lexer_->lookup_identifier ("toplevel-book-handler");
		scm_call_1 (proc, yyvsp[0]);
	}
#line 3515 "./out/parser.cc"
    break;

  case 12: /* toplevel_expression: bookpart_block  */
#line 419 "parser.yy"
                         {
		SCM proc = parser->lexer_->lookup_identifier ("toplevel-bookpart-handler");
		scm_call_1 (proc, yyvsp[0]);
	}
#line 3524 "./out/parser.cc"
    break;

  case 13: /* toplevel_expression: BOOK_IDENTIFIER  */
#line 423 "parser.yy"
                          {
		SCM proc = parser->lexer_->lookup_identifier
			(unsmob<Book>(yyvsp[0])->paper_
			 ? "toplevel-book-handler"
			 : "toplevel-bookpart-handler");
		scm_call_1 (proc, yyvsp[0]);
	}
#line 3536 "./out/parser.cc"
    break;

  case 14: /* toplevel_expression: score_block  */
#line 430 "parser.yy"
                      {
		SCM proc = parser->lexer_->lookup_identifier ("toplevel-score-handler");
		scm_call_1 (proc, yyvsp[0]);
	}
#line 3545 "./out/parser.cc"
    break;

  case 15: /* toplevel_expression: composite_music  */
#line 434 "parser.yy"
                          {
		SCM proc = parser->lexer_->lookup_identifier ("toplevel-music-handler");
		scm_call_1 (proc, yyvsp[0]);
	}
#line 3554 "./out/parser.cc"
    break;

  case 16: /* toplevel_expression: full_markup  */
#line 438 "parser.yy"
                      {
		SCM proc = parser->lexer_->lookup_identifier ("toplevel-text-handler");
		scm_call_1 (proc, scm_list_1 (yyvsp[0]));
	}
#line 3563 "./out/parser.cc"
    break;

  case 17: /* toplevel_expression: full_markup_list  */
#line 442 "parser.yy"
                           {
		SCM proc = parser->lexer_->lookup_identifier ("toplevel-text-handler");
		scm_call_1 (proc, yyvsp[0]);
	}
#line 3572 "./out/parser.cc"
    break;

  case 18: /* toplevel_expression: SCM_TOKEN  */
#line 446 "parser.yy"
                    {
		// Evaluate and ignore #xxx, as opposed to \xxx
		parser->lexer_->eval_scm_token (yyvsp[0], (yylsp[0]));
	}
#line 3581 "./out/parser.cc"
    break;

  case 19: /* toplevel_expression: embedded_scm_active  */
#line 451 "parser.yy"
        {
		SCM out = SCM_UNDEFINED;
		if (Text_interface::is_markup (yyvsp[0]))
			out = scm_list_1 (yyvsp[0]);
		else if (Text_interface::is_markup_list (yyvsp[0]))
			out = yyvsp[0];
		if (scm_is_pair (out))
		{
			SCM proc = parser->lexer_->lookup_identifier ("toplevel-text-handler");
			scm_call_1 (proc, out);
		} else if (unsmob<Score> (yyvsp[0]))
		{
			SCM proc = parser->lexer_->lookup_identifier ("toplevel-score-handler");
			scm_call_1 (proc, yyvsp[0]);
		} else if (Output_def * od = unsmob<Output_def> (yyvsp[0])) {
			SCM id = SCM_EOL;

			if (from_scm<bool> (od->c_variable ("is-paper")))
				id = ly_symbol2scm ("$defaultpaper");
			else if (from_scm<bool> (od->c_variable ("is-midi")))
				id = ly_symbol2scm ("$defaultmidi");
			else if (from_scm<bool> (od->c_variable ("is-layout")))
				id = ly_symbol2scm ("$defaultlayout");

			parser->lexer_->set_identifier (id, yyvsp[0]);
		} else if (ly_is_module (yyvsp[0]))
		{
			SCM module = get_header (parser);
			ly_module_copy (module, yyvsp[0]);
			parser->lexer_->set_identifier
				(ly_symbol2scm ("$defaultheader"), module);
		} else if (!scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
			parser->parser_error ((yylsp[0]), _("bad expression type"));
	}
#line 3620 "./out/parser.cc"
    break;

  case 20: /* toplevel_expression: output_def  */
#line 485 "parser.yy"
                     {
		SCM id = SCM_EOL;
		Output_def * od = unsmob<Output_def> (yyvsp[0]);

		if (from_scm<bool> (od->c_variable ("is-paper")))
			id = ly_symbol2scm ("$defaultpaper");
		else if (from_scm<bool> (od->c_variable ("is-midi")))
			id = ly_symbol2scm ("$defaultmidi");
		else if (from_scm<bool> (od->c_variable ("is-layout")))
			id = ly_symbol2scm ("$defaultlayout");

		parser->lexer_->set_identifier (id, yyvsp[0]);
	}
#line 3638 "./out/parser.cc"
    break;

  case 22: /* lookup: LOOKUP_IDENTIFIER '.' symbol_list_rev  */
#line 503 "parser.yy"
        {
		yyval = loc_on_copy (parser, (yyloc),
				  nested_property (yyvsp[-2], scm_reverse_x (yyvsp[0], SCM_EOL)));
	}
#line 3647 "./out/parser.cc"
    break;

  case 23: /* embedded_scm_bare: SCM_TOKEN  */
#line 511 "parser.yy"
        {
		yyval = parser->lexer_->eval_scm_token (yyvsp[0], (yylsp[0]));
	}
#line 3655 "./out/parser.cc"
    break;

  case 29: /* embedded_scm_bare_arg: SCM_TOKEN  */
#line 526 "parser.yy"
        {
		yyval = parser->lexer_->eval_scm_token (yyvsp[0], (yylsp[0]));
	}
#line 3663 "./out/parser.cc"
    break;

  case 47: /* scm_function_call: SCM_FUNCTION function_arglist  */
#line 566 "parser.yy"
                                      {
		yyval = MAKE_SYNTAX (music_function, (yyloc),
				  yyvsp[-1], yyvsp[0]);
	}
#line 3672 "./out/parser.cc"
    break;

  case 48: /* embedded_lilypond_number: '-' embedded_lilypond_number  */
#line 574 "parser.yy"
        {
		yyval = scm_difference (yyvsp[0], SCM_UNDEFINED);
	}
#line 3680 "./out/parser.cc"
    break;

  case 50: /* embedded_lilypond_number: UNSIGNED NUMBER_IDENTIFIER  */
#line 579 "parser.yy"
        {
		yyval = scm_product (yyvsp[-1], yyvsp[0]);
	}
#line 3688 "./out/parser.cc"
    break;

  case 51: /* embedded_lilypond: %empty  */
#line 586 "parser.yy"
        {
		// FIXME: @$ does not contain a useful source location
		// for empty rules, and the only token in the whole
		// production, EMBEDDED_LILY, is synthetic and also
		// contains no source location.
		yyval = MAKE_SYNTAX (void_music, (yyloc));
	}
#line 3700 "./out/parser.cc"
    break;

  case 54: /* embedded_lilypond: post_event  */
#line 596 "parser.yy"
        {
		if (!unsmob<Music> (yyvsp[0]))
			yyval = MY_MAKE_MUSIC ("PostEvents", (yyloc))->unprotect ();
	}
#line 3709 "./out/parser.cc"
    break;

  case 55: /* embedded_lilypond: duration post_events  */
#line 601 "parser.yy"
        {
		if (scm_is_pair (yyvsp[0])) {
			Music *n = MY_MAKE_MUSIC ("NoteEvent", (yyloc));

			parser->default_duration_ = *unsmob<Duration> (yyvsp[-1]);
			set_property (n, "duration", yyvsp[-1]);
			set_property (n, "articulations",
					 scm_reverse_x (yyvsp[0], SCM_EOL));
			yyval = n->unprotect ();
		}
	}
#line 3725 "./out/parser.cc"
    break;

  case 56: /* embedded_lilypond: music_embedded music_embedded music_list  */
#line 612 "parser.yy"
                                                   {
		SCM tail = SCM_EOL;
		if (unsmob<Music> (yyvsp[-2]))
			tail = scm_cons (yyvsp[-2], tail);
		if (unsmob<Music> (yyvsp[-1]))
			tail = scm_cons (yyvsp[-1], tail);
		yyval = reverse_music_list (parser, (yyloc),
					 scm_append_x (scm_list_2 (yyvsp[0], tail)),
					 true, true);
		if (scm_is_pair (yyval)) // unpackaged list
			if (scm_is_null (scm_cdr (yyval)))
				yyval = scm_car (yyval); // single expression
			else
				yyval = MAKE_SYNTAX (sequential_music, (yyloc), yyval);
		else if (scm_is_null (yyval))
			yyval = MAKE_SYNTAX (void_music, (yyloc));
		// else already packaged post-event
	}
#line 3748 "./out/parser.cc"
    break;

  case 57: /* embedded_lilypond: error  */
#line 630 "parser.yy"
                {
		parser->error_level_ = 1;
                yyval = SCM_UNSPECIFIED;
	}
#line 3757 "./out/parser.cc"
    break;

  case 58: /* embedded_lilypond: "\\version-error" embedded_lilypond  */
#line 634 "parser.yy"
                                    {
		parser->error_level_ = 1;
                yyval = yyvsp[0];
	}
#line 3766 "./out/parser.cc"
    break;

  case 59: /* lilypond_header_body: %empty  */
#line 642 "parser.yy"
                    { yyval = SCM_UNSPECIFIED; }
#line 3772 "./out/parser.cc"
    break;

  case 60: /* lilypond_header_body: lilypond_header_body assignment  */
#line 643 "parser.yy"
                                           {

	}
#line 3780 "./out/parser.cc"
    break;

  case 61: /* lilypond_header_body: lilypond_header_body SCM_TOKEN  */
#line 646 "parser.yy"
                                         {
		// Evaluate and ignore #xxx, as opposed to \xxx
		parser->lexer_->eval_scm_token (yyvsp[0], (yylsp[0]));
	}
#line 3789 "./out/parser.cc"
    break;

  case 62: /* lilypond_header_body: lilypond_header_body embedded_scm_active  */
#line 650 "parser.yy"
                                                   {
		if (ly_is_module (yyvsp[0]))
			ly_module_copy (scm_current_module (), yyvsp[0]);
		else if (!scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
			parser->parser_error ((yylsp[0]), _("bad expression type"));
	}
#line 3800 "./out/parser.cc"
    break;

  case 63: /* lilypond_header: "\\header" '{' lilypond_header_body '}'  */
#line 659 "parser.yy"
                                                {
		yyval = parser->lexer_->remove_scope ();
	}
#line 3808 "./out/parser.cc"
    break;

  case 64: /* $@2: %empty  */
#line 665 "parser.yy"
        {
		parser->lexer_->add_scope (get_header (parser));
	}
#line 3816 "./out/parser.cc"
    break;

  case 65: /* header_block: $@2 lilypond_header  */
#line 667 "parser.yy"
                          {
		yyval = yyvsp[0];
	}
#line 3824 "./out/parser.cc"
    break;

  case 66: /* assignment_id: STRING  */
#line 677 "parser.yy"
        {
		yyval = scm_string_to_symbol (yyvsp[0]);
	}
#line 3832 "./out/parser.cc"
    break;

  case 67: /* assignment_id: SYMBOL  */
#line 681 "parser.yy"
        {
		yyval = scm_string_to_symbol (yyvsp[0]);
	}
#line 3840 "./out/parser.cc"
    break;

  case 68: /* assignment: assignment_id '=' identifier_init  */
#line 687 "parser.yy"
                                           {
	        parser->lexer_->set_identifier (yyvsp[-2], yyvsp[0]);
                yyval = SCM_UNSPECIFIED;
	}
#line 3849 "./out/parser.cc"
    break;

  case 69: /* assignment: assignment_id '.' property_path '=' identifier_init  */
#line 691 "parser.yy"
                                                              {
		SCM path = scm_cons (yyvsp[-4], yyvsp[-2]);
		parser->lexer_->set_identifier (path, yyvsp[0]);
                yyval = SCM_UNSPECIFIED;
	}
#line 3859 "./out/parser.cc"
    break;

  case 70: /* assignment: markup_mode_word '=' identifier_init  */
#line 697 "parser.yy"
        {
		if (scm_is_false (Lily::markup_function_p (yyvsp[0])))
		{
			parser->parser_error ((yylsp[0]), _ ("Not a markup function"));
		} else {
			Lily::define_markup_command_internal
 				(scm_string_to_symbol (yyvsp[-2]), yyvsp[0], SCM_BOOL_F);
		}
		yyval = SCM_UNSPECIFIED;
	}
#line 3874 "./out/parser.cc"
    break;

  case 73: /* identifier_init: symbol_list_part_bare '.' property_path  */
#line 714 "parser.yy"
        {
		yyval = scm_reverse_x (yyvsp[-2], yyvsp[0]);
	}
#line 3882 "./out/parser.cc"
    break;

  case 74: /* identifier_init: symbol_list_part_bare ',' property_path  */
#line 718 "parser.yy"
        {
		yyval = scm_reverse_x (yyvsp[-2], yyvsp[0]);
	}
#line 3890 "./out/parser.cc"
    break;

  case 75: /* identifier_init: post_event_nofinger post_events  */
#line 722 "parser.yy"
        {
		yyval = post_event_cons (yyvsp[-1], scm_reverse_x (yyvsp[0], SCM_EOL));
		if (scm_is_pair (yyval)
		    && scm_is_null (scm_cdr (yyval)))
			yyval = scm_car (yyval);
		else
		{
			Music * m = MY_MAKE_MUSIC ("PostEvents", (yyloc));
			set_property (m, "elements", yyval);
			yyval = m->unprotect ();
		}
	}
#line 3907 "./out/parser.cc"
    break;

  case 90: /* identifier_init_nonumber: partial_function "\\etc"  */
#line 752 "parser.yy"
        {
		yyval = MAKE_SYNTAX (partial_music_function, (yyloc),
				  scm_reverse_x (yyvsp[-1], SCM_EOL));
	}
#line 3916 "./out/parser.cc"
    break;

  case 91: /* partial_function_scriptable: MUSIC_FUNCTION function_arglist_partial  */
#line 762 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-1], yyvsp[0], SCM_EOL);
	}
#line 3924 "./out/parser.cc"
    break;

  case 92: /* partial_function_scriptable: EVENT_FUNCTION function_arglist_partial  */
#line 766 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-1], yyvsp[0], SCM_EOL);
	}
#line 3932 "./out/parser.cc"
    break;

  case 93: /* partial_function_scriptable: SCM_FUNCTION function_arglist_partial  */
#line 770 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-1], yyvsp[0], SCM_EOL);
	}
#line 3940 "./out/parser.cc"
    break;

  case 94: /* partial_function_scriptable: MUSIC_FUNCTION "scheme?" function_arglist_optional partial_function  */
#line 774 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-3], yyvsp[-1], yyvsp[0]);
	}
#line 3948 "./out/parser.cc"
    break;

  case 95: /* partial_function_scriptable: EVENT_FUNCTION "scheme?" function_arglist_optional partial_function  */
#line 778 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-3], yyvsp[-1], yyvsp[0]);
	}
#line 3956 "./out/parser.cc"
    break;

  case 96: /* partial_function_scriptable: SCM_FUNCTION "scheme?" function_arglist_optional partial_function  */
#line 782 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-3], yyvsp[-1], yyvsp[0]);
	}
#line 3964 "./out/parser.cc"
    break;

  case 97: /* partial_function_scriptable: MUSIC_FUNCTION "optional?" "scheme?" function_arglist_nonbackup partial_function  */
#line 786 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-4], yyvsp[-1], yyvsp[0]);
	}
#line 3972 "./out/parser.cc"
    break;

  case 98: /* partial_function_scriptable: EVENT_FUNCTION "optional?" "scheme?" function_arglist_nonbackup partial_function  */
#line 790 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-4], yyvsp[-1], yyvsp[0]);
	}
#line 3980 "./out/parser.cc"
    break;

  case 99: /* partial_function_scriptable: SCM_FUNCTION "optional?" "scheme?" function_arglist_nonbackup partial_function  */
#line 794 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-4], yyvsp[-1], yyvsp[0]);
	}
#line 3988 "./out/parser.cc"
    break;

  case 101: /* partial_function: "\\override" grob_prop_path '='  */
#line 802 "parser.yy"
        {
		if (SCM_UNBNDP (yyvsp[-1]))
			yyval = scm_list_1 (SCM_BOOL_F);
		else
			yyval = scm_cons
				(scm_list_3 (Syntax::property_override,
					     scm_cdr (yyvsp[-1]), scm_car (yyvsp[-1])),
				 SCM_EOL);
	}
#line 4002 "./out/parser.cc"
    break;

  case 102: /* partial_function: "\\set" context_prop_spec '='  */
#line 812 "parser.yy"
        {
		if (SCM_UNBNDP (yyvsp[-1]))
			yyval = scm_list_1 (SCM_BOOL_F);
		else
			yyval = scm_cons
				(scm_list_3 (Syntax::property_set,
					     scm_cadr (yyvsp[-1]), scm_car (yyvsp[-1])),
				 SCM_EOL);
	}
#line 4016 "./out/parser.cc"
    break;

  case 103: /* partial_function: "\\override" grob_prop_path '=' partial_function  */
#line 822 "parser.yy"
        {
		if (SCM_UNBNDP (yyvsp[-2]))
			yyval = scm_list_1 (SCM_BOOL_F);
		else
			yyval = scm_cons
				(scm_list_3 (Syntax::property_override,
					     scm_cdr (yyvsp[-2]), scm_car (yyvsp[-2])),
				 yyvsp[0]);
	}
#line 4030 "./out/parser.cc"
    break;

  case 104: /* partial_function: "\\set" context_prop_spec '=' partial_function  */
#line 832 "parser.yy"
        {
		if (SCM_UNBNDP (yyvsp[-2]))
			yyval = scm_list_1 (SCM_BOOL_F);
		else
			yyval = scm_cons
				(scm_list_3 (Syntax::property_set,
					     scm_cadr (yyvsp[-2]), scm_car (yyvsp[-2])),
				 yyvsp[0]);
	}
#line 4044 "./out/parser.cc"
    break;

  case 105: /* partial_function: script_dir markup_mode markup_partial_function  */
#line 843 "parser.yy"
        {
		if (SCM_UNBNDP (yyvsp[-2]))
			yyvsp[-2] = SCM_INUM0;
		yyvsp[0] = MAKE_SYNTAX (partial_markup, (yylsp[0]), yyvsp[0]);
		parser->lexer_->pop_state ();
// This relies on partial_function always being followed by ETC
		yyval = scm_list_1 (scm_list_3 (MAKE_SYNTAX (partial_text_script, (yyloc), yyvsp[0]),
					     yyvsp[0], yyvsp[-2]));
	}
#line 4058 "./out/parser.cc"
    break;

  case 106: /* partial_function: script_dir partial_function_scriptable  */
#line 853 "parser.yy"
        {
		if (SCM_UNBNDP (yyvsp[-1]))
			yyvsp[-1] = SCM_INUM0;
		yyval = scm_acons (Syntax::create_script_function, scm_list_1 (yyvsp[-1]), yyvsp[0]);
	}
#line 4068 "./out/parser.cc"
    break;

  case 107: /* partial_function: script_dir  */
#line 859 "parser.yy"
        {
		if (SCM_UNBNDP (yyvsp[0]))
			yyvsp[0] = SCM_INUM0;
		yyval = scm_acons (Syntax::create_script_function, scm_list_1 (yyvsp[0]), SCM_EOL);
	}
#line 4078 "./out/parser.cc"
    break;

  case 108: /* context_def_spec_block: "\\context" '{' context_def_spec_body '}'  */
#line 868 "parser.yy"
        {
		yyval = yyvsp[-1];
		Context_def *td = unsmob<Context_def> (yyval);
		if (!td) {
			yyval = Context_def::make_scm ();
			td = unsmob<Context_def> (yyval);
		}
		td->origin ()->set_spot ((yyloc));
	}
#line 4092 "./out/parser.cc"
    break;

  case 110: /* $@3: %empty  */
#line 882 "parser.yy"
        {
		parser->lexer_->push_note_state (Lily::pitchnames);
	}
#line 4100 "./out/parser.cc"
    break;

  case 111: /* context_mod_arg: $@3 composite_music  */
#line 886 "parser.yy"
        {
		parser->lexer_->pop_state ();
		yyval = yyvsp[0];
	}
#line 4109 "./out/parser.cc"
    break;

  case 112: /* context_def_spec_body: %empty  */
#line 894 "parser.yy"
             {
		yyval = SCM_UNSPECIFIED;
	}
#line 4117 "./out/parser.cc"
    break;

  case 113: /* context_def_spec_body: context_def_spec_body context_mod  */
#line 897 "parser.yy"
                                            {
		if (!SCM_UNBNDP (yyvsp[0])) {
			Context_def *td = unsmob<Context_def> (yyval);
			if (!td) {
				yyval = Context_def::make_scm ();
				td = unsmob<Context_def> (yyval);
			}
			unsmob<Context_def> (yyval)->add_context_mod (yyvsp[0]);
		}
	}
#line 4132 "./out/parser.cc"
    break;

  case 114: /* context_def_spec_body: context_def_spec_body context_modification  */
#line 907 "parser.yy"
                                                     {
                Context_def *td = unsmob<Context_def> (yyval);
		if (!td) {
			yyval = Context_def::make_scm ();
			td = unsmob<Context_def> (yyval);
		}
                SCM new_mods = unsmob<Context_mod> (yyvsp[0])->get_mods ();
                for (SCM m = new_mods; scm_is_pair (m); m = scm_cdr (m)) {
                    td->add_context_mod (scm_car (m));
                }
	}
#line 4148 "./out/parser.cc"
    break;

  case 115: /* context_def_spec_body: context_def_spec_body context_mod_arg  */
#line 918 "parser.yy"
                                                {
		Context_def *td = unsmob<Context_def> (yyvsp[-1]);
		if (scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
			;
		else if (!td && unsmob<Context_def> (yyvsp[0]))
			yyval = yyvsp[0];
		else {
			if (!td) {
				yyval = Context_def::make_scm ();
				td = unsmob<Context_def> (yyval);
			}
			if (unsmob<Music> (yyvsp[0])) {
				SCM proc = parser->lexer_->lookup_identifier ("context-mod-music-handler");
				yyvsp[0] = scm_call_1 (proc, yyvsp[0]);
			}
			if (Context_mod *cm = unsmob<Context_mod> (yyvsp[0])) {
				for (SCM m = cm->get_mods (); scm_is_pair (m); m = scm_cdr (m)) {
					td->add_context_mod (scm_car (m));
				}
			} else
				parser->parser_error ((yylsp[0]), _ ("not a context mod"));
		}
	}
#line 4176 "./out/parser.cc"
    break;

  case 116: /* book_block: "\\book" '{' book_body '}'  */
#line 946 "parser.yy"
                                {
		yyval = yyvsp[-1];
		unsmob<Book> (yyval)->origin ()->set_spot ((yyloc));
		pop_paper (parser);
		parser->lexer_->set_identifier (ly_symbol2scm ("$current-book"), SCM_BOOL_F);
	}
#line 4187 "./out/parser.cc"
    break;

  case 117: /* book_body: %empty  */
#line 958 "parser.yy"
        {
		Book *book = new Book;
		init_papers (parser);
		book->paper_ = unsmob<Output_def> (parser->lexer_->lookup_identifier ("$defaultpaper"))->clone ();
		book->paper_->unprotect ();
		push_paper (parser, book->paper_);
		book->header_ = get_header (parser);
                yyval = book->unprotect ();
		parser->lexer_->set_identifier (ly_symbol2scm ("$current-book"), yyval);
	}
#line 4202 "./out/parser.cc"
    break;

  case 118: /* book_body: BOOK_IDENTIFIER  */
#line 968 "parser.yy"
                          {
		parser->lexer_->set_identifier (ly_symbol2scm ("$current-book"), yyvsp[0]);
	}
#line 4210 "./out/parser.cc"
    break;

  case 119: /* book_body: book_body paper_block  */
#line 971 "parser.yy"
                                {
		unsmob<Book> (yyvsp[-1])->paper_ = unsmob<Output_def> (yyvsp[0]);
		set_paper (parser, unsmob<Output_def> (yyvsp[0]));
	}
#line 4219 "./out/parser.cc"
    break;

  case 120: /* book_body: book_body bookpart_block  */
#line 975 "parser.yy"
                                   {
		SCM proc = parser->lexer_->lookup_identifier ("book-bookpart-handler");
		scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
	}
#line 4228 "./out/parser.cc"
    break;

  case 121: /* book_body: book_body score_block  */
#line 979 "parser.yy"
                                {
		SCM proc = parser->lexer_->lookup_identifier ("book-score-handler");
		scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
	}
#line 4237 "./out/parser.cc"
    break;

  case 122: /* book_body: book_body composite_music  */
#line 983 "parser.yy"
                                    {
		SCM proc = parser->lexer_->lookup_identifier ("book-music-handler");
		scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
	}
#line 4246 "./out/parser.cc"
    break;

  case 123: /* book_body: book_body full_markup  */
#line 987 "parser.yy"
                                {
		SCM proc = parser->lexer_->lookup_identifier ("book-text-handler");
		scm_call_2 (proc, yyvsp[-1], scm_list_1 (yyvsp[0]));
	}
#line 4255 "./out/parser.cc"
    break;

  case 124: /* book_body: book_body full_markup_list  */
#line 991 "parser.yy"
                                     {
		SCM proc = parser->lexer_->lookup_identifier ("book-text-handler");
		scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
	}
#line 4264 "./out/parser.cc"
    break;

  case 125: /* book_body: book_body SCM_TOKEN  */
#line 995 "parser.yy"
                              {
		// Evaluate and ignore #xxx, as opposed to \xxx
		parser->lexer_->eval_scm_token (yyvsp[0], (yylsp[0]));
	}
#line 4273 "./out/parser.cc"
    break;

  case 126: /* book_body: book_body embedded_scm_active  */
#line 1000 "parser.yy"
        {
		SCM out = SCM_UNDEFINED;
		if (Text_interface::is_markup (yyvsp[0]))
			out = scm_list_1 (yyvsp[0]);
		else if (Text_interface::is_markup_list (yyvsp[0]))
			out = yyvsp[0];
		if (scm_is_pair (out))
		{
			SCM proc = parser->lexer_->lookup_identifier ("book-text-handler");
			scm_call_2 (proc, yyvsp[-1], out);
		} else if (unsmob<Score> (yyvsp[0]))
		{
			SCM proc = parser->lexer_->lookup_identifier ("book-score-handler");
			scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
		} else if (Output_def *od = unsmob<Output_def> (yyvsp[0])) {
			if (from_scm<bool> (od->lookup_variable (ly_symbol2scm ("is-paper")))) {
				unsmob<Book> (yyvsp[-1])->paper_ = od;
				set_paper (parser, od);
			} else {
				parser->parser_error ((yylsp[0]), _ ("need \\paper for paper block"));
			}
		} else if (ly_is_module (yyvsp[0]))
		{
			ly_module_copy (unsmob<Book> (yyvsp[-1])->header_, yyvsp[0]);
		} else if (!scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
			parser->parser_error ((yylsp[0]), _("bad expression type"));
	}
#line 4305 "./out/parser.cc"
    break;

  case 127: /* $@4: %empty  */
#line 1028 "parser.yy"
        {
		parser->lexer_->add_scope (unsmob<Book> (yyvsp[0])->header_);
	}
#line 4313 "./out/parser.cc"
    break;

  case 129: /* book_body: book_body error  */
#line 1031 "parser.yy"
                          {
                Book *book = unsmob<Book> (yyvsp[-1]);
		book->paper_ = 0;
		book->scores_ = SCM_EOL;
		book->bookparts_ = SCM_EOL;
	}
#line 4324 "./out/parser.cc"
    break;

  case 130: /* bookpart_block: "\\bookpart" '{' bookpart_body '}'  */
#line 1040 "parser.yy"
                                       {
		yyval = yyvsp[-1];
		unsmob<Book> (yyval)->origin ()->set_spot ((yyloc));
		parser->lexer_->set_identifier (ly_symbol2scm ("$current-bookpart"), SCM_BOOL_F);
	}
#line 4334 "./out/parser.cc"
    break;

  case 131: /* bookpart_body: %empty  */
#line 1048 "parser.yy"
        {
		Book *book = new Book;
                yyval = book->unprotect ();
		parser->lexer_->set_identifier (ly_symbol2scm ("$current-bookpart"), yyval);
	}
#line 4344 "./out/parser.cc"
    break;

  case 132: /* bookpart_body: BOOK_IDENTIFIER  */
#line 1053 "parser.yy"
                          {
		parser->lexer_->set_identifier (ly_symbol2scm ("$current-bookpart"), yyvsp[0]);
	}
#line 4352 "./out/parser.cc"
    break;

  case 133: /* bookpart_body: bookpart_body paper_block  */
#line 1056 "parser.yy"
                                    {
		unsmob<Book> (yyval)->paper_ = unsmob<Output_def> (yyvsp[0]);
	}
#line 4360 "./out/parser.cc"
    break;

  case 134: /* bookpart_body: bookpart_body score_block  */
#line 1059 "parser.yy"
                                    {
		SCM proc = parser->lexer_->lookup_identifier ("bookpart-score-handler");
		scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
	}
#line 4369 "./out/parser.cc"
    break;

  case 135: /* bookpart_body: bookpart_body composite_music  */
#line 1063 "parser.yy"
                                        {
		SCM proc = parser->lexer_->lookup_identifier ("bookpart-music-handler");
		scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
	}
#line 4378 "./out/parser.cc"
    break;

  case 136: /* bookpart_body: bookpart_body full_markup  */
#line 1067 "parser.yy"
                                    {
		SCM proc = parser->lexer_->lookup_identifier ("bookpart-text-handler");
		scm_call_2 (proc, yyvsp[-1], scm_list_1 (yyvsp[0]));
	}
#line 4387 "./out/parser.cc"
    break;

  case 137: /* bookpart_body: bookpart_body full_markup_list  */
#line 1071 "parser.yy"
                                         {
		SCM proc = parser->lexer_->lookup_identifier ("bookpart-text-handler");
		scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
	}
#line 4396 "./out/parser.cc"
    break;

  case 138: /* bookpart_body: bookpart_body SCM_TOKEN  */
#line 1075 "parser.yy"
                                  {
		// Evaluate and ignore #xxx, as opposed to \xxx
		parser->lexer_->eval_scm_token (yyvsp[0], (yylsp[0]));
	}
#line 4405 "./out/parser.cc"
    break;

  case 139: /* bookpart_body: bookpart_body embedded_scm_active  */
#line 1080 "parser.yy"
        {
		SCM out = SCM_UNDEFINED;
		if (Text_interface::is_markup (yyvsp[0]))
			out = scm_list_1 (yyvsp[0]);
		else if (Text_interface::is_markup_list (yyvsp[0]))
			out = yyvsp[0];
		if (scm_is_pair (out))
		{
			SCM proc = parser->lexer_->lookup_identifier ("bookpart-text-handler");
			scm_call_2 (proc, yyvsp[-1], out);
		} else if (unsmob<Score> (yyvsp[0]))
		{
			SCM proc = parser->lexer_->lookup_identifier ("bookpart-score-handler");
			scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
		} else if (Output_def *od = unsmob<Output_def> (yyvsp[0])) {
			if (from_scm<bool> (od->lookup_variable (ly_symbol2scm ("is-paper")))) {
				unsmob<Book> (yyvsp[-1])->paper_ = od;
			} else {
				parser->parser_error ((yylsp[0]), _ ("need \\paper for paper block"));
			}
		} else if (ly_is_module (yyvsp[0])) {
			Book *book = unsmob<Book> (yyvsp[-1]);
			if (!ly_is_module (book->header_))
				book->header_ = ly_make_module (false);
			ly_module_copy (book->header_, yyvsp[0]);
		} else if (!scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
			parser->parser_error ((yylsp[0]), _("bad expression type"));
	}
#line 4438 "./out/parser.cc"
    break;

  case 140: /* $@5: %empty  */
#line 1109 "parser.yy"
        {
                Book *book = unsmob<Book> (yyvsp[0]);
		if (!ly_is_module (book->header_))
			book->header_ = ly_make_module (false);
		parser->lexer_->add_scope (book->header_);
	}
#line 4449 "./out/parser.cc"
    break;

  case 142: /* bookpart_body: bookpart_body error  */
#line 1115 "parser.yy"
                              {
                Book *book = unsmob<Book> (yyvsp[-1]);
		book->paper_ = 0;
		book->scores_ = SCM_EOL;
	}
#line 4459 "./out/parser.cc"
    break;

  case 143: /* score_block: "\\score" '{' score_body '}'  */
#line 1123 "parser.yy"
                                        {
		unsmob<Score> (yyvsp[-1])->origin ()->set_spot ((yyloc));
		yyval = yyvsp[-1];
	}
#line 4468 "./out/parser.cc"
    break;

  case 144: /* score_body: score_items  */
#line 1130 "parser.yy"
                    {
		if (!unsmob<Score> (yyvsp[0])) {
			parser->parser_error ((yylsp[0]), _("Missing music in \\score"));
			yyval = (new Score)->unprotect ();
			if (scm_is_pair (yyvsp[0]) && ly_is_module (scm_car (yyvsp[0])))
			{
				unsmob<Score> (yyval)->set_header (scm_car (yyvsp[0]));
				yyvsp[0] = scm_cdr (yyvsp[0]);
			}
			for (SCM p = scm_reverse_x (yyvsp[0], SCM_EOL);
			     scm_is_pair (p); p = scm_cdr (p))
			{
				unsmob<Score> (yyval)->
					add_output_def (unsmob<Output_def> (scm_car (p)));
			}
		}
	}
#line 4490 "./out/parser.cc"
    break;

  case 145: /* score_body: score_body error  */
#line 1147 "parser.yy"
                           {
		unsmob<Score> (yyval)->error_found_ = true;
	}
#line 4498 "./out/parser.cc"
    break;

  case 149: /* score_items: %empty  */
#line 1160 "parser.yy"
        {
		yyval = SCM_EOL;
	}
#line 4506 "./out/parser.cc"
    break;

  case 150: /* score_items: score_items score_item  */
#line 1164 "parser.yy"
        {
		Output_def *od = unsmob<Output_def> (yyvsp[0]);
		if (od) {
			if (from_scm<bool> (od->lookup_variable (ly_symbol2scm ("is-paper"))))
			{
				parser->parser_error ((yylsp[0]), _("\\paper cannot be used in \\score, use \\layout instead"));
				od = 0;
				yyvsp[0] = SCM_UNSPECIFIED;
			}
		} else if (!unsmob<Score> (yyval)) {
			if (unsmob<Music> (yyvsp[0])) {
				yyvsp[0] = Lily::scorify_music (yyvsp[0]);
			}
			if (unsmob<Score> (yyvsp[0]))
			{
				yyval = yyvsp[0];
				yyvsp[0] = SCM_UNSPECIFIED;
			}
		}
		Score *score = unsmob<Score> (yyval);
		if (score && scm_is_pair (yyvsp[-1])) {
			if (ly_is_module (scm_car (yyvsp[-1])))
			{
				score->set_header (scm_car (yyvsp[-1]));
				yyvsp[-1] = scm_cdr (yyvsp[-1]);
			}
			for (SCM p = scm_reverse_x (yyvsp[-1], SCM_EOL);
			     scm_is_pair (p); p = scm_cdr (p))
			{
				score->add_output_def (unsmob<Output_def> (scm_car (p)));
			}
		}
		if (od) {
			if (score)
				score->add_output_def (od);
			else if (scm_is_pair (yyval) && ly_is_module (scm_car (yyval)))
				scm_set_cdr_x (yyval, scm_cons (yyvsp[0], scm_cdr (yyval)));
			else
				yyval = scm_cons (yyvsp[0], yyval);
		} else if (ly_is_module (yyvsp[0])) {
			SCM module = SCM_UNSPECIFIED;
			if (score) {
				module = score->get_header ();
				if (!ly_is_module (module))
				{
					module = ly_make_module (false);
					score->set_header (module);
				}
			} else if (scm_is_pair (yyval) && ly_is_module (scm_car (yyval)))
				module = scm_car (yyval);
			else {
				module = ly_make_module (false);
				yyval = scm_cons (module, yyval);
			}
			ly_module_copy (module, yyvsp[0]);
		} else if (!scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
			parser->parser_error ((yylsp[0]), _("Spurious expression in \\score"));
	}
#line 4569 "./out/parser.cc"
    break;

  case 151: /* $@6: %empty  */
#line 1223 "parser.yy"
        {
		if (Score *score = unsmob<Score> (yyvsp[0])) {
			if (!ly_is_module (score->get_header ()))
				score->set_header (ly_make_module (false));
			parser->lexer_->add_scope (score->get_header ());
		} else {
			if (!scm_is_pair (yyvsp[0]) || !ly_is_module (scm_car (yyvsp[0])))
				yyvsp[0] = scm_cons (ly_make_module (false), yyvsp[0]);
			parser->lexer_->add_scope (scm_car (yyvsp[0]));
		}
	}
#line 4585 "./out/parser.cc"
    break;

  case 152: /* score_items: score_items $@6 lilypond_header  */
#line 1234 "parser.yy"
        {
		yyval = yyvsp[-2];
	}
#line 4593 "./out/parser.cc"
    break;

  case 153: /* paper_block: output_def  */
#line 1245 "parser.yy"
                   {
                Output_def *od = unsmob<Output_def> (yyvsp[0]);

		if (!from_scm<bool> (od->lookup_variable (ly_symbol2scm ("is-paper"))))
		{
			parser->parser_error ((yylsp[0]), _ ("need \\paper for paper block"));
			yyval = get_paper (parser)->unprotect ();
		}
	}
#line 4607 "./out/parser.cc"
    break;

  case 154: /* output_def: output_def_body '}'  */
#line 1258 "parser.yy"
                            {
		if (scm_is_pair (yyvsp[-1]))
			yyval = scm_car (yyvsp[-1]);

		parser->lexer_->remove_scope ();
		parser->lexer_->pop_state ();
	}
#line 4619 "./out/parser.cc"
    break;

  case 155: /* output_def_head: "\\paper"  */
#line 1268 "parser.yy"
              {
                Output_def *p = get_paper (parser);
		p->input_origin_ = (yyloc);
		parser->lexer_->add_scope (p->scope_);
                yyval = p->unprotect ();
	}
#line 4630 "./out/parser.cc"
    break;

  case 156: /* output_def_head: "\\midi"  */
#line 1274 "parser.yy"
                  {
		Output_def *p = get_midi (parser);
		yyval = p->unprotect ();
		parser->lexer_->add_scope (p->scope_);
	}
#line 4640 "./out/parser.cc"
    break;

  case 157: /* output_def_head: "\\layout"  */
#line 1279 "parser.yy"
                        {
		Output_def *p = get_layout (parser);

		parser->lexer_->add_scope (p->scope_);
		yyval = p->unprotect ();
	}
#line 4651 "./out/parser.cc"
    break;

  case 158: /* output_def_head_with_mode_switch: output_def_head  */
#line 1288 "parser.yy"
                        {
		parser->lexer_->push_initial_state ();
		yyval = yyvsp[0];
	}
#line 4660 "./out/parser.cc"
    break;

  case 161: /* output_def_body: output_def_head_with_mode_switch '{'  */
#line 1305 "parser.yy"
                                             {
		unsmob<Output_def> (yyvsp[-1])->input_origin_.set_spot ((yyloc));
		// This is a stupid trick to mark the beginning of the
		// body for deciding whether to allow
		// embedded_scm_active to have an output definition
		yyval = scm_list_1 (yyvsp[-1]);
	}
#line 4672 "./out/parser.cc"
    break;

  case 162: /* output_def_body: output_def_body assignment  */
#line 1312 "parser.yy"
                                      {
		if (scm_is_pair (yyvsp[-1]))
			yyval = scm_car (yyvsp[-1]);
	}
#line 4681 "./out/parser.cc"
    break;

  case 163: /* output_def_body: output_def_body embedded_scm_active  */
#line 1317 "parser.yy"
        {
		// We don't switch into note mode for Scheme functions
		// here.  Does not seem warranted/required in output
		// definitions.
		if (scm_is_pair (yyvsp[-1]))
		{
			Output_def *o = unsmob<Output_def> (yyvsp[0]);
			if (o) {
				o->input_origin_.set_spot ((yyloc));
				yyvsp[-1] = o->self_scm ();
				parser->lexer_->remove_scope ();
				parser->lexer_->add_scope (o->scope_);
				yyvsp[0] = SCM_UNSPECIFIED;
			} else
				yyvsp[-1] = scm_car (yyvsp[-1]);
		}
		if (unsmob<Context_def> (yyvsp[0]))
			assign_context_def (unsmob<Output_def> (yyvsp[-1]), yyvsp[0]);
		// Seems unlikely, but let's be complete:
		else if (unsmob<Music> (yyvsp[0]))
		{
			SCM proc = parser->lexer_->lookup_identifier
				("output-def-music-handler");
			scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
		} else if (!scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
			parser->parser_error ((yylsp[0]), _("bad expression type"));
		yyval = yyvsp[-1];
	}
#line 4714 "./out/parser.cc"
    break;

  case 164: /* output_def_body: output_def_body SCM_TOKEN  */
#line 1345 "parser.yy"
                                    {
		if (scm_is_pair (yyvsp[-1]))
			yyval = scm_car (yyvsp[-1]);
		// Evaluate and ignore #xxx, as opposed to \xxx
		parser->lexer_->eval_scm_token (yyvsp[0], (yylsp[0]));
	}
#line 4725 "./out/parser.cc"
    break;

  case 165: /* $@7: %empty  */
#line 1352 "parser.yy"
        {
		if (scm_is_pair (yyvsp[0]))
			yyvsp[0] = scm_car (yyvsp[0]);
		parser->lexer_->push_note_state (Lily::pitchnames);
	}
#line 4735 "./out/parser.cc"
    break;

  case 166: /* output_def_body: output_def_body $@7 music_or_context_def  */
#line 1357 "parser.yy"
        {
		parser->lexer_->pop_state ();
		if (unsmob<Context_def> (yyvsp[0]))
			assign_context_def (unsmob<Output_def> (yyvsp[-2]), yyvsp[0]);
		else {

			SCM proc = parser->lexer_->lookup_identifier
				     ("output-def-music-handler");
			scm_call_2 (proc, yyvsp[-2], yyvsp[0]);
		}
		yyval = yyvsp[-2];
	}
#line 4752 "./out/parser.cc"
    break;

  case 167: /* output_def_body: output_def_body error  */
#line 1369 "parser.yy"
                                {

	}
#line 4760 "./out/parser.cc"
    break;

  case 168: /* tempo_event: "\\tempo" steno_duration '=' tempo_range  */
#line 1375 "parser.yy"
                                                {
		yyval = MAKE_SYNTAX (tempo, (yyloc), SCM_EOL, yyvsp[-2], yyvsp[0]);
	}
#line 4768 "./out/parser.cc"
    break;

  case 169: /* tempo_event: "\\tempo" text steno_duration '=' tempo_range  */
#line 1378 "parser.yy"
                                                        {
		yyval = MAKE_SYNTAX (tempo, (yyloc), yyvsp[-3], yyvsp[-2], yyvsp[0]);
	}
#line 4776 "./out/parser.cc"
    break;

  case 170: /* tempo_event: "\\tempo" text  */
#line 1381 "parser.yy"
                     {
		yyval = MAKE_SYNTAX (tempo, (yyloc), yyvsp[0]);
	}
#line 4784 "./out/parser.cc"
    break;

  case 171: /* music_list: %empty  */
#line 1390 "parser.yy"
                    {
		yyval = SCM_EOL;
	}
#line 4792 "./out/parser.cc"
    break;

  case 172: /* music_list: music_list music_embedded  */
#line 1393 "parser.yy"
                                    {
		if (unsmob<Music> (yyvsp[0]))
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
	}
#line 4801 "./out/parser.cc"
    break;

  case 173: /* music_list: music_list error  */
#line 1397 "parser.yy"
                           {
		Music *m = MY_MAKE_MUSIC("Music", (yyloc));
		// ugh. code dup
		set_property (m, "error-found", SCM_BOOL_T);
		yyval = scm_cons (m->self_scm (), yyvsp[-1]);
		m->unprotect (); /* UGH */
	}
#line 4813 "./out/parser.cc"
    break;

  case 174: /* braced_music_list: '{' music_list '}'  */
#line 1408 "parser.yy"
        {
		yyval = reverse_music_list (parser, (yyloc), yyvsp[-1], true, false);
	}
#line 4821 "./out/parser.cc"
    break;

  case 178: /* pitch_as_music: pitch_or_music  */
#line 1420 "parser.yy"
        {
	        yyval = make_music_from_simple (parser, (yylsp[0]), yyvsp[0]);
                if (!unsmob<Music> (yyval))
		{
                        parser->parser_error ((yylsp[0]), _ ("music expected"));
			yyval = MAKE_SYNTAX (void_music, (yyloc));
		}
	}
#line 4834 "./out/parser.cc"
    break;

  case 181: /* music_embedded: music_embedded_backup  */
#line 1434 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 4842 "./out/parser.cc"
    break;

  case 182: /* music_embedded: music_embedded_backup "(backed-up?)" lyric_element_music  */
#line 1438 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 4850 "./out/parser.cc"
    break;

  case 183: /* music_embedded: duration post_events  */
#line 1442 "parser.yy"
        {
		Music *n = MY_MAKE_MUSIC ("NoteEvent", (yyloc));

		parser->default_duration_ = *unsmob<Duration> (yyvsp[-1]);
		set_property (n, "duration", yyvsp[-1]);

		if (scm_is_pair (yyvsp[0]))
			set_property (n, "articulations",
					 scm_reverse_x (yyvsp[0], SCM_EOL));
		yyval = n->unprotect ();
	}
#line 4866 "./out/parser.cc"
    break;

  case 184: /* music_embedded_backup: embedded_scm  */
#line 1457 "parser.yy"
        {
		if (scm_is_eq (yyvsp[0], SCM_UNSPECIFIED)
		    || unsmob<Music> (yyvsp[0]))
			yyval = yyvsp[0];
		else if (parser->lexer_->is_lyric_state ()
			   && Text_interface::is_markup (yyvsp[0]))
			MYBACKUP (LYRIC_ELEMENT, yyvsp[0], (yylsp[0]));
		else {
			(yyloc).warning (_ ("Ignoring non-music expression"));
			yyval = SCM_UNSPECIFIED;
		}
	}
#line 4883 "./out/parser.cc"
    break;

  case 187: /* repeated_music: "\\repeat" simple_string unsigned_number music  */
#line 1480 "parser.yy"
        {
		yyval = MAKE_SYNTAX (repeat, (yyloc), yyvsp[-2], yyvsp[-1], yyvsp[0], SCM_EOL);
	}
#line 4891 "./out/parser.cc"
    break;

  case 188: /* repeated_music: "\\repeat" simple_string unsigned_number music "\\alternative" braced_music_list  */
#line 1484 "parser.yy"
        {
		yyval = MAKE_SYNTAX (repeat, (yyloc), yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[0]);
	}
#line 4899 "./out/parser.cc"
    break;

  case 189: /* sequential_music: "\\sequential" braced_music_list  */
#line 1490 "parser.yy"
                                     {
		yyval = MAKE_SYNTAX (sequential_music, (yyloc), yyvsp[0]);
	}
#line 4907 "./out/parser.cc"
    break;

  case 190: /* sequential_music: braced_music_list  */
#line 1493 "parser.yy"
                            {
		yyval = MAKE_SYNTAX (sequential_music, (yyloc), yyvsp[0]);
	}
#line 4915 "./out/parser.cc"
    break;

  case 191: /* simultaneous_music: "\\simultaneous" braced_music_list  */
#line 1499 "parser.yy"
                                       {
		yyval = MAKE_SYNTAX (simultaneous_music, (yyloc), yyvsp[0]);
	}
#line 4923 "./out/parser.cc"
    break;

  case 192: /* simultaneous_music: "<<" music_list ">>"  */
#line 1502 "parser.yy"
                                                                {
		yyval = MAKE_SYNTAX (simultaneous_music, (yyloc),
				  reverse_music_list (parser, (yyloc), yyvsp[-1],
						      true, false));
	}
#line 4933 "./out/parser.cc"
    break;

  case 196: /* $@8: %empty  */
#line 1517 "parser.yy"
        {
		parser->lexer_->push_note_state (Lily::pitchnames);
	}
#line 4941 "./out/parser.cc"
    break;

  case 197: /* context_modification: "\\with" $@8 '{' context_mod_list '}'  */
#line 1520 "parser.yy"
        {
                parser->lexer_->pop_state ();
                yyval = yyvsp[-1];
        }
#line 4950 "./out/parser.cc"
    break;

  case 198: /* context_modification: "\\with" context_modification_arg  */
#line 1525 "parser.yy"
        {
		if (unsmob<Music> (yyvsp[0])) {
			SCM proc = parser->lexer_->lookup_identifier ("context-mod-music-handler");
			yyvsp[0] = scm_call_1 (proc, yyvsp[0]);
		}
		if (unsmob<Context_mod> (yyvsp[0]))
			yyval = yyvsp[0];
		else {
			// let's permit \with #*unspecified* to go for
			// an empty context mod
			if (!scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
				parser->parser_error ((yylsp[0]), _ ("not a context mod"));
			yyval = Context_mod ().smobbed_copy ();
		}
	}
#line 4970 "./out/parser.cc"
    break;

  case 201: /* optional_context_mods: context_modification_mods_list  */
#line 1553 "parser.yy"
        {
		if (scm_is_pair (yyvsp[0]))
			yyval = scm_append_x (scm_reverse_x (yyvsp[0], SCM_EOL));
        }
#line 4979 "./out/parser.cc"
    break;

  case 202: /* context_modification_mods_list: %empty  */
#line 1566 "parser.yy"
             {
		yyval = SCM_EOL;
	}
#line 4987 "./out/parser.cc"
    break;

  case 203: /* context_modification_mods_list: context_modification_mods_list context_modification  */
#line 1570 "parser.yy"
        {
		if (Context_mod *m = unsmob<Context_mod> (yyvsp[0]))
			yyval = scm_cons (m->get_mods (), yyvsp[-1]);
	}
#line 4996 "./out/parser.cc"
    break;

  case 204: /* context_mod_list: %empty  */
#line 1582 "parser.yy"
             {
            yyval = Context_mod ().smobbed_copy ();
        }
#line 5004 "./out/parser.cc"
    break;

  case 205: /* context_mod_list: context_mod_list context_mod  */
#line 1585 "parser.yy"
                                        {
		if (!SCM_UNBNDP (yyvsp[0]))
			unsmob<Context_mod> (yyvsp[-1])->add_context_mod (yyvsp[0]);
        }
#line 5013 "./out/parser.cc"
    break;

  case 206: /* context_mod_list: context_mod_list context_mod_arg  */
#line 1589 "parser.yy"
                                           {
		if (unsmob<Music> (yyvsp[0])) {
			SCM proc = parser->lexer_->lookup_identifier ("context-mod-music-handler");
			yyvsp[0] = scm_call_1 (proc, yyvsp[0]);
		}
		if (unsmob<Context_mod> (yyvsp[0]))
			unsmob<Context_mod> (yyval)->add_context_mods
				(unsmob<Context_mod> (yyvsp[0])->get_mods ());
		else if (!scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
			parser->parser_error ((yylsp[0]), _ ("not a context mod"));
        }
#line 5029 "./out/parser.cc"
    break;

  case 207: /* context_prefix: "\\context" symbol optional_id optional_context_mods  */
#line 1603 "parser.yy"
                                                         {
		yyval = START_MAKE_SYNTAX (context_find_or_create, yyvsp[-2], yyvsp[-1], yyvsp[0]);
	}
#line 5037 "./out/parser.cc"
    break;

  case 208: /* context_prefix: "\\new" symbol optional_id optional_context_mods  */
#line 1606 "parser.yy"
                                                              {
		yyval = START_MAKE_SYNTAX (context_create, yyvsp[-2], yyvsp[-1], yyvsp[0]);
	}
#line 5045 "./out/parser.cc"
    break;

  case 209: /* new_lyrics: "\\addlyrics" optional_context_mods lyric_mode_music  */
#line 1612 "parser.yy"
                                                         {
		yyval = scm_acons (yyvsp[0], yyvsp[-1], SCM_EOL);
	}
#line 5053 "./out/parser.cc"
    break;

  case 210: /* new_lyrics: new_lyrics "\\addlyrics" optional_context_mods lyric_mode_music  */
#line 1615 "parser.yy"
                                                                      {
		yyval = scm_acons (yyvsp[0], yyvsp[-1], yyvsp[-3]);
	}
#line 5061 "./out/parser.cc"
    break;

  case 214: /* basic_music: "\\lyricsto" simple_string lyric_mode_music  */
#line 1640 "parser.yy"
                                                  {
		yyval = MAKE_SYNTAX (lyric_combine, (yyloc), yyvsp[-1], SCM_EOL, yyvsp[0]);
	}
#line 5069 "./out/parser.cc"
    break;

  case 215: /* basic_music: "\\lyricsto" symbol '=' simple_string lyric_mode_music  */
#line 1644 "parser.yy"
        {
		yyval = MAKE_SYNTAX (lyric_combine, (yyloc), yyvsp[-1], yyvsp[-3], yyvsp[0]);
	}
#line 5077 "./out/parser.cc"
    break;

  case 219: /* contexted_basic_music: context_prefix contextable_music new_lyrics  */
#line 1657 "parser.yy"
        {
		Input i;
		i.set_location ((yylsp[-2]), (yylsp[-1]));
		yyval = FINISH_MAKE_SYNTAX (yyvsp[-2], i, yyvsp[-1]);
		yyval = MAKE_SYNTAX (add_lyrics, (yyloc), yyval, scm_reverse_x (yyvsp[0], SCM_EOL));
	}
#line 5088 "./out/parser.cc"
    break;

  case 220: /* contexted_basic_music: context_prefix contextable_music  */
#line 1664 "parser.yy"
        {
		yyval = FINISH_MAKE_SYNTAX (yyvsp[-1], (yyloc), yyvsp[0]);
	}
#line 5096 "./out/parser.cc"
    break;

  case 221: /* contexted_basic_music: context_prefix contexted_basic_music  */
#line 1668 "parser.yy"
        {
		yyval = FINISH_MAKE_SYNTAX (yyvsp[-1], (yyloc), yyvsp[0]);
	}
#line 5104 "./out/parser.cc"
    break;

  case 224: /* composite_music: basic_music new_lyrics  */
#line 1677 "parser.yy"
        {
		yyval = MAKE_SYNTAX (add_lyrics, (yyloc), yyvsp[-1], scm_reverse_x (yyvsp[0], SCM_EOL));
	}
#line 5112 "./out/parser.cc"
    break;

  case 228: /* grouped_music_list: simultaneous_music  */
#line 1689 "parser.yy"
                                        { yyval = yyvsp[0]; }
#line 5118 "./out/parser.cc"
    break;

  case 229: /* grouped_music_list: sequential_music  */
#line 1690 "parser.yy"
                                        { yyval = yyvsp[0]; }
#line 5124 "./out/parser.cc"
    break;

  case 231: /* symbol_list_arg: SYMBOL_LIST '.' symbol_list_rev  */
#line 1749 "parser.yy"
        {
		yyval = scm_append (scm_list_2 (yyvsp[-2], scm_reverse_x (yyvsp[0], SCM_EOL)));
	}
#line 5132 "./out/parser.cc"
    break;

  case 232: /* symbol_list_arg: SYMBOL_LIST ',' symbol_list_rev  */
#line 1753 "parser.yy"
        {
		yyval = scm_append (scm_list_2 (yyvsp[-2], scm_reverse_x (yyvsp[0], SCM_EOL)));
	}
#line 5140 "./out/parser.cc"
    break;

  case 234: /* symbol_list_rev: symbol_list_rev '.' symbol_list_part  */
#line 1761 "parser.yy"
        {
		yyval = scm_append_x (scm_list_2 (yyvsp[0], yyvsp[-2]));
	}
#line 5148 "./out/parser.cc"
    break;

  case 235: /* symbol_list_rev: symbol_list_rev ',' symbol_list_part  */
#line 1765 "parser.yy"
        {
		yyval = scm_append_x (scm_list_2 (yyvsp[0], yyvsp[-2]));
	}
#line 5156 "./out/parser.cc"
    break;

  case 237: /* symbol_list_part: embedded_scm_bare  */
#line 1775 "parser.yy"
        {
		yyval = make_reverse_key_list (yyvsp[0]);
		if (SCM_UNBNDP (yyval)) {
			parser->parser_error ((yylsp[0]), _("not a key"));
			yyval = SCM_EOL;
		}
	}
#line 5168 "./out/parser.cc"
    break;

  case 238: /* symbol_list_element: STRING  */
#line 1787 "parser.yy"
        {
		yyval = scm_string_to_symbol (yyvsp[0]);
	}
#line 5176 "./out/parser.cc"
    break;

  case 240: /* symbol_list_part_bare: SYMBOL  */
#line 1796 "parser.yy"
        {
		yyval = try_word_variants (Lily::key_list_p, yyvsp[0]);
		if (SCM_UNBNDP (yyval)) {
			parser->parser_error ((yylsp[0]), _("not a key"));
			yyval = SCM_EOL;
		} else
			yyval = scm_reverse (yyval);
	}
#line 5189 "./out/parser.cc"
    break;

  case 241: /* symbol_list_part_bare: symbol_list_element  */
#line 1805 "parser.yy"
        {
		yyval = scm_list_1 (yyvsp[0]);
	}
#line 5197 "./out/parser.cc"
    break;

  case 243: /* function_arglist_nonbackup: "optional?" "scheme?" function_arglist_nonbackup post_event_nofinger  */
#line 1813 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-1], yyvsp[-2]);
	}
#line 5205 "./out/parser.cc"
    break;

  case 244: /* function_arglist_nonbackup: "optional?" "scheme?" function_arglist_nonbackup '-' UNSIGNED  */
#line 1817 "parser.yy"
        {
		SCM n = scm_difference (yyvsp[0], SCM_UNDEFINED);
		if (scm_is_true (scm_call_1 (yyvsp[-3], n)))
			yyval = scm_cons (n, yyvsp[-2]);
		else {
			Music *t = MY_MAKE_MUSIC ("FingeringEvent", (yylsp[0]));
			set_property (t, "digit", yyvsp[0]);
			yyval = check_scheme_arg (parser, (yylsp[-1]), t->unprotect (),
					       yyvsp[-2], yyvsp[-3], n);
		}
	}
#line 5221 "./out/parser.cc"
    break;

  case 245: /* function_arglist_nonbackup: "optional?" "scheme?" function_arglist_nonbackup '-' REAL  */
#line 1829 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[-1]),
				       scm_difference (yyvsp[0], SCM_UNDEFINED),
				       yyvsp[-2], yyvsp[-3]);
	}
#line 5231 "./out/parser.cc"
    break;

  case 246: /* function_arglist_nonbackup: "optional?" "scheme?" function_arglist_nonbackup '-' NUMBER_IDENTIFIER  */
#line 1835 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[-1]),
				       scm_difference (yyvsp[0], SCM_UNDEFINED),
				       yyvsp[-2], yyvsp[-3]);
	}
#line 5241 "./out/parser.cc"
    break;

  case 247: /* function_arglist_nonbackup: "optional?" "scheme?" function_arglist_nonbackup embedded_scm_arg  */
#line 1841 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
		else
			yyval = check_scheme_arg (parser, (yylsp[0]),
					       make_music_from_simple
					       (parser, (yylsp[0]), yyvsp[0]),
					       yyvsp[-1], yyvsp[-2], yyvsp[0]);
	}
#line 5255 "./out/parser.cc"
    break;

  case 248: /* function_arglist_nonbackup: "optional?" "scheme?" function_arglist_nonbackup bare_number_common  */
#line 1851 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-1], yyvsp[-2]);
	}
#line 5263 "./out/parser.cc"
    break;

  case 249: /* function_arglist_nonbackup: function_arglist_nonbackup_reparse "(reparsed?)" pitch_or_music  */
#line 1855 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-1], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-2]);
		else
			yyval = check_scheme_arg (parser, (yylsp[0]),
					       make_music_from_simple
					       (parser, (yylsp[0]), yyvsp[0]),
					       yyvsp[-2], yyvsp[-1], yyvsp[0]);
	}
#line 5277 "./out/parser.cc"
    break;

  case 250: /* function_arglist_nonbackup: function_arglist_nonbackup_reparse "(reparsed?)" duration  */
#line 1865 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5285 "./out/parser.cc"
    break;

  case 251: /* function_arglist_nonbackup: function_arglist_nonbackup_reparse "(reparsed?)" reparsed_rhythm  */
#line 1869 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5293 "./out/parser.cc"
    break;

  case 252: /* function_arglist_nonbackup: function_arglist_nonbackup_reparse "(reparsed?)" bare_number_common  */
#line 1873 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5301 "./out/parser.cc"
    break;

  case 253: /* function_arglist_nonbackup: function_arglist_nonbackup_reparse "(reparsed?)" SCM_ARG  */
#line 1877 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5309 "./out/parser.cc"
    break;

  case 254: /* function_arglist_nonbackup: function_arglist_nonbackup_reparse "(reparsed?)" lyric_element_music  */
#line 1881 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5317 "./out/parser.cc"
    break;

  case 255: /* function_arglist_nonbackup: function_arglist_nonbackup_reparse "(reparsed?)" symbol_list_arg  */
#line 1885 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5325 "./out/parser.cc"
    break;

  case 256: /* reparsed_rhythm: DURATION_ARG dots multipliers post_events  */
#line 1893 "parser.yy"
        {
		SCM d = make_duration (yyvsp[-3], scm_to_int (yyvsp[-2]), yyvsp[-1]);
		parser->default_duration_ = *unsmob<Duration> (d);
		yyval = make_music_from_simple (parser, (yyloc), d);
		Music *m = unsmob<Music> (yyval);
		assert (m);
		if (scm_is_pair (yyvsp[0]))
			set_property (m, "articulations",
					 scm_reverse_x (yyvsp[0], SCM_EOL));
	}
#line 5340 "./out/parser.cc"
    break;

  case 257: /* function_arglist_nonbackup_reparse: "optional?" "scheme?" function_arglist_nonbackup SCM_IDENTIFIER  */
#line 1907 "parser.yy"
        {
		yyval = yyvsp[-1];
		SCM res = try_string_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res))
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			else
				MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, res);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple
			   (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], STRING, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5361 "./out/parser.cc"
    break;

  case 258: /* function_arglist_nonbackup_reparse: "optional?" "scheme?" function_arglist_nonbackup pitch  */
#line 1924 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true
		    (scm_call_1
		     (yyvsp[-2], make_music_from_simple
		      (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], PITCH_IDENTIFIER, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5376 "./out/parser.cc"
    break;

  case 259: /* function_arglist_nonbackup_reparse: "optional?" "scheme?" function_arglist_nonbackup steno_tonic_pitch  */
#line 1935 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true
		    (scm_call_1
		     (yyvsp[-2], make_music_from_simple
		      (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], TONICNAME_PITCH, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5391 "./out/parser.cc"
    break;

  case 260: /* function_arglist_nonbackup_reparse: "optional?" "scheme?" function_arglist_nonbackup STRING  */
#line 1946 "parser.yy"
        {
		yyval = yyvsp[-1];
		SCM res = try_string_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res))
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			else
				MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, res);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple
			   (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], STRING, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5412 "./out/parser.cc"
    break;

  case 261: /* function_arglist_nonbackup_reparse: "optional?" "scheme?" function_arglist_nonbackup SYMBOL  */
#line 1963 "parser.yy"
        {
		yyval = yyvsp[-1];
		SCM res = try_word_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res))
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			else
				MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, res);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple
			   (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], STRING, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5433 "./out/parser.cc"
    break;

  case 262: /* function_arglist_nonbackup_reparse: "optional?" "scheme?" function_arglist_nonbackup full_markup  */
#line 1980 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple
			   (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], STRING, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5450 "./out/parser.cc"
    break;

  case 263: /* function_arglist_nonbackup_reparse: "optional?" "scheme?" function_arglist_nonbackup UNSIGNED  */
#line 1993 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			// May be 3 \cm or similar
			MYREPARSE ((yylsp[0]), yyvsp[-2], REAL, yyvsp[0]);
		else if (scm_is_true (scm_call_1 (yyvsp[-2], scm_list_1 (yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, scm_list_1 (yyvsp[0]));
		else {
			SCM d = make_duration (yyvsp[0]);
			if (!SCM_UNBNDP (d)) {
				if (scm_is_true (scm_call_1 (yyvsp[-2], d)))
					MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_IDENTIFIER, d);
				else if (scm_is_true
					 (scm_call_1
					  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), d))))
					MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_ARG, d);
				else
					MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]); // trigger error
			} else
				MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]); // trigger error
		}
	}
#line 5477 "./out/parser.cc"
    break;

  case 264: /* function_arglist_nonbackup_reparse: "optional?" "scheme?" function_arglist_nonbackup DURATION_IDENTIFIER  */
#line 2016 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_IDENTIFIER, yyvsp[0]);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_ARG, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]); // trigger error
	}
#line 5493 "./out/parser.cc"
    break;

  case 266: /* function_arglist_backup: "optional?" "scheme?" function_arglist_backup embedded_scm_arg  */
#line 2035 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
		else {
			yyval = make_music_from_simple (parser, (yylsp[0]), yyvsp[0]);
			if (scm_is_true (scm_call_1 (yyvsp[-2], yyval)))
				yyval = scm_cons (yyval, yyvsp[-1]);
			else
			{
				yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
				MYBACKUP (SCM_ARG, yyvsp[0], (yylsp[0]));
			}
		}
	}
#line 5512 "./out/parser.cc"
    break;

  case 267: /* function_arglist_backup: "optional?" "scheme?" function_arglist_backup post_event_nofinger  */
#line 2050 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
		{
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
		} else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (EVENT_IDENTIFIER, yyvsp[0], (yylsp[0]));
		}
	}
#line 5526 "./out/parser.cc"
    break;

  case 268: /* function_arglist_backup: "optional?" "scheme?" function_arglist_backup pitch  */
#line 2060 "parser.yy"
        {
		if (scm_is_true
		    (scm_call_1
		     (yyvsp[-2], make_music_from_simple
		      (parser, (yylsp[0]), yyvsp[0]))))
		{
			yyval = yyvsp[-1];
			MYREPARSE ((yylsp[0]), yyvsp[-2], PITCH_IDENTIFIER, yyvsp[0]);
		} else if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
		else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (PITCH_IDENTIFIER, yyvsp[0], (yylsp[0]));
		}
	}
#line 5546 "./out/parser.cc"
    break;

  case 269: /* function_arglist_backup: "optional?" "scheme?" function_arglist_backup steno_tonic_pitch  */
#line 2076 "parser.yy"
        {
		if (scm_is_true
		    (scm_call_1
		     (yyvsp[-2], make_music_from_simple
		      (parser, (yylsp[0]), yyvsp[0]))))
		{
			yyval = yyvsp[-1];
			MYREPARSE ((yylsp[0]), yyvsp[-2], TONICNAME_PITCH, yyvsp[0]);
		} else if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
		else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (TONICNAME_PITCH, yyvsp[0], (yylsp[0]));
		}
	}
#line 5566 "./out/parser.cc"
    break;

  case 270: /* function_arglist_backup: "optional?" "scheme?" function_arglist_backup full_markup  */
#line 2092 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
		else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (SCM_IDENTIFIER, yyvsp[0], (yylsp[0]));
		}
	}
#line 5579 "./out/parser.cc"
    break;

  case 271: /* function_arglist_backup: "optional?" "scheme?" function_arglist_backup UNSIGNED  */
#line 2101 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			// May be 3 \cm or similar
			MYREPARSE ((yylsp[0]), yyvsp[-2], REAL, yyvsp[0]);
		else if (scm_is_true (scm_call_1 (yyvsp[-2], scm_list_1 (yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, scm_list_1 (yyvsp[0]));
		else {
			SCM d = make_duration (yyvsp[0]);
			if (!SCM_UNBNDP (d)) {
				if (scm_is_true (scm_call_1 (yyvsp[-2], d)))
					MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_IDENTIFIER, d);
				else if (scm_is_true
					 (scm_call_1
					  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), d))))
					MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_ARG, d);
				else {
					yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
					MYBACKUP (UNSIGNED, yyvsp[0], (yylsp[0]));
				}
			} else {
				yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
				MYBACKUP (UNSIGNED, yyvsp[0], (yylsp[0]));
			}
		}
	}
#line 5610 "./out/parser.cc"
    break;

  case 272: /* function_arglist_backup: "optional?" "scheme?" function_arglist_backup REAL  */
#line 2128 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
		{
			yyval = yyvsp[-1];
			MYREPARSE ((yylsp[0]), yyvsp[-2], REAL, yyvsp[0]);
		} else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (REAL, yyvsp[0], (yylsp[0]));
		}
	}
#line 5625 "./out/parser.cc"
    break;

  case 273: /* function_arglist_backup: "optional?" "scheme?" function_arglist_backup NUMBER_IDENTIFIER  */
#line 2139 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
		{
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
		} else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (NUMBER_IDENTIFIER, yyvsp[0], (yylsp[0]));
		}
	}
#line 5639 "./out/parser.cc"
    break;

  case 274: /* function_arglist_backup: "optional?" "scheme?" function_arglist_backup '-' UNSIGNED  */
#line 2149 "parser.yy"
        {
		SCM n = scm_difference (yyvsp[0], SCM_UNDEFINED);
		if (scm_is_true (scm_call_1 (yyvsp[-3], n))) {
			yyval = yyvsp[-2];
			MYREPARSE ((yylsp[0]), yyvsp[-3], REAL, n);
		} else {
			Music *t = MY_MAKE_MUSIC ("FingeringEvent", (yylsp[0]));
			set_property (t, "digit", yyvsp[0]);
			yyval = t->unprotect ();
			if (scm_is_true (scm_call_1 (yyvsp[-3], yyval)))
				yyval = scm_cons (yyval, yyvsp[-2]);
			else {
				yyval = scm_cons (loc_on_copy (parser, (yylsp[-2]), yyvsp[-4]), yyvsp[-2]);
				MYBACKUP (UNSIGNED, yyvsp[0], (yylsp[0]));
				parser->lexer_->push_extra_token ((yylsp[-1]), '-');
			}
		}
	}
#line 5662 "./out/parser.cc"
    break;

  case 275: /* function_arglist_backup: "optional?" "scheme?" function_arglist_backup '-' REAL  */
#line 2168 "parser.yy"
        {
		SCM n = scm_difference (yyvsp[0], SCM_UNDEFINED);
		if (scm_is_true (scm_call_1 (yyvsp[-3], n))) {
			MYREPARSE ((yylsp[0]), yyvsp[-3], REAL, n);
			yyval = yyvsp[-2];
		} else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-2]), yyvsp[-4]), yyvsp[-2]);
			MYBACKUP (REAL, n, (yylsp[0]));
		}
	}
#line 5677 "./out/parser.cc"
    break;

  case 276: /* function_arglist_backup: "optional?" "scheme?" function_arglist_backup '-' NUMBER_IDENTIFIER  */
#line 2179 "parser.yy"
        {
		SCM n = scm_difference (yyvsp[0], SCM_UNDEFINED);
		if (scm_is_true (scm_call_1 (yyvsp[-3], n))) {
			yyval = scm_cons (n, yyvsp[-2]);
		} else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-2]), yyvsp[-4]), yyvsp[-2]);
			MYBACKUP (NUMBER_IDENTIFIER, n, (yylsp[0]));
		}
	}
#line 5691 "./out/parser.cc"
    break;

  case 277: /* function_arglist_backup: "optional?" "scheme?" function_arglist_backup DURATION_IDENTIFIER  */
#line 2189 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_IDENTIFIER, yyvsp[0]);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_ARG, yyvsp[0]);
		else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (DURATION_IDENTIFIER, yyvsp[0], (yylsp[0]));
		}
	}
#line 5709 "./out/parser.cc"
    break;

  case 278: /* function_arglist_backup: "optional?" "scheme?" function_arglist_backup SCM_IDENTIFIER  */
#line 2203 "parser.yy"
        {
		SCM res = try_string_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res)) {
				yyval = yyvsp[-1];
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			}
			else
				yyval = scm_cons (res, yyvsp[-1]);
		else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (SCM_IDENTIFIER, yyvsp[0], (yylsp[0]));
		}
	}
#line 5728 "./out/parser.cc"
    break;

  case 279: /* function_arglist_backup: "optional?" "scheme?" function_arglist_backup STRING  */
#line 2218 "parser.yy"
        {
		SCM res = try_string_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res)) {
				yyval = yyvsp[-1];
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			}
			else
				yyval = scm_cons (res, yyvsp[-1]);
		else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (STRING, yyvsp[0], (yylsp[0]));
		}
	}
#line 5747 "./out/parser.cc"
    break;

  case 280: /* function_arglist_backup: "optional?" "scheme?" function_arglist_backup SYMBOL  */
#line 2233 "parser.yy"
        {
		SCM res = try_word_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res)) {
				yyval = yyvsp[-1];
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			}
			else
				yyval = scm_cons (res, yyvsp[-1]);
		else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (STRING, yyvsp[0], (yylsp[0]));
		}
	}
#line 5766 "./out/parser.cc"
    break;

  case 281: /* function_arglist_backup: function_arglist_backup "(reparsed?)" pitch_or_music  */
#line 2248 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-1], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-2]);
		else
			yyval = check_scheme_arg (parser, (yylsp[0]),
					       make_music_from_simple
					       (parser, (yylsp[0]), yyvsp[0]),
					       yyvsp[-2], yyvsp[-1]);
	}
#line 5780 "./out/parser.cc"
    break;

  case 282: /* function_arglist_backup: function_arglist_backup "(reparsed?)" bare_number_common  */
#line 2258 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5789 "./out/parser.cc"
    break;

  case 283: /* function_arglist_backup: function_arglist_backup "(reparsed?)" duration  */
#line 2263 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5798 "./out/parser.cc"
    break;

  case 284: /* function_arglist_backup: function_arglist_backup "(reparsed?)" reparsed_rhythm  */
#line 2268 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5807 "./out/parser.cc"
    break;

  case 285: /* function_arglist_backup: function_arglist_backup "(reparsed?)" symbol_list_arg  */
#line 2273 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5815 "./out/parser.cc"
    break;

  case 287: /* function_arglist: "optional?" "scheme?" function_arglist_skip_nonbackup "\\default"  */
#line 2281 "parser.yy"
        {
		yyval = scm_cons (loc_on_copy (parser, (yylsp[0]), yyvsp[-3]), yyvsp[-1]);
	}
#line 5823 "./out/parser.cc"
    break;

  case 289: /* function_arglist_skip_nonbackup: "optional?" "scheme?" function_arglist_skip_nonbackup  */
#line 2289 "parser.yy"
        {
		yyval = scm_cons (loc_on_copy (parser, (yylsp[0]), yyvsp[-2]), yyvsp[0]);
	}
#line 5831 "./out/parser.cc"
    break;

  case 290: /* function_arglist_partial: "scheme?" function_arglist_optional  */
#line 2308 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 5839 "./out/parser.cc"
    break;

  case 291: /* function_arglist_partial: "scheme?" function_arglist_partial_optional  */
#line 2312 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 5847 "./out/parser.cc"
    break;

  case 292: /* function_arglist_partial: "optional?" "scheme?" function_arglist_nonbackup  */
#line 2316 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 5855 "./out/parser.cc"
    break;

  case 293: /* function_arglist_partial: "optional?" "scheme?" function_arglist_partial  */
#line 2320 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 5863 "./out/parser.cc"
    break;

  case 294: /* function_arglist_partial_optional: "scheme?" function_arglist_optional  */
#line 2327 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 5871 "./out/parser.cc"
    break;

  case 295: /* function_arglist_partial_optional: "scheme?" function_arglist_partial_optional  */
#line 2331 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 5879 "./out/parser.cc"
    break;

  case 296: /* function_arglist_partial_optional: "optional?" "scheme?" function_arglist_backup  */
#line 2335 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 5887 "./out/parser.cc"
    break;

  case 297: /* function_arglist_partial_optional: "optional?" "scheme?" function_arglist_partial_optional  */
#line 2339 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 5895 "./out/parser.cc"
    break;

  case 298: /* function_arglist_common: EXPECT_NO_MORE_ARGS  */
#line 2345 "parser.yy"
                            {
		yyval = SCM_EOL;
	}
#line 5903 "./out/parser.cc"
    break;

  case 299: /* function_arglist_common: "scheme?" function_arglist_optional embedded_scm_arg  */
#line 2349 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
		else
			yyval = check_scheme_arg (parser, (yylsp[0]),
					       make_music_from_simple
					       (parser, (yylsp[0]), yyvsp[0]),
					       yyvsp[-1], yyvsp[-2], yyvsp[0]);
	}
#line 5917 "./out/parser.cc"
    break;

  case 300: /* function_arglist_common: "scheme?" function_arglist_optional bare_number_common  */
#line 2359 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-1], yyvsp[-2]);
	}
#line 5926 "./out/parser.cc"
    break;

  case 301: /* function_arglist_common: "scheme?" function_arglist_optional post_event_nofinger  */
#line 2364 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-1], yyvsp[-2]);
	}
#line 5935 "./out/parser.cc"
    break;

  case 302: /* function_arglist_common: "scheme?" function_arglist_optional '-' NUMBER_IDENTIFIER  */
#line 2369 "parser.yy"
        {
		SCM n = scm_difference (yyvsp[0], SCM_UNDEFINED);
		yyval = check_scheme_arg (parser, (yylsp[0]), n, yyvsp[-2], yyvsp[-3]);
	}
#line 5944 "./out/parser.cc"
    break;

  case 303: /* function_arglist_common: function_arglist_common_reparse "(reparsed?)" SCM_ARG  */
#line 2374 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5953 "./out/parser.cc"
    break;

  case 304: /* function_arglist_common: function_arglist_common_reparse "(reparsed?)" lyric_element_music  */
#line 2379 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5962 "./out/parser.cc"
    break;

  case 305: /* function_arglist_common: function_arglist_common_reparse "(reparsed?)" pitch_or_music  */
#line 2384 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-1], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-2]);
		else
			yyval = check_scheme_arg (parser, (yylsp[0]),
					       make_music_from_simple
					       (parser, (yylsp[0]), yyvsp[0]),
					       yyvsp[-2], yyvsp[-1], yyvsp[0]);
	}
#line 5976 "./out/parser.cc"
    break;

  case 306: /* function_arglist_common: function_arglist_common_reparse "(reparsed?)" bare_number_common  */
#line 2394 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5985 "./out/parser.cc"
    break;

  case 307: /* function_arglist_common: function_arglist_common_reparse "(reparsed?)" duration  */
#line 2399 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5994 "./out/parser.cc"
    break;

  case 308: /* function_arglist_common: function_arglist_common_reparse "(reparsed?)" reparsed_rhythm  */
#line 2404 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 6003 "./out/parser.cc"
    break;

  case 309: /* function_arglist_common: function_arglist_common_reparse "(reparsed?)" symbol_list_arg  */
#line 2409 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 6011 "./out/parser.cc"
    break;

  case 310: /* function_arglist_common_reparse: "scheme?" function_arglist_optional SCM_IDENTIFIER  */
#line 2416 "parser.yy"
        {
		yyval = yyvsp[-1];
		SCM res = try_string_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res))
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			else
				MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, res);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], LYRIC_ELEMENT, yyvsp[0]);
		else
			// This is going to flag a syntax error, we
			// know the predicate to be false.
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 6033 "./out/parser.cc"
    break;

  case 311: /* function_arglist_common_reparse: "scheme?" function_arglist_optional pitch  */
#line 2434 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true
		    (scm_call_1
		     (yyvsp[-2], make_music_from_simple
		      (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], PITCH_IDENTIFIER, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 6048 "./out/parser.cc"
    break;

  case 312: /* function_arglist_common_reparse: "scheme?" function_arglist_optional steno_tonic_pitch  */
#line 2445 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true
		    (scm_call_1
		     (yyvsp[-2], make_music_from_simple
		      (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], TONICNAME_PITCH, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 6063 "./out/parser.cc"
    break;

  case 313: /* function_arglist_common_reparse: "scheme?" function_arglist_optional STRING  */
#line 2456 "parser.yy"
        {
		yyval = yyvsp[-1];
		SCM res = try_string_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res))
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			else
				MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, res);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], LYRIC_ELEMENT, yyvsp[0]);
		else
			// This is going to flag a syntax error, we
			// know the predicate to be false.
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 6085 "./out/parser.cc"
    break;

  case 314: /* function_arglist_common_reparse: "scheme?" function_arglist_optional SYMBOL  */
#line 2474 "parser.yy"
        {
		yyval = yyvsp[-1];
		SCM res = try_word_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res))
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			else
				MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, res);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], LYRIC_ELEMENT, yyvsp[0]);
		else
			// This is going to flag a syntax error, we
			// know the predicate to be false.
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 6107 "./out/parser.cc"
    break;

  case 315: /* function_arglist_common_reparse: "scheme?" function_arglist_optional full_markup  */
#line 2492 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], LYRIC_ELEMENT, yyvsp[0]);
		else
			// This is going to flag a syntax error, we
			// know the predicate to be false.
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 6125 "./out/parser.cc"
    break;

  case 316: /* function_arglist_common_reparse: "scheme?" function_arglist_optional UNSIGNED  */
#line 2506 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			// May be 3 \cm or similar
			MYREPARSE ((yylsp[0]), yyvsp[-2], REAL, yyvsp[0]);
		else if (scm_is_true (scm_call_1 (yyvsp[-2], scm_list_1 (yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, scm_list_1 (yyvsp[0]));
		else {
			SCM d = make_duration (yyvsp[0]);
			if (!SCM_UNBNDP (d)) {
				if (scm_is_true (scm_call_1 (yyvsp[-2], d)))
					MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_IDENTIFIER, d);
				else if (scm_is_true
					 (scm_call_1
					  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), d))))
					MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_ARG, d);
				else
					MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]); // trigger error
			} else
				MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]); // trigger error
		}
	}
#line 6152 "./out/parser.cc"
    break;

  case 317: /* function_arglist_common_reparse: "scheme?" function_arglist_optional DURATION_IDENTIFIER  */
#line 2529 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_IDENTIFIER, yyvsp[0]);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_ARG, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]); // trigger error
	}
#line 6168 "./out/parser.cc"
    break;

  case 318: /* function_arglist_common_reparse: "scheme?" function_arglist_optional '-' UNSIGNED  */
#line 2541 "parser.yy"
        {
		yyval = yyvsp[-2];
		SCM n = scm_difference (yyvsp[0], SCM_UNDEFINED);
		if (scm_is_true (scm_call_1 (yyvsp[-3], n)))
			MYREPARSE ((yylsp[0]), yyvsp[-3], REAL, n);
		else {
			Music *t = MY_MAKE_MUSIC ("FingeringEvent", (yylsp[0]));
			set_property (t, "digit", yyvsp[0]);
			SCM m = t->unprotect ();
			if (scm_is_true (scm_call_1 (yyvsp[-3], m)))
				MYREPARSE ((yylsp[0]), yyvsp[-3], SCM_ARG, m);
			else
				MYREPARSE ((yylsp[0]), yyvsp[-3], SCM_ARG, yyvsp[0]);
		}
	}
#line 6188 "./out/parser.cc"
    break;

  case 319: /* function_arglist_common_reparse: "scheme?" function_arglist_optional '-' REAL  */
#line 2557 "parser.yy"
        {
		yyval = yyvsp[-2];
		SCM n = scm_difference (yyvsp[0], SCM_UNDEFINED);
		MYREPARSE ((yylsp[0]), yyvsp[-3], REAL, n);
	}
#line 6198 "./out/parser.cc"
    break;

  case 321: /* function_arglist_optional: "optional?" "scheme?" function_arglist_skip_backup "\\default"  */
#line 2567 "parser.yy"
        {
		yyval = scm_cons (loc_on_copy (parser, (yylsp[0]), yyvsp[-3]), yyvsp[-1]);
	}
#line 6206 "./out/parser.cc"
    break;

  case 324: /* function_arglist_skip_backup: "optional?" "scheme?" function_arglist_skip_backup  */
#line 2576 "parser.yy"
        {
		yyval = scm_cons (loc_on_copy (parser, (yylsp[0]), yyvsp[-2]), yyvsp[0]);
	}
#line 6214 "./out/parser.cc"
    break;

  case 325: /* music_function_call: MUSIC_FUNCTION function_arglist  */
#line 2582 "parser.yy"
                                        {
		yyval = MAKE_SYNTAX (music_function, (yyloc),
				  yyvsp[-1], yyvsp[0]);
	}
#line 6223 "./out/parser.cc"
    break;

  case 326: /* optional_id: %empty  */
#line 2590 "parser.yy"
             { yyval = SCM_EOL; }
#line 6229 "./out/parser.cc"
    break;

  case 327: /* optional_id: '=' simple_string  */
#line 2591 "parser.yy"
                            {
		yyval = yyvsp[0];
	}
#line 6237 "./out/parser.cc"
    break;

  case 328: /* $@9: %empty  */
#line 2603 "parser.yy"
        {
		parser->lexer_->push_lyric_state ();
	}
#line 6245 "./out/parser.cc"
    break;

  case 329: /* lyric_mode_music: $@9 grouped_music_list  */
#line 2606 "parser.yy"
        {
		parser->lexer_->pop_state ();
		yyval = yyvsp[0];
	}
#line 6254 "./out/parser.cc"
    break;

  case 331: /* mode_changed_music: mode_changing_head grouped_music_list  */
#line 2614 "parser.yy"
                                              {
		if (scm_is_eq (yyvsp[-1], ly_symbol2scm ("chords")))
		{
		  yyval = MAKE_SYNTAX (unrelativable_music, (yyloc), yyvsp[0]);
		}
		else
		{
		  yyval = yyvsp[0];
		}
		parser->lexer_->pop_state ();
	}
#line 6270 "./out/parser.cc"
    break;

  case 332: /* mode_changed_music: mode_changing_head_with_context optional_context_mods grouped_music_list  */
#line 2625 "parser.yy"
                                                                                   {
		yyval = MAKE_SYNTAX (context_create, (yyloc), yyvsp[-2], SCM_EOL, yyvsp[-1], yyvsp[0]);
		if (scm_is_eq (yyvsp[-2], ly_symbol2scm ("ChordNames")))
		{
		  yyval = MAKE_SYNTAX (unrelativable_music, (yyloc), yyval);
		}
		parser->lexer_->pop_state ();
	}
#line 6283 "./out/parser.cc"
    break;

  case 333: /* mode_changing_head: "\\notemode"  */
#line 2636 "parser.yy"
                 {
		parser->lexer_->push_note_state (Lily::pitchnames);

		yyval = ly_symbol2scm ("notes");
	}
#line 6293 "./out/parser.cc"
    break;

  case 334: /* mode_changing_head: "\\drummode"  */
#line 2642 "parser.yy"
                {
		parser->lexer_->push_note_state (Lily::drum_pitch_names);

		yyval = ly_symbol2scm ("drums");
	}
#line 6303 "./out/parser.cc"
    break;

  case 335: /* mode_changing_head: "\\figuremode"  */
#line 2647 "parser.yy"
                     {
		parser->lexer_->push_figuredbass_state ();

		yyval = ly_symbol2scm ("figures");
	}
#line 6313 "./out/parser.cc"
    break;

  case 336: /* mode_changing_head: "\\chordmode"  */
#line 2652 "parser.yy"
                    {
		parser->lexer_->chordmodifier_tab_ =
			alist_to_hashq (Lily::chordmodifiers);
		parser->lexer_->push_chord_state (Lily::pitchnames);
		yyval = ly_symbol2scm ("chords");

	}
#line 6325 "./out/parser.cc"
    break;

  case 337: /* mode_changing_head: "\\lyricmode"  */
#line 2660 "parser.yy"
                { parser->lexer_->push_lyric_state ();
		yyval = ly_symbol2scm ("lyrics");
	}
#line 6333 "./out/parser.cc"
    break;

  case 338: /* mode_changing_head_with_context: "\\drums"  */
#line 2666 "parser.yy"
              {
		parser->lexer_->push_note_state (Lily::drum_pitch_names);

		yyval = ly_symbol2scm ("DrumStaff");
	}
#line 6343 "./out/parser.cc"
    break;

  case 339: /* mode_changing_head_with_context: "\\figures"  */
#line 2671 "parser.yy"
                  {
		parser->lexer_->push_figuredbass_state ();

		yyval = ly_symbol2scm ("FiguredBass");
	}
#line 6353 "./out/parser.cc"
    break;

  case 340: /* mode_changing_head_with_context: "\\chords"  */
#line 2676 "parser.yy"
                 {
		parser->lexer_->chordmodifier_tab_ =
			alist_to_hashq (Lily::chordmodifiers);
		parser->lexer_->push_chord_state (Lily::pitchnames);
		yyval = ly_symbol2scm ("ChordNames");
	}
#line 6364 "./out/parser.cc"
    break;

  case 341: /* mode_changing_head_with_context: "\\lyrics"  */
#line 2683 "parser.yy"
                { parser->lexer_->push_lyric_state ();
		yyval = ly_symbol2scm ("Lyrics");
	}
#line 6372 "./out/parser.cc"
    break;

  case 342: /* context_change: "\\change" symbol '=' simple_string  */
#line 2689 "parser.yy"
                                         {
		yyval = MAKE_SYNTAX (context_change, (yyloc), yyvsp[-2], yyvsp[0]);
	}
#line 6380 "./out/parser.cc"
    break;

  case 343: /* property_path: symbol_list_rev  */
#line 2696 "parser.yy"
                         {
		yyval = scm_reverse_x (yyvsp[0], SCM_EOL);
	}
#line 6388 "./out/parser.cc"
    break;

  case 344: /* property_operation: symbol '=' scalar  */
#line 2702 "parser.yy"
                          {
		yyval = scm_list_3 (ly_symbol2scm ("assign"), yyvsp[-2], yyvsp[0]);
	}
#line 6396 "./out/parser.cc"
    break;

  case 345: /* property_operation: "\\unset" symbol  */
#line 2705 "parser.yy"
                       {
		yyval = scm_list_2 (ly_symbol2scm ("unset"), yyvsp[0]);
	}
#line 6404 "./out/parser.cc"
    break;

  case 346: /* property_operation: "\\override" revert_arg '=' scalar  */
#line 2708 "parser.yy"
                                         {
		if (scm_ilength (yyvsp[-2]) < 2) {
			parser->parser_error ((yylsp[-2]), _("bad grob property path"));
			yyval = SCM_UNDEFINED;
		} else {
			yyval = scm_cons (ly_symbol2scm ("push"),
				       scm_cons2 (scm_car (yyvsp[-2]),
						  yyvsp[0],
						  scm_cdr (yyvsp[-2])));
		}
	}
#line 6420 "./out/parser.cc"
    break;

  case 347: /* property_operation: "\\revert" revert_arg  */
#line 2719 "parser.yy"
                            {
		yyval = scm_cons (ly_symbol2scm ("pop"), yyvsp[0]);
	}
#line 6428 "./out/parser.cc"
    break;

  case 348: /* revert_arg: revert_arg_backup "(backed-up?)" symbol_list_arg  */
#line 2749 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 6436 "./out/parser.cc"
    break;

  case 349: /* revert_arg_backup: revert_arg_part  */
#line 2756 "parser.yy"
        {
		if (scm_is_null (yyvsp[0])
		    || scm_is_null (scm_cdr (yyvsp[0])))
			MYBACKUP (SCM_ARG, yyvsp[0], (yylsp[0]));
		else
			MYBACKUP (SYMBOL_LIST, scm_reverse_x (yyvsp[0], SCM_EOL), (yylsp[0]));
	}
#line 6448 "./out/parser.cc"
    break;

  case 351: /* revert_arg_part: revert_arg_backup "(backed-up?)" SCM_ARG '.' symbol_list_part  */
#line 2769 "parser.yy"
        {
		yyval = scm_append_x (scm_list_2 (yyvsp[0], yyvsp[-2]));
	}
#line 6456 "./out/parser.cc"
    break;

  case 352: /* revert_arg_part: revert_arg_backup "(backed-up?)" SCM_ARG ',' symbol_list_part  */
#line 2773 "parser.yy"
        {
		yyval = scm_append_x (scm_list_2 (yyvsp[0], yyvsp[-2]));
	}
#line 6464 "./out/parser.cc"
    break;

  case 353: /* revert_arg_part: revert_arg_backup "(backed-up?)" SCM_ARG symbol_list_part  */
#line 2777 "parser.yy"
        {
		yyval = scm_append_x (scm_list_2 (yyvsp[0], yyvsp[-1]));
	}
#line 6472 "./out/parser.cc"
    break;

  case 354: /* context_def_mod: "\\consists"  */
#line 2783 "parser.yy"
                 { yyval = ly_symbol2scm ("consists"); }
#line 6478 "./out/parser.cc"
    break;

  case 355: /* context_def_mod: "\\remove"  */
#line 2784 "parser.yy"
                 { yyval = ly_symbol2scm ("remove"); }
#line 6484 "./out/parser.cc"
    break;

  case 356: /* context_def_mod: "\\accepts"  */
#line 2786 "parser.yy"
                  { yyval = ly_symbol2scm ("accepts"); }
#line 6490 "./out/parser.cc"
    break;

  case 357: /* context_def_mod: "\\defaultchild"  */
#line 2787 "parser.yy"
                       { yyval = ly_symbol2scm ("default-child"); }
#line 6496 "./out/parser.cc"
    break;

  case 358: /* context_def_mod: "\\denies"  */
#line 2788 "parser.yy"
                 { yyval = ly_symbol2scm ("denies"); }
#line 6502 "./out/parser.cc"
    break;

  case 359: /* context_def_mod: "\\alias"  */
#line 2790 "parser.yy"
                { yyval = ly_symbol2scm ("alias"); }
#line 6508 "./out/parser.cc"
    break;

  case 360: /* context_def_mod: "\\type"  */
#line 2791 "parser.yy"
               { yyval = ly_symbol2scm ("translator-type"); }
#line 6514 "./out/parser.cc"
    break;

  case 361: /* context_def_mod: "\\description"  */
#line 2792 "parser.yy"
                      { yyval = ly_symbol2scm ("description"); }
#line 6520 "./out/parser.cc"
    break;

  case 362: /* context_def_mod: "\\name"  */
#line 2793 "parser.yy"
               { yyval = ly_symbol2scm ("context-name"); }
#line 6526 "./out/parser.cc"
    break;

  case 363: /* context_mod: property_operation  */
#line 2797 "parser.yy"
                           { yyval = yyvsp[0]; }
#line 6532 "./out/parser.cc"
    break;

  case 364: /* context_mod: context_def_mod STRING  */
#line 2798 "parser.yy"
                                 {
		yyval = scm_list_2 (yyvsp[-1], yyvsp[0]);
	}
#line 6540 "./out/parser.cc"
    break;

  case 365: /* context_mod: context_def_mod SYMBOL  */
#line 2801 "parser.yy"
                                 {
		yyval = scm_list_2 (yyvsp[-1], yyvsp[0]);
	}
#line 6548 "./out/parser.cc"
    break;

  case 366: /* context_mod: context_def_mod embedded_scm  */
#line 2805 "parser.yy"
        {
		if (!scm_is_string (yyvsp[0])
		    && !scm_is_eq (yyvsp[-1], ly_symbol2scm ("consists"))
		    && !scm_is_eq (yyvsp[-1], ly_symbol2scm ("remove")))
		{
			yyval = SCM_EOL;
			parser->parser_error ((yylsp[-1]), _ ("only \\consists and \\remove take non-string argument."));
		}
		else
		{
			yyval = scm_list_2 (yyvsp[-1], yyvsp[0]);
		}
	}
#line 6566 "./out/parser.cc"
    break;

  case 367: /* grob_prop_spec: symbol_list_rev  */
#line 2823 "parser.yy"
        {
		SCM l = scm_reverse_x (yyvsp[0], SCM_EOL);
		if (scm_is_pair (l)
		    && from_scm<bool>
		    (scm_object_property (scm_car (l),
					  ly_symbol2scm ("is-grob?"))))
			l = scm_cons (ly_symbol2scm ("Bottom"), l);
		if (scm_is_null (l) || scm_is_null (scm_cdr (l))) {
			parser->parser_error ((yylsp[0]), _ ("bad grob property path"));
			l = SCM_UNDEFINED;
		}
		yyval = l;
	}
#line 6584 "./out/parser.cc"
    break;

  case 368: /* grob_prop_path: grob_prop_spec  */
#line 2841 "parser.yy"
        {
		if (!SCM_UNBNDP (yyvsp[0]) && scm_is_null (scm_cddr (yyvsp[0])))
		{
			parser->parser_error ((yylsp[0]), _ ("bad grob property path"));
			yyval = SCM_UNDEFINED;
		}
	}
#line 6596 "./out/parser.cc"
    break;

  case 369: /* grob_prop_path: grob_prop_spec property_path  */
#line 2849 "parser.yy"
        {
		if (!SCM_UNBNDP (yyvsp[-1])) {
			yyval = scm_append_x (scm_list_2 (yyvsp[-1], yyvsp[0]));
			if (scm_is_null (scm_cddr (yyval))) {
				parser->parser_error ((yyloc), _ ("bad grob property path"));
				yyval = SCM_UNDEFINED;
			}
		}

	}
#line 6611 "./out/parser.cc"
    break;

  case 370: /* context_prop_spec: symbol_list_rev  */
#line 2864 "parser.yy"
        {
		SCM l = scm_reverse_x (yyvsp[0], SCM_EOL);
		switch (scm_ilength (l)) {
		case 1:
			l = scm_cons (ly_symbol2scm ("Bottom"), l);
		case 2:
			break;
		default:
			parser->parser_error ((yylsp[0]), _ ("bad context property path"));
			l = SCM_UNDEFINED;
		}
		yyval = l;
	}
#line 6629 "./out/parser.cc"
    break;

  case 371: /* simple_revert_context: symbol_list_part  */
#line 2896 "parser.yy"
        {
		yyvsp[0] = scm_reverse_x (yyvsp[0], SCM_EOL);
		if (scm_is_null (yyvsp[0])
		    || from_scm<bool>
		    (scm_object_property (scm_car (yyvsp[0]),
					  ly_symbol2scm ("is-grob?")))) {
			yyval = ly_symbol2scm ("Bottom");
			parser->lexer_->push_extra_token ((yylsp[0]), SCM_IDENTIFIER, yyvsp[0]);
		} else {
			yyval = scm_car (yyvsp[0]);
			parser->lexer_->push_extra_token ((yylsp[0]), SCM_IDENTIFIER,
							  scm_cdr (yyvsp[0]));
		}
	}
#line 6648 "./out/parser.cc"
    break;

  case 372: /* music_property_def: "\\override" grob_prop_path '=' scalar  */
#line 2913 "parser.yy"
                                           {
		if (SCM_UNBNDP (yyvsp[-2]))
			yyval = MAKE_SYNTAX (void_music, (yyloc));
		else
			yyval = MAKE_SYNTAX (property_override, (yyloc),
					  scm_car (yyvsp[-2]),
					  scm_cdr (yyvsp[-2]),
					  yyvsp[0]);
	}
#line 6662 "./out/parser.cc"
    break;

  case 373: /* music_property_def: "\\revert" simple_revert_context revert_arg  */
#line 2922 "parser.yy"
                                                  {
		yyval = MAKE_SYNTAX (property_revert, (yyloc), yyvsp[-1], yyvsp[0]);
	}
#line 6670 "./out/parser.cc"
    break;

  case 374: /* music_property_def: "\\set" context_prop_spec '=' scalar  */
#line 2925 "parser.yy"
                                           {
		if (SCM_UNBNDP (yyvsp[-2]))
			yyval = MAKE_SYNTAX (void_music, (yyloc));
		else
			yyval = MAKE_SYNTAX (property_set, (yyloc),
					  scm_car (yyvsp[-2]),
					  scm_cadr (yyvsp[-2]),
					  yyvsp[0]);
	}
#line 6684 "./out/parser.cc"
    break;

  case 375: /* music_property_def: "\\unset" context_prop_spec  */
#line 2934 "parser.yy"
                                  {
		if (SCM_UNBNDP (yyvsp[0]))
			yyval = MAKE_SYNTAX (void_music, (yyloc));
		else
			yyval = MAKE_SYNTAX (property_unset, (yyloc),
					  scm_car (yyvsp[0]),
					  scm_cadr (yyvsp[0]));
	}
#line 6697 "./out/parser.cc"
    break;

  case 382: /* text: embedded_scm_bare  */
#line 2955 "parser.yy"
        {
		if (Text_interface::is_markup (yyvsp[0])) {
			yyval = yyvsp[0];
		} else {
			parser->parser_error ((yylsp[0]), (_ ("markup expected")));
			yyval = scm_string (SCM_EOL);
		}
	}
#line 6710 "./out/parser.cc"
    break;

  case 385: /* simple_string: embedded_scm_bare  */
#line 2968 "parser.yy"
        {
		if (scm_is_string (yyvsp[0])) {
			yyval = yyvsp[0];
		} else {
			parser->parser_error ((yylsp[0]), (_ ("simple string expected")));
			yyval = scm_string (SCM_EOL);
		}
	}
#line 6723 "./out/parser.cc"
    break;

  case 386: /* symbol: STRING  */
#line 2979 "parser.yy"
               {
		yyval = scm_string_to_symbol (yyvsp[0]);
	}
#line 6731 "./out/parser.cc"
    break;

  case 387: /* symbol: SYMBOL  */
#line 2983 "parser.yy"
        {
		if (!is_regular_identifier (yyvsp[0], false))
			parser->parser_error ((yylsp[0]), (_ ("symbol expected")));
		yyval = scm_string_to_symbol (yyvsp[0]);
	}
#line 6741 "./out/parser.cc"
    break;

  case 388: /* symbol: embedded_scm_bare  */
#line 2989 "parser.yy"
        {
		// This is a bit of overkill but makes the same
		// routine responsible for all symbol interpretations.
		yyval = try_string_variants (Guile_user::symbol_p, yyvsp[0]);
		if (SCM_UNBNDP (yyval))
		{
			parser->parser_error ((yylsp[0]), (_ ("symbol expected")));
			// Generate a unique symbol in case it is used
			// for an assignment or similar
			yyval = scm_make_symbol (ly_string2scm ("undefined"));
		}
	}
#line 6758 "./out/parser.cc"
    break;

  case 393: /* scalar: '-' bare_number  */
#line 3016 "parser.yy"
        {
		yyval = scm_difference (yyvsp[0], SCM_UNDEFINED);
	}
#line 6766 "./out/parser.cc"
    break;

  case 395: /* scalar: symbol_list_part_bare '.' property_path  */
#line 3021 "parser.yy"
        {
		yyval = scm_reverse_x (yyvsp[-2], yyvsp[0]);
	}
#line 6774 "./out/parser.cc"
    break;

  case 396: /* scalar: symbol_list_part_bare ',' property_path  */
#line 3025 "parser.yy"
        {
		yyval = scm_reverse_x (yyvsp[-2], yyvsp[0]);
	}
#line 6782 "./out/parser.cc"
    break;

  case 397: /* event_chord: simple_element post_events  */
#line 3031 "parser.yy"
                                   {
		// Let the rhythmic music iterator sort this mess out.
		if (scm_is_pair (yyvsp[0])) {
			set_property (unsmob<Music> (yyval), "articulations",
							 scm_reverse_x (yyvsp[0], SCM_EOL));
		}
	}
#line 6794 "./out/parser.cc"
    break;

  case 398: /* event_chord: CHORD_REPETITION optional_notemode_duration post_events  */
#line 3038 "parser.yy"
                                                                  {
		yyval = MAKE_SYNTAX (repetition_chord, (yyloc),
				  yyvsp[-1], scm_reverse_x (yyvsp[0], SCM_EOL));
	}
#line 6803 "./out/parser.cc"
    break;

  case 399: /* event_chord: MULTI_MEASURE_REST optional_notemode_duration post_events  */
#line 3042 "parser.yy"
                                                                    {
		yyval = MAKE_SYNTAX (multi_measure_rest, (yyloc), yyvsp[-1],
				  scm_reverse_x (yyvsp[0], SCM_EOL));
	}
#line 6812 "./out/parser.cc"
    break;

  case 402: /* note_chord_element: chord_body optional_notemode_duration post_events  */
#line 3053 "parser.yy"
        {
		Music *m = unsmob<Music> (yyvsp[-2]);
		SCM dur = unsmob<Duration> (yyvsp[-1])->smobbed_copy ();
		SCM es = get_property (m, "elements");
		SCM postevs = scm_reverse_x (yyvsp[0], SCM_EOL);

		for (SCM s = es; scm_is_pair (s); s = scm_cdr (s))
			set_property (unsmob<Music> (scm_car (s)), "duration", dur);
		es = ly_append2 (es, postevs);

		set_property (m, "elements", es);
		m->set_spot (parser->lexer_->override_input ((yyloc)));
		yyval = m->self_scm ();
	}
#line 6831 "./out/parser.cc"
    break;

  case 403: /* chord_body: "<" chord_body_elements ">"  */
#line 3071 "parser.yy"
        {
		yyval = MAKE_SYNTAX (event_chord, (yyloc),
				  reverse_music_list (parser, (yyloc),
						      yyvsp[-1], false, false));
	}
#line 6841 "./out/parser.cc"
    break;

  case 404: /* chord_body: FIGURE_OPEN figure_list FIGURE_CLOSE  */
#line 3077 "parser.yy"
        {
		yyval = MAKE_SYNTAX (event_chord, (yyloc), scm_reverse_x (yyvsp[-1], SCM_EOL));
	}
#line 6849 "./out/parser.cc"
    break;

  case 405: /* chord_body_elements: %empty  */
#line 3083 "parser.yy"
                                { yyval = SCM_EOL; }
#line 6855 "./out/parser.cc"
    break;

  case 406: /* chord_body_elements: chord_body_elements chord_body_element  */
#line 3084 "parser.yy"
                                                 {
		if (unsmob<Music> (yyvsp[0]))
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
	}
#line 6864 "./out/parser.cc"
    break;

  case 407: /* chord_body_element: pitch_or_tonic_pitch exclamations questions octave_check post_events  */
#line 3092 "parser.yy"
        {
		bool q = from_scm<bool> (yyvsp[-2]);
		bool ex = from_scm<bool> (yyvsp[-3]);
		SCM check = yyvsp[-1];
		SCM post = yyvsp[0];

		Music *n = MY_MAKE_MUSIC ("NoteEvent", (yyloc));
		set_property (n, "pitch", yyvsp[-4]);
		if (q)
			set_property (n, "cautionary", SCM_BOOL_T);
                if (ex || q)
			set_property (n, "force-accidental", SCM_BOOL_T);

		if (scm_is_pair (post)) {
			SCM arts = scm_reverse_x (post, SCM_EOL);
			set_property (n, "articulations", arts);
		}
		if (scm_is_number (check))
		{
			int q = scm_to_int (check);
			set_property (n, "absolute-octave", to_scm (q-1));
		}

		yyval = n->unprotect ();
	}
#line 6894 "./out/parser.cc"
    break;

  case 408: /* chord_body_element: DRUM_PITCH post_events  */
#line 3117 "parser.yy"
                                           {
		Music *n = MY_MAKE_MUSIC ("NoteEvent", (yyloc));
		set_property (n, "drum-type", yyvsp[-1]);

		if (scm_is_pair (yyvsp[0])) {
			SCM arts = scm_reverse_x (yyvsp[0], SCM_EOL);
			set_property (n, "articulations", arts);
		}
		yyval = n->unprotect ();
	}
#line 6909 "./out/parser.cc"
    break;

  case 409: /* chord_body_element: music_function_chord_body  */
#line 3128 "parser.yy"
        {
		Music *m = unsmob<Music> (yyvsp[0]);

		if (m && !m->is_mus_type ("post-event")) {
			while (m && m->is_mus_type ("music-wrapper-music")) {
				yyval = get_property (m, "element");
				m = unsmob<Music> (yyval);
			}

			if (!(m && m->is_mus_type ("rhythmic-event"))) {
				parser->parser_error ((yyloc), _ ("not a rhythmic event"));
				yyval = SCM_UNSPECIFIED;
			}
		}
	}
#line 6929 "./out/parser.cc"
    break;

  case 414: /* event_function_event: EVENT_FUNCTION function_arglist  */
#line 3153 "parser.yy"
                                        {
		yyval = MAKE_SYNTAX (music_function, (yyloc),
				  yyvsp[-1], yyvsp[0]);
	}
#line 6938 "./out/parser.cc"
    break;

  case 415: /* post_events: %empty  */
#line 3160 "parser.yy"
                    {
		yyval = SCM_EOL;
	}
#line 6946 "./out/parser.cc"
    break;

  case 416: /* post_events: post_events post_event  */
#line 3163 "parser.yy"
                                 {
		yyval = post_event_cons (yyvsp[0], yyvsp[-1]);
	}
#line 6954 "./out/parser.cc"
    break;

  case 417: /* post_event_nofinger: direction_less_event  */
#line 3169 "parser.yy"
                             {
		yyval = yyvsp[0];
	}
#line 6962 "./out/parser.cc"
    break;

  case 418: /* post_event_nofinger: script_dir music_function_call  */
#line 3172 "parser.yy"
                                         {
		Music *m = unsmob<Music> (yyvsp[0]);
		if (!m->is_mus_type ("post-event")) {
			parser->parser_error ((yylsp[0]), _ ("post-event expected"));
			yyval = SCM_UNSPECIFIED;
		} else {
			m->set_spot (parser->lexer_->override_input ((yyloc)));
			if (!SCM_UNBNDP (yyvsp[-1]))
				set_property (m, "direction", yyvsp[-1]);
			yyval = yyvsp[0];
		}
	}
#line 6979 "./out/parser.cc"
    break;

  case 419: /* post_event_nofinger: "--"  */
#line 3184 "parser.yy"
                 {
		if (!parser->lexer_->is_lyric_state ())
			parser->parser_error ((yylsp[0]), _ ("have to be in Lyric mode for lyrics"));
		yyval = MY_MAKE_MUSIC ("HyphenEvent", (yyloc))->unprotect ();
	}
#line 6989 "./out/parser.cc"
    break;

  case 420: /* post_event_nofinger: "__"  */
#line 3189 "parser.yy"
                   {
		if (!parser->lexer_->is_lyric_state ())
			parser->parser_error ((yylsp[0]), _ ("have to be in Lyric mode for lyrics"));
		yyval = MY_MAKE_MUSIC ("ExtenderEvent", (yyloc))->unprotect ();
	}
#line 6999 "./out/parser.cc"
    break;

  case 421: /* post_event_nofinger: script_dir direction_reqd_event  */
#line 3194 "parser.yy"
                                          {
		if (Music *m = unsmob<Music> (yyvsp[0])) {
			m->set_spot (parser->lexer_->override_input ((yyloc)));
			if (!SCM_UNBNDP (yyvsp[-1]))
			{
				set_property (m, "direction", yyvsp[-1]);
			}
		}
		yyval = yyvsp[0];
	}
#line 7014 "./out/parser.cc"
    break;

  case 422: /* post_event_nofinger: script_dir direction_less_event  */
#line 3204 "parser.yy"
                                          {
		Music *m = unsmob<Music> (yyvsp[0]);
		m->set_spot (parser->lexer_->override_input ((yyloc)));
		if (!SCM_UNBNDP (yyvsp[-1]))
			set_property (m, "direction", yyvsp[-1]);
		yyval = yyvsp[0];
	}
#line 7026 "./out/parser.cc"
    break;

  case 423: /* post_event_nofinger: '^' fingering  */
#line 3212 "parser.yy"
        {
		Music *m = unsmob<Music> (yyvsp[0]);
		m->set_spot (parser->lexer_->override_input ((yyloc)));
		set_property (m, "direction", to_scm (UP));
		yyval = yyvsp[0];
	}
#line 7037 "./out/parser.cc"
    break;

  case 424: /* post_event_nofinger: '_' fingering  */
#line 3219 "parser.yy"
        {
		Music *m = unsmob<Music> (yyvsp[0]);
		m->set_spot (parser->lexer_->override_input ((yyloc)));
		set_property (m, "direction", to_scm (DOWN));
		yyval = yyvsp[0];
	}
#line 7048 "./out/parser.cc"
    break;

  case 426: /* post_event: '-' fingering  */
#line 3229 "parser.yy"
                        {
		unsmob<Music> (yyvsp[0])->set_spot (parser->lexer_->override_input ((yyloc)));
		yyval = yyvsp[0];
	}
#line 7057 "./out/parser.cc"
    break;

  case 427: /* string_number_event: E_UNSIGNED  */
#line 3236 "parser.yy"
                   {
		Music *s = MY_MAKE_MUSIC ("StringNumberEvent", (yyloc));
		set_property (s, "string-number", yyvsp[0]);
		yyval = s->unprotect ();
	}
#line 7067 "./out/parser.cc"
    break;

  case 429: /* direction_less_event: EVENT_IDENTIFIER  */
#line 3245 "parser.yy"
                                {
		yyval = yyvsp[0];
	}
#line 7075 "./out/parser.cc"
    break;

  case 430: /* direction_less_event: tremolo_type  */
#line 3248 "parser.yy"
                        {
               Music *a = MY_MAKE_MUSIC ("TremoloEvent", (yyloc));
               set_property (a, "tremolo-type", yyvsp[0]);
               yyval = a->unprotect ();
        }
#line 7085 "./out/parser.cc"
    break;

  case 432: /* direction_reqd_event: gen_text_def  */
#line 3257 "parser.yy"
                     {
		yyval = yyvsp[0];
	}
#line 7093 "./out/parser.cc"
    break;

  case 433: /* direction_reqd_event: script_abbreviation  */
#line 3260 "parser.yy"
                              {
		SCM s = parser->lexer_->lookup_identifier ("dash" + ly_scm2string (yyvsp[0]));
		if (scm_is_string (s)) {
			Music *a = MY_MAKE_MUSIC ("ArticulationEvent", (yyloc));
			set_property (a, "articulation-type", s);
			yyval = a->unprotect ();
		} else {
			Music *original = unsmob<Music> (s);
			if (original && original->is_mus_type ("post-event")) {
				Music *a = original->clone ();
				// origin will be set by post_event_nofinger
				yyval = a->unprotect ();
			} else {
				parser->parser_error ((yylsp[0]), _ ("expecting string or post-event as script definition"));
				yyval = SCM_UNSPECIFIED;
			}
		}
	}
#line 7116 "./out/parser.cc"
    break;

  case 434: /* octave_check: %empty  */
#line 3281 "parser.yy"
             { yyval = SCM_EOL; }
#line 7122 "./out/parser.cc"
    break;

  case 435: /* octave_check: '=' quotes  */
#line 3282 "parser.yy"
                     { yyval = yyvsp[0]; }
#line 7128 "./out/parser.cc"
    break;

  case 436: /* quotes: %empty  */
#line 3287 "parser.yy"
        {
                yyval = SCM_INUM0;
	}
#line 7136 "./out/parser.cc"
    break;

  case 439: /* erroneous_quotes: quotes  */
#line 3296 "parser.yy"
               {
		if (scm_is_eq (SCM_INUM0, yyvsp[0]))
			yyval = SCM_UNDEFINED;
	}
#line 7145 "./out/parser.cc"
    break;

  case 440: /* sup_quotes: '\''  */
#line 3303 "parser.yy"
             {
		yyval = to_scm (1);
	}
#line 7153 "./out/parser.cc"
    break;

  case 441: /* sup_quotes: sup_quotes '\''  */
#line 3306 "parser.yy"
                          {
		yyval = scm_oneplus (yyvsp[-1]);
	}
#line 7161 "./out/parser.cc"
    break;

  case 442: /* sub_quotes: ','  */
#line 3312 "parser.yy"
            {
		yyval = to_scm (-1);
	}
#line 7169 "./out/parser.cc"
    break;

  case 443: /* sub_quotes: sub_quotes ','  */
#line 3315 "parser.yy"
                         {
		yyval = scm_oneminus (yyvsp[-1]);
	}
#line 7177 "./out/parser.cc"
    break;

  case 444: /* steno_pitch: NOTENAME_PITCH quotes  */
#line 3321 "parser.yy"
                              {
                if (!scm_is_eq (SCM_INUM0, yyvsp[0]))
                {
                        Pitch p = *unsmob<Pitch> (yyvsp[-1]);
                        p = p.transposed (Pitch (scm_to_int (yyvsp[0]), 0));
                        yyval = p.smobbed_copy ();
                }
	}
#line 7190 "./out/parser.cc"
    break;

  case 445: /* steno_tonic_pitch: TONICNAME_PITCH quotes  */
#line 3336 "parser.yy"
                               {
                if (!scm_is_eq (SCM_INUM0, yyvsp[0]))
                {
                        Pitch p = *unsmob<Pitch> (yyvsp[-1]);
                        p = p.transposed (Pitch (scm_to_int (yyvsp[0]), 0));
                        yyval = p.smobbed_copy ();
                }
	}
#line 7203 "./out/parser.cc"
    break;

  case 447: /* pitch: PITCH_IDENTIFIER quotes  */
#line 3348 "parser.yy"
                                  {
                if (!scm_is_eq (SCM_INUM0, yyvsp[0]))
                {
                        Pitch p = *unsmob<Pitch> (yyvsp[-1]);
                        p = p.transposed (Pitch (scm_to_int (yyvsp[0]), 0));
                        yyval = p.smobbed_copy ();
                }
	}
#line 7216 "./out/parser.cc"
    break;

  case 450: /* gen_text_def: full_markup  */
#line 3364 "parser.yy"
                    {
		Music *t = MY_MAKE_MUSIC ("TextScriptEvent", (yyloc));
		set_property (t, "text", yyvsp[0]);
		yyval = t->unprotect ();
	}
#line 7226 "./out/parser.cc"
    break;

  case 451: /* gen_text_def: STRING  */
#line 3369 "parser.yy"
                 {
		Music *t = MY_MAKE_MUSIC ("TextScriptEvent", (yyloc));
		set_property (t, "text",
			make_simple_markup (yyvsp[0]));
		yyval = t->unprotect ();
	}
#line 7237 "./out/parser.cc"
    break;

  case 452: /* gen_text_def: SYMBOL  */
#line 3375 "parser.yy"
                 {
		// Flag a warning? could be unintentional
		Music *t = MY_MAKE_MUSIC ("TextScriptEvent", (yyloc));
		set_property (t, "text",
			make_simple_markup (yyvsp[0]));
		yyval = t->unprotect ();
	}
#line 7249 "./out/parser.cc"
    break;

  case 453: /* gen_text_def: embedded_scm  */
#line 3383 "parser.yy"
        {
		// Could be using this for every gen_text_def but for speed
		yyval = MAKE_SYNTAX (create_script, (yylsp[0]), yyvsp[0]);
	}
#line 7258 "./out/parser.cc"
    break;

  case 454: /* fingering: UNSIGNED  */
#line 3390 "parser.yy"
                 {
		Music *t = MY_MAKE_MUSIC ("FingeringEvent", (yyloc));
		set_property (t, "digit", yyvsp[0]);
		yyval = t->unprotect ();
	}
#line 7268 "./out/parser.cc"
    break;

  case 455: /* script_abbreviation: '^'  */
#line 3398 "parser.yy"
                        {
		yyval = scm_from_ascii_string ("Hat");
	}
#line 7276 "./out/parser.cc"
    break;

  case 456: /* script_abbreviation: '+'  */
#line 3401 "parser.yy"
                        {
		yyval = scm_from_ascii_string ("Plus");
	}
#line 7284 "./out/parser.cc"
    break;

  case 457: /* script_abbreviation: '-'  */
#line 3404 "parser.yy"
                        {
		yyval = scm_from_ascii_string ("Dash");
	}
#line 7292 "./out/parser.cc"
    break;

  case 458: /* script_abbreviation: '!'  */
#line 3407 "parser.yy"
                        {
		yyval = scm_from_ascii_string ("Bang");
	}
#line 7300 "./out/parser.cc"
    break;

  case 459: /* script_abbreviation: ">"  */
#line 3410 "parser.yy"
                        {
		yyval = scm_from_ascii_string ("Larger");
	}
#line 7308 "./out/parser.cc"
    break;

  case 460: /* script_abbreviation: '.'  */
#line 3413 "parser.yy"
                        {
		yyval = scm_from_ascii_string ("Dot");
	}
#line 7316 "./out/parser.cc"
    break;

  case 461: /* script_abbreviation: '_'  */
#line 3416 "parser.yy"
              {
		yyval = scm_from_ascii_string ("Underscore");
	}
#line 7324 "./out/parser.cc"
    break;

  case 462: /* script_dir: '_'  */
#line 3422 "parser.yy"
                { yyval = to_scm (DOWN); }
#line 7330 "./out/parser.cc"
    break;

  case 463: /* script_dir: '^'  */
#line 3423 "parser.yy"
                { yyval = to_scm (UP); }
#line 7336 "./out/parser.cc"
    break;

  case 464: /* script_dir: '-'  */
#line 3424 "parser.yy"
                { yyval = SCM_UNDEFINED; }
#line 7342 "./out/parser.cc"
    break;

  case 465: /* maybe_notemode_duration: %empty  */
#line 3428 "parser.yy"
        {
		yyval = SCM_UNDEFINED;
	}
#line 7350 "./out/parser.cc"
    break;

  case 466: /* maybe_notemode_duration: duration  */
#line 3431 "parser.yy"
                        {
		yyval = yyvsp[0];
		parser->default_duration_ = *unsmob<Duration> (yyval);
	}
#line 7359 "./out/parser.cc"
    break;

  case 467: /* optional_notemode_duration: maybe_notemode_duration  */
#line 3440 "parser.yy"
        {
		if (SCM_UNBNDP (yyval))
			yyval = parser->default_duration_.smobbed_copy ();
	}
#line 7368 "./out/parser.cc"
    break;

  case 468: /* steno_duration: UNSIGNED dots  */
#line 3447 "parser.yy"
                                {
		yyval = make_duration (yyvsp[-1], scm_to_int (yyvsp[0]));
		if (SCM_UNBNDP (yyval))
		{
			parser->parser_error ((yylsp[-1]), _ ("not a duration"));
			yyval = Duration ().smobbed_copy ();
		}
	}
#line 7381 "./out/parser.cc"
    break;

  case 469: /* steno_duration: DURATION_IDENTIFIER dots  */
#line 3455 "parser.yy"
                                        {
		yyval = make_duration (yyvsp[-1], scm_to_int (yyvsp[0]));
	}
#line 7389 "./out/parser.cc"
    break;

  case 470: /* duration: steno_duration multipliers  */
#line 3461 "parser.yy"
                                   {
		yyval = make_duration (yyvsp[-1], 0, yyvsp[0]);
	}
#line 7397 "./out/parser.cc"
    break;

  case 471: /* dots: %empty  */
#line 3467 "parser.yy"
                        {
		yyval = SCM_INUM0;
	}
#line 7405 "./out/parser.cc"
    break;

  case 472: /* dots: dots '.'  */
#line 3470 "parser.yy"
                   {
		yyval = scm_oneplus (yyvsp[-1]);
	}
#line 7413 "./out/parser.cc"
    break;

  case 475: /* multipliers: %empty  */
#line 3482 "parser.yy"
        {
		yyval = SCM_UNDEFINED;
	}
#line 7421 "./out/parser.cc"
    break;

  case 476: /* multipliers: multipliers '*' UNSIGNED  */
#line 3486 "parser.yy"
        {
		if (!SCM_UNBNDP (yyvsp[-2]))
			yyval = scm_product (yyvsp[-2], yyvsp[0]);
		else
			yyval = yyvsp[0];
	}
#line 7432 "./out/parser.cc"
    break;

  case 477: /* multipliers: multipliers '*' FRACTION  */
#line 3493 "parser.yy"
        {
		if (!SCM_UNBNDP (yyvsp[-2]))
			yyval = scm_product (yyvsp[-2], scm_divide (scm_car (yyvsp[0]),
							  scm_cdr (yyvsp[0])));
		else
			yyval = scm_divide (scm_car (yyvsp[0]), scm_cdr (yyvsp[0]));
	}
#line 7444 "./out/parser.cc"
    break;

  case 478: /* multipliers: multipliers '*' multiplier_scm  */
#line 3501 "parser.yy"
        {
		if (scm_is_false (Lily::scale_p (yyvsp[0])))
		{
			parser->parser_error ((yylsp[0]), _ ("not a multiplier"));
		} else if (SCM_UNBNDP (yyvsp[-2]))
			yyval = Lily::scale_to_factor (yyvsp[0]);
		else
			yyval = scm_product (yyvsp[-2], Lily::scale_to_factor (yyvsp[0]));
	}
#line 7458 "./out/parser.cc"
    break;

  case 479: /* tremolo_type: ':'  */
#line 3513 "parser.yy"
                {
		yyval = to_scm (parser->default_tremolo_type_);
	}
#line 7466 "./out/parser.cc"
    break;

  case 480: /* tremolo_type: ':' UNSIGNED  */
#line 3516 "parser.yy"
                       {
		if (SCM_UNBNDP (make_duration (yyvsp[0]))) {
			parser->parser_error ((yylsp[0]), _ ("not a duration"));
			yyval = to_scm (parser->default_tremolo_type_);
		} else {
			yyval = yyvsp[0];
			parser->default_tremolo_type_ = scm_to_int (yyvsp[0]);
		}
	}
#line 7480 "./out/parser.cc"
    break;

  case 485: /* bass_number: embedded_scm_bare  */
#line 3533 "parser.yy"
        {
		// as an integer, it needs to be non-negative, and otherwise
		// it needs to be suitable as a markup.
		if (scm_is_integer (yyvsp[0])
		    ? scm_is_true (scm_negative_p (yyvsp[0]))
		    : !Text_interface::is_markup (yyvsp[0]))
		{
			parser->parser_error ((yylsp[0]), _ ("bass number expected"));
			yyval = SCM_INUM0;
		}
	}
#line 7496 "./out/parser.cc"
    break;

  case 486: /* figured_bass_alteration: '-'  */
#line 3547 "parser.yy"
                { yyval = to_scm (FLAT_ALTERATION); }
#line 7502 "./out/parser.cc"
    break;

  case 487: /* figured_bass_alteration: '+'  */
#line 3548 "parser.yy"
                { yyval = to_scm (SHARP_ALTERATION); }
#line 7508 "./out/parser.cc"
    break;

  case 488: /* figured_bass_alteration: '!'  */
#line 3549 "parser.yy"
                { yyval = to_scm (0); }
#line 7514 "./out/parser.cc"
    break;

  case 489: /* bass_figure: "_"  */
#line 3553 "parser.yy"
                     {
		Music *bfr = MY_MAKE_MUSIC ("BassFigureEvent", (yyloc));
		yyval = bfr->unprotect ();
	}
#line 7523 "./out/parser.cc"
    break;

  case 490: /* bass_figure: bass_number  */
#line 3557 "parser.yy"
                       {
		Music *bfr = MY_MAKE_MUSIC ("BassFigureEvent", (yyloc));
		yyval = bfr->self_scm ();

		if (scm_is_number (yyvsp[0]))
			set_property (bfr, "figure", yyvsp[0]);
		else if (Text_interface::is_markup (yyvsp[0]))
			set_property (bfr, "text", yyvsp[0]);

		bfr->unprotect ();
	}
#line 7539 "./out/parser.cc"
    break;

  case 491: /* bass_figure: bass_figure ']'  */
#line 3568 "parser.yy"
                          {
		yyval = yyvsp[-1];
		set_property (unsmob<Music> (yyvsp[-1]), "bracket-stop", SCM_BOOL_T);
	}
#line 7548 "./out/parser.cc"
    break;

  case 492: /* bass_figure: bass_figure figured_bass_alteration  */
#line 3572 "parser.yy"
                                              {
		Music *m = unsmob<Music> (yyvsp[-1]);
		if (scm_to_double (yyvsp[0])) {
			SCM salter = get_property (m, "alteration");
			SCM alter = scm_is_number (salter) ? salter : to_scm (0);
			set_property (m, "alteration",
					 scm_sum (alter, yyvsp[0]));
		} else {
			set_property (m, "alteration", to_scm (0));
		}
	}
#line 7564 "./out/parser.cc"
    break;

  case 493: /* bass_figure: bass_figure figured_bass_modification  */
#line 3583 "parser.yy"
                                                 {
		Music *m = unsmob<Music> (yyvsp[-1]);
		set_property (m, yyvsp[0], SCM_BOOL_T);
	}
#line 7573 "./out/parser.cc"
    break;

  case 494: /* figured_bass_modification: "\\+"  */
#line 3591 "parser.yy"
                        {
		yyval = ly_symbol2scm ("augmented");
	}
#line 7581 "./out/parser.cc"
    break;

  case 495: /* figured_bass_modification: "\\!"  */
#line 3594 "parser.yy"
                        {
		yyval = ly_symbol2scm ("no-continuation");
	}
#line 7589 "./out/parser.cc"
    break;

  case 496: /* figured_bass_modification: '/'  */
#line 3597 "parser.yy"
                        {
		yyval = ly_symbol2scm ("diminished");
	}
#line 7597 "./out/parser.cc"
    break;

  case 497: /* figured_bass_modification: "\\\\"  */
#line 3600 "parser.yy"
                      {
		yyval = ly_symbol2scm ("augmented-slash");
	}
#line 7605 "./out/parser.cc"
    break;

  case 498: /* br_bass_figure: bass_figure  */
#line 3606 "parser.yy"
                    {
		yyval = yyvsp[0];
	}
#line 7613 "./out/parser.cc"
    break;

  case 499: /* br_bass_figure: '[' bass_figure  */
#line 3609 "parser.yy"
                          {
		yyval = yyvsp[0];
		set_property (unsmob<Music> (yyval), "bracket-start", SCM_BOOL_T);
	}
#line 7622 "./out/parser.cc"
    break;

  case 500: /* figure_list: %empty  */
#line 3616 "parser.yy"
                        {
		yyval = SCM_EOL;
	}
#line 7630 "./out/parser.cc"
    break;

  case 501: /* figure_list: figure_list br_bass_figure  */
#line 3619 "parser.yy"
                                     {
		yyval = scm_cons (yyvsp[0], yyvsp[-1]);
	}
#line 7638 "./out/parser.cc"
    break;

  case 502: /* optional_rest: %empty  */
#line 3625 "parser.yy"
               { yyval = SCM_BOOL_F; }
#line 7644 "./out/parser.cc"
    break;

  case 503: /* optional_rest: "\\rest"  */
#line 3626 "parser.yy"
               { yyval = SCM_BOOL_T; }
#line 7650 "./out/parser.cc"
    break;

  case 504: /* pitch_or_music: pitch exclamations questions octave_check maybe_notemode_duration erroneous_quotes optional_rest post_events  */
#line 3634 "parser.yy"
                                                                                                                     {
		if (!parser->lexer_->is_note_state ())
			parser->parser_error ((yylsp[-7]), _ ("have to be in Note mode for notes"));
		if (!SCM_UNBNDP (yyvsp[-2]))
		{
			// It's possible to get here without a
			// duration, like when there is no
			// octave_check but a question mark.  But we
			// point out the most frequent error of an
			// interspersed duration specifically
			if (!SCM_UNBNDP (yyvsp[-3]))
				parser->parser_error ((yylsp[-2]), _ ("octave marks must precede duration"));
			else
				parser->parser_error ((yylsp[-2]), _ ("badly placed octave marks"));
			// Try sorting the quotes to where they likely belong
			if (scm_is_number (yyvsp[-4])) {
				yyvsp[-4] = scm_sum (yyvsp[-4], yyvsp[-2]);
			} else {
				yyvsp[-7] = unsmob<Pitch> (yyvsp[-7])->transposed
					(Pitch (scm_to_int (yyvsp[-2]), 0)).smobbed_copy ();
			}
		}

		if (!SCM_UNBNDP (yyvsp[-6])
                    || !SCM_UNBNDP (yyvsp[-5])
                    || scm_is_number (yyvsp[-4])
                    || !SCM_UNBNDP (yyvsp[-3])
		    || scm_is_true (yyvsp[-1])
		    || scm_is_pair (yyvsp[0]))
		{
			Music *n = 0;
			if (scm_is_true (yyvsp[-1]))
				n = MY_MAKE_MUSIC ("RestEvent", (yyloc));
			else
				n = MY_MAKE_MUSIC ("NoteEvent", (yyloc));

			set_property (n, "pitch", yyvsp[-7]);
			if (SCM_UNBNDP (yyvsp[-3]))
				set_property (n, "duration",
						 parser->default_duration_.smobbed_copy ());
			else
				set_property (n, "duration", yyvsp[-3]);

			if (scm_is_number (yyvsp[-4]))
			{
				int q = scm_to_int (yyvsp[-4]);
				set_property (n, "absolute-octave", to_scm (q-1));
			}

			if (from_scm<bool> (yyvsp[-5]))
				set_property (n, "cautionary", SCM_BOOL_T);
			if (from_scm<bool> (yyvsp[-6]) || from_scm<bool> (yyvsp[-5]))
				set_property (n, "force-accidental", SCM_BOOL_T);
			if (scm_is_pair (yyvsp[0]))
				set_property (n, "articulations",
						 scm_reverse_x (yyvsp[0], SCM_EOL));
			yyval = n->unprotect ();
		}
	}
#line 7714 "./out/parser.cc"
    break;

  case 505: /* pitch_or_music: new_chord post_events  */
#line 3693 "parser.yy"
                                {
		if (!parser->lexer_->is_chord_state ())
                        parser->parser_error ((yylsp[-1]), _ ("have to be in Chord mode for chords"));
		if (scm_is_pair (yyvsp[0])) {
			if (unsmob<Pitch> (yyvsp[-1]))
				yyvsp[-1] = make_chord_elements ((yylsp[-1]),
							  yyvsp[-1],
							  parser->default_duration_.smobbed_copy (),
							  SCM_EOL);

			SCM elts = ly_append2 (yyvsp[-1], scm_reverse_x (yyvsp[0], SCM_EOL));

			yyval = MAKE_SYNTAX (event_chord, (yylsp[-1]), elts);
		} else if (!unsmob<Pitch> (yyvsp[-1]))
			yyval = MAKE_SYNTAX (event_chord, (yylsp[-1]), yyvsp[-1]);
		// A mere pitch drops through.
	}
#line 7736 "./out/parser.cc"
    break;

  case 506: /* simple_element: DRUM_PITCH optional_notemode_duration  */
#line 3713 "parser.yy"
                                              {
		Music *n = MY_MAKE_MUSIC ("NoteEvent", (yyloc));
		set_property (n, "duration", yyvsp[0]);
		set_property (n, "drum-type", yyvsp[-1]);

		yyval = n->unprotect ();
	}
#line 7748 "./out/parser.cc"
    break;

  case 507: /* simple_element: RESTNAME optional_notemode_duration  */
#line 3720 "parser.yy"
                                                        {
		Music *ev = 0;
 		if (ly_scm2string (yyvsp[-1]) == "s") {
			/* Space */
			ev = MY_MAKE_MUSIC ("SkipEvent", (yyloc));
		  }
		else {
			ev = MY_MAKE_MUSIC ("RestEvent", (yyloc));

		    }
		set_property (ev, "duration", yyvsp[0]);
 		yyval = ev->unprotect ();
	}
#line 7766 "./out/parser.cc"
    break;

  case 508: /* lyric_element: full_markup  */
#line 3736 "parser.yy"
                    {
		if (!parser->lexer_->is_lyric_state ())
			parser->parser_error ((yylsp[0]), _ ("markup outside of text script or \\lyricmode"));
		yyval = yyvsp[0];
	}
#line 7776 "./out/parser.cc"
    break;

  case 509: /* lyric_element: SYMBOL  */
#line 3741 "parser.yy"
                 {
		if (!parser->lexer_->is_lyric_state ())
			parser->parser_error ((yylsp[0]), _f ("not a note name: %s", ly_scm2string (yyvsp[0])));
		yyval = yyvsp[0];
	}
#line 7786 "./out/parser.cc"
    break;

  case 510: /* lyric_element: STRING  */
#line 3746 "parser.yy"
                 {
		if (!parser->lexer_->is_lyric_state ())
			parser->parser_error ((yylsp[0]), _ ("string outside of text script or \\lyricmode"));
		yyval = yyvsp[0];
	}
#line 7796 "./out/parser.cc"
    break;

  case 512: /* lyric_element_music: lyric_element optional_notemode_duration post_events  */
#line 3755 "parser.yy"
                                                             {
		yyval = MAKE_SYNTAX (lyric_event, (yyloc), yyvsp[-2], yyvsp[-1]);
		if (scm_is_pair (yyvsp[0]))
			set_property
				(unsmob<Music> (yyval), "articulations", scm_reverse_x (yyvsp[0], SCM_EOL));
	}
#line 7807 "./out/parser.cc"
    break;

  case 513: /* new_chord: steno_tonic_pitch maybe_notemode_duration  */
#line 3765 "parser.yy"
                                                    {
		if (SCM_UNBNDP (yyvsp[0]))
			yyval = yyvsp[-1];
		else
			yyval = make_chord_elements ((yyloc), yyvsp[-1], yyvsp[0], SCM_EOL);
	}
#line 7818 "./out/parser.cc"
    break;

  case 514: /* new_chord: steno_tonic_pitch optional_notemode_duration chord_separator chord_items  */
#line 3771 "parser.yy"
                                                                                   {
		SCM its = scm_reverse_x (yyvsp[0], SCM_EOL);
		yyval = make_chord_elements ((yyloc), yyvsp[-3], yyvsp[-2], scm_cons (yyvsp[-1], its));
	}
#line 7827 "./out/parser.cc"
    break;

  case 515: /* chord_items: %empty  */
#line 3778 "parser.yy"
             {
		yyval = SCM_EOL;
	}
#line 7835 "./out/parser.cc"
    break;

  case 516: /* chord_items: chord_items chord_item  */
#line 3781 "parser.yy"
                                 {
		yyval = scm_cons (yyvsp[0], yyval);
	}
#line 7843 "./out/parser.cc"
    break;

  case 517: /* chord_separator: ":"  */
#line 3787 "parser.yy"
                    {
		yyval = ly_symbol2scm ("chord-colon");
	}
#line 7851 "./out/parser.cc"
    break;

  case 518: /* chord_separator: "^"  */
#line 3790 "parser.yy"
                      {
		yyval = ly_symbol2scm ("chord-caret");
	}
#line 7859 "./out/parser.cc"
    break;

  case 519: /* chord_separator: "/" steno_tonic_pitch  */
#line 3793 "parser.yy"
                                        {
 		yyval = scm_list_2 (ly_symbol2scm ("chord-slash"), yyvsp[0]);
	}
#line 7867 "./out/parser.cc"
    break;

  case 520: /* chord_separator: "/+" steno_tonic_pitch  */
#line 3796 "parser.yy"
                                       {
		yyval = scm_list_2 (ly_symbol2scm ("chord-bass"), yyvsp[0]);
	}
#line 7875 "./out/parser.cc"
    break;

  case 521: /* chord_item: chord_separator  */
#line 3802 "parser.yy"
                        {
		yyval = yyvsp[0];
	}
#line 7883 "./out/parser.cc"
    break;

  case 522: /* chord_item: step_numbers  */
#line 3805 "parser.yy"
                       {
		yyval = scm_reverse_x (yyvsp[0], SCM_EOL);
	}
#line 7891 "./out/parser.cc"
    break;

  case 523: /* chord_item: CHORD_MODIFIER  */
#line 3808 "parser.yy"
                          {
		yyval = yyvsp[0];
	}
#line 7899 "./out/parser.cc"
    break;

  case 524: /* step_numbers: step_number  */
#line 3814 "parser.yy"
                    { yyval = scm_cons (yyvsp[0], SCM_EOL); }
#line 7905 "./out/parser.cc"
    break;

  case 525: /* step_numbers: step_numbers '.' step_number  */
#line 3815 "parser.yy"
                                       {
		yyval = scm_cons (yyvsp[0], yyval);
	}
#line 7913 "./out/parser.cc"
    break;

  case 526: /* step_number: UNSIGNED  */
#line 3821 "parser.yy"
                 {
		yyval = make_chord_step (yyvsp[0], 0);
        }
#line 7921 "./out/parser.cc"
    break;

  case 527: /* step_number: UNSIGNED '+'  */
#line 3824 "parser.yy"
                       {
		yyval = make_chord_step (yyvsp[-1], SHARP_ALTERATION);
	}
#line 7929 "./out/parser.cc"
    break;

  case 528: /* step_number: UNSIGNED "-"  */
#line 3827 "parser.yy"
                               {
		yyval = make_chord_step (yyvsp[-1], FLAT_ALTERATION);
	}
#line 7937 "./out/parser.cc"
    break;

  case 529: /* tempo_range: unsigned_number  */
#line 3833 "parser.yy"
                        {
		yyval = yyvsp[0];
	}
#line 7945 "./out/parser.cc"
    break;

  case 530: /* tempo_range: unsigned_number '-' unsigned_number  */
#line 3836 "parser.yy"
                                              {
		yyval = scm_cons (yyvsp[-2], yyvsp[0]);
	}
#line 7953 "./out/parser.cc"
    break;

  case 531: /* number_expression: number_expression '+' number_term  */
#line 3848 "parser.yy"
                                          {
		yyval = scm_sum (yyvsp[-2], yyvsp[0]);
	}
#line 7961 "./out/parser.cc"
    break;

  case 532: /* number_expression: number_expression '-' number_term  */
#line 3851 "parser.yy"
                                            {
		yyval = scm_difference (yyvsp[-2], yyvsp[0]);
	}
#line 7969 "./out/parser.cc"
    break;

  case 534: /* number_term: number_factor  */
#line 3858 "parser.yy"
                      {
		yyval = yyvsp[0];
	}
#line 7977 "./out/parser.cc"
    break;

  case 535: /* number_term: number_factor '*' number_factor  */
#line 3861 "parser.yy"
                                          {
		yyval = scm_product (yyvsp[-2], yyvsp[0]);
	}
#line 7985 "./out/parser.cc"
    break;

  case 536: /* number_term: number_factor '/' number_factor  */
#line 3864 "parser.yy"
                                          {
		yyval = scm_divide (yyvsp[-2], yyvsp[0]);
	}
#line 7993 "./out/parser.cc"
    break;

  case 537: /* number_factor: '-' number_factor  */
#line 3870 "parser.yy"
                           { /* %prec UNARY_MINUS */
		yyval = scm_difference (yyvsp[0], SCM_UNDEFINED);
	}
#line 8001 "./out/parser.cc"
    break;

  case 541: /* bare_number_common: REAL NUMBER_IDENTIFIER  */
#line 3880 "parser.yy"
        {
		yyval = scm_product (yyvsp[-1], yyvsp[0]);
	}
#line 8009 "./out/parser.cc"
    break;

  case 544: /* bare_number: UNSIGNED NUMBER_IDENTIFIER  */
#line 3888 "parser.yy"
                                        {
		yyval = scm_product (yyvsp[-1], yyvsp[0]);
	}
#line 8017 "./out/parser.cc"
    break;

  case 546: /* unsigned_number: NUMBER_IDENTIFIER  */
#line 3896 "parser.yy"
        {
		if (!scm_is_integer (yyvsp[0])
		    || scm_is_true (scm_negative_p (yyvsp[0])))
		{
			parser->parser_error ((yylsp[0]), _("not an unsigned integer"));
			yyval = SCM_INUM0;
		}
	}
#line 8030 "./out/parser.cc"
    break;

  case 547: /* unsigned_number: embedded_scm  */
#line 3905 "parser.yy"
        {
		if (!scm_is_integer (yyvsp[0])
		    || scm_is_true (scm_negative_p (yyvsp[0])))
		{
			parser->parser_error ((yylsp[0]), _("not an unsigned integer"));
			yyval = SCM_INUM0;
		}
	}
#line 8043 "./out/parser.cc"
    break;

  case 548: /* exclamations: %empty  */
#line 3916 "parser.yy"
                { yyval = SCM_UNDEFINED; }
#line 8049 "./out/parser.cc"
    break;

  case 549: /* exclamations: exclamations '!'  */
#line 3918 "parser.yy"
        {
                if (SCM_UNBNDP (yyvsp[-1]))
                        yyval = SCM_BOOL_T;
                else
                        yyval = scm_not (yyvsp[-1]);
        }
#line 8060 "./out/parser.cc"
    break;

  case 550: /* questions: %empty  */
#line 3933 "parser.yy"
        { yyval = SCM_UNDEFINED; }
#line 8066 "./out/parser.cc"
    break;

  case 551: /* questions: questions '?'  */
#line 3935 "parser.yy"
        {
                if (SCM_UNBNDP (yyvsp[-1]))
                        yyval = SCM_BOOL_T;
                else
                        yyval = scm_not (yyvsp[-1]);
        }
#line 8077 "./out/parser.cc"
    break;

  case 552: /* $@10: %empty  */
#line 3945 "parser.yy"
                { parser->lexer_->push_markup_state (); }
#line 8083 "./out/parser.cc"
    break;

  case 553: /* full_markup_list: "\\markuplist" $@10 markup_list  */
#line 3946 "parser.yy"
                    {
		yyval = yyvsp[0];
		parser->lexer_->pop_state ();
	}
#line 8092 "./out/parser.cc"
    break;

  case 554: /* markup_mode: "\\markup"  */
#line 3954 "parser.yy"
        {
		parser->lexer_->push_markup_state ();
	}
#line 8100 "./out/parser.cc"
    break;

  case 555: /* markup_mode_word: markup_mode markup_word  */
#line 3970 "parser.yy"
        {
		yyval = yyvsp[0];
		parser->lexer_->pop_state ();
	}
#line 8109 "./out/parser.cc"
    break;

  case 556: /* full_markup: markup_mode markup_top  */
#line 3978 "parser.yy"
                               {
		yyval = yyvsp[0];
		parser->lexer_->pop_state ();
	}
#line 8118 "./out/parser.cc"
    break;

  case 557: /* full_markup: markup_mode_word  */
#line 3983 "parser.yy"
        {
		yyval = make_simple_markup (yyvsp[0]);
	}
#line 8126 "./out/parser.cc"
    break;

  case 558: /* partial_markup: markup_mode markup_partial_function "\\etc"  */
#line 3990 "parser.yy"
        {
		yyval = MAKE_SYNTAX (partial_markup, (yylsp[-1]), yyvsp[-1]);
		parser->lexer_->pop_state ();
	}
#line 8135 "./out/parser.cc"
    break;

  case 559: /* markup_top: markup_list  */
#line 3997 "parser.yy"
                    {
		yyval = scm_list_2 (Lily::line_markup,  yyvsp[0]);
	}
#line 8143 "./out/parser.cc"
    break;

  case 560: /* markup_top: markup_head_1_list simple_markup  */
#line 4001 "parser.yy"
        {
		yyval = scm_car (MAKE_SYNTAX (composed_markup_list,
					   (yylsp[0]), yyvsp[-1], scm_list_1 (yyvsp[0])));
	}
#line 8152 "./out/parser.cc"
    break;

  case 561: /* markup_top: simple_markup_noword  */
#line 4005 "parser.yy"
                               {
		yyval = yyvsp[0];
	}
#line 8160 "./out/parser.cc"
    break;

  case 562: /* $@11: %empty  */
#line 4012 "parser.yy"
        {
		if (Text_interface::is_markup (yyvsp[0]))
			MYBACKUP (MARKUP_IDENTIFIER, yyvsp[0], (yylsp[0]));
		else if (Text_interface::is_markup_list (yyvsp[0]))
			MYBACKUP (MARKUPLIST_IDENTIFIER, yyvsp[0], (yylsp[0]));
		else {
			parser->parser_error ((yylsp[0]), _ ("not a markup"));
			MYBACKUP (MARKUP_IDENTIFIER, scm_string (SCM_EOL), (yylsp[0]));
		}
	}
#line 8175 "./out/parser.cc"
    break;

  case 564: /* markup_list: markup_composed_list  */
#line 4026 "parser.yy"
                             {
		yyval = yyvsp[0];
	}
#line 8183 "./out/parser.cc"
    break;

  case 566: /* markup_uncomposed_list: markup_braced_list  */
#line 4033 "parser.yy"
                           {
		yyval = yyvsp[0];
	}
#line 8191 "./out/parser.cc"
    break;

  case 567: /* markup_uncomposed_list: markup_command_list  */
#line 4036 "parser.yy"
                              {
		yyval = scm_list_1 (yyvsp[0]);
	}
#line 8199 "./out/parser.cc"
    break;

  case 568: /* markup_uncomposed_list: markup_scm MARKUPLIST_IDENTIFIER  */
#line 4040 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 8207 "./out/parser.cc"
    break;

  case 569: /* $@12: %empty  */
#line 4043 "parser.yy"
                     {
		parser->lexer_->push_note_state (Lily::pitchnames);
	}
#line 8215 "./out/parser.cc"
    break;

  case 570: /* markup_uncomposed_list: "\\score-lines" $@12 '{' score_body '}'  */
#line 4045 "parser.yy"
                             {
		Score *sc = unsmob<Score> (yyvsp[-1]);
		sc->origin ()->set_spot ((yyloc));
		if (sc->defs_.empty ()) {
			Output_def *od = get_layout (parser);
			sc->add_output_def (od);
			od->unprotect ();
		}
		yyval = scm_list_1 (scm_list_2 (Lily::score_lines_markup_list, yyvsp[-1]));
		parser->lexer_->pop_state ();
	}
#line 8231 "./out/parser.cc"
    break;

  case 571: /* markup_composed_list: markup_head_1_list markup_uncomposed_list  */
#line 4059 "parser.yy"
                                                  {
		yyval = MAKE_SYNTAX (composed_markup_list,
				  (yylsp[0]), yyvsp[-1], yyvsp[0]);
	}
#line 8240 "./out/parser.cc"
    break;

  case 572: /* markup_braced_list: '{' markup_braced_list_body '}'  */
#line 4066 "parser.yy"
                                        {
		yyval = scm_reverse_x (yyvsp[-1], SCM_EOL);
	}
#line 8248 "./out/parser.cc"
    break;

  case 573: /* markup_braced_list_body: %empty  */
#line 4072 "parser.yy"
                        {  yyval = SCM_EOL; }
#line 8254 "./out/parser.cc"
    break;

  case 574: /* markup_braced_list_body: markup_braced_list_body markup  */
#line 4073 "parser.yy"
                                         {
		yyval = scm_cons (yyvsp[0], yyvsp[-1]);
	}
#line 8262 "./out/parser.cc"
    break;

  case 575: /* markup_braced_list_body: markup_braced_list_body markup_list  */
#line 4076 "parser.yy"
                                              {
		yyval = Srfi_1::append_reverse (yyvsp[0], yyvsp[-1]);
	}
#line 8270 "./out/parser.cc"
    break;

  case 576: /* markup_command_list: MARKUP_LIST_FUNCTION markup_command_list_arguments  */
#line 4082 "parser.yy"
                                                           {
	  yyval = scm_cons (yyvsp[-1], scm_reverse_x (yyvsp[0], SCM_EOL));
	}
#line 8278 "./out/parser.cc"
    break;

  case 577: /* $@13: %empty  */
#line 4088 "parser.yy"
            {
		parser->lexer_->push_note_state (Lily::pitchnames);
	}
#line 8286 "./out/parser.cc"
    break;

  case 578: /* markup_command_embedded_lilypond: '{' $@13 embedded_lilypond '}'  */
#line 4090 "parser.yy"
                                {
		parser->lexer_->pop_state ();
                yyval = yyvsp[-1];
	}
#line 8295 "./out/parser.cc"
    break;

  case 579: /* markup_command_basic_arguments: "markup-list?" markup_command_list_arguments markup_list  */
#line 4098 "parser.yy"
                                                                     {
		yyval = scm_cons (yyvsp[0], yyvsp[-1]);
	}
#line 8303 "./out/parser.cc"
    break;

  case 580: /* markup_command_basic_arguments: "scheme?" markup_command_list_arguments embedded_scm  */
#line 4101 "parser.yy"
                                                                {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-1], yyvsp[-2]);
	}
#line 8311 "./out/parser.cc"
    break;

  case 581: /* markup_command_basic_arguments: "scheme?" markup_command_list_arguments markup_command_embedded_lilypond  */
#line 4105 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-1], yyvsp[-2]);
	}
#line 8319 "./out/parser.cc"
    break;

  case 582: /* markup_command_basic_arguments: "scheme?" markup_command_list_arguments mode_changed_music  */
#line 4108 "parser.yy"
                                                                      {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-1], yyvsp[-2]);
	}
#line 8327 "./out/parser.cc"
    break;

  case 583: /* markup_command_basic_arguments: "scheme?" markup_command_list_arguments MUSIC_IDENTIFIER  */
#line 4111 "parser.yy"
                                                                    {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-1], yyvsp[-2]);
	}
#line 8335 "./out/parser.cc"
    break;

  case 584: /* markup_command_basic_arguments: "scheme?" markup_command_list_arguments STRING  */
#line 4114 "parser.yy"
                                                          {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-1], yyvsp[-2]);
	}
#line 8343 "./out/parser.cc"
    break;

  case 585: /* markup_command_basic_arguments: EXPECT_NO_MORE_ARGS  */
#line 4117 "parser.yy"
                              {
		yyval = SCM_EOL;
	}
#line 8351 "./out/parser.cc"
    break;

  case 586: /* markup_command_list_arguments: markup_command_basic_arguments  */
#line 4123 "parser.yy"
                                       { yyval = yyvsp[0]; }
#line 8357 "./out/parser.cc"
    break;

  case 587: /* markup_command_list_arguments: "markup?" markup_command_list_arguments markup  */
#line 4124 "parser.yy"
                                                             {
	  yyval = scm_cons (yyvsp[0], yyvsp[-1]);
	}
#line 8365 "./out/parser.cc"
    break;

  case 588: /* markup_partial_function: MARKUP_FUNCTION markup_arglist_partial  */
#line 4131 "parser.yy"
        {
		yyval = scm_list_1 (scm_cons (yyvsp[-1], scm_reverse_x (yyvsp[0], SCM_EOL)));
	}
#line 8373 "./out/parser.cc"
    break;

  case 589: /* markup_partial_function: markup_head_1_list MARKUP_FUNCTION markup_arglist_partial  */
#line 4135 "parser.yy"
        {
		yyval = scm_cons (scm_cons (yyvsp[-1], scm_reverse_x (yyvsp[0], SCM_EOL)),
			       yyvsp[-2]);
	}
#line 8382 "./out/parser.cc"
    break;

  case 590: /* markup_arglist_partial: "markup?" markup_arglist_partial  */
#line 4143 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 8390 "./out/parser.cc"
    break;

  case 591: /* markup_arglist_partial: "scheme?" markup_arglist_partial  */
#line 4147 "parser.yy"
        {
		yyval= yyvsp[0];
	}
#line 8398 "./out/parser.cc"
    break;

  case 592: /* markup_arglist_partial: "markup?" markup_command_list_arguments  */
#line 4151 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 8406 "./out/parser.cc"
    break;

  case 593: /* markup_arglist_partial: "scheme?" markup_command_list_arguments  */
#line 4155 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 8414 "./out/parser.cc"
    break;

  case 594: /* markup_head_1_item: MARKUP_FUNCTION "markup?" markup_command_list_arguments  */
#line 4161 "parser.yy"
                                                                    {
	  yyval = scm_cons (yyvsp[-2], scm_reverse_x (yyvsp[0], SCM_EOL));
	}
#line 8422 "./out/parser.cc"
    break;

  case 595: /* markup_head_1_list: markup_head_1_item  */
#line 4167 "parser.yy"
                                {
		yyval = scm_list_1 (yyvsp[0]);
	}
#line 8430 "./out/parser.cc"
    break;

  case 596: /* markup_head_1_list: markup_head_1_list markup_head_1_item  */
#line 4170 "parser.yy"
                                                {
		yyval = scm_cons (yyvsp[0], yyvsp[-1]);
	}
#line 8438 "./out/parser.cc"
    break;

  case 599: /* simple_markup: markup_word  */
#line 4182 "parser.yy"
        {
		yyval = make_simple_markup (yyvsp[0]);
	}
#line 8446 "./out/parser.cc"
    break;

  case 601: /* $@14: %empty  */
#line 4189 "parser.yy"
              {
		parser->lexer_->push_note_state (Lily::pitchnames);
	}
#line 8454 "./out/parser.cc"
    break;

  case 602: /* simple_markup_noword: "\\score" $@14 '{' score_body '}'  */
#line 4191 "parser.yy"
                             {
		Score *sc = unsmob<Score> (yyvsp[-1]);
		sc->origin ()->set_spot ((yyloc));
		if (sc->defs_.empty ()) {
			Output_def *od = get_layout (parser);
			sc->add_output_def (od);
			od->unprotect ();
		}
		yyval = scm_list_2 (Lily::score_markup, yyvsp[-1]);
		parser->lexer_->pop_state ();
	}
#line 8470 "./out/parser.cc"
    break;

  case 603: /* simple_markup_noword: MARKUP_FUNCTION markup_command_basic_arguments  */
#line 4202 "parser.yy"
                                                         {
		yyval = scm_cons (yyvsp[-1], scm_reverse_x (yyvsp[0], SCM_EOL));
	}
#line 8478 "./out/parser.cc"
    break;

  case 604: /* simple_markup_noword: markup_scm MARKUP_IDENTIFIER  */
#line 4206 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 8486 "./out/parser.cc"
    break;

  case 605: /* markup: markup_head_1_list simple_markup  */
#line 4213 "parser.yy"
        {
		yyval = scm_car (MAKE_SYNTAX (composed_markup_list,
					   (yylsp[0]), yyvsp[-1], scm_list_1 (yyvsp[0])));
	}
#line 8495 "./out/parser.cc"
    break;

  case 606: /* markup: simple_markup  */
#line 4217 "parser.yy"
                        {
		yyval = yyvsp[0];
	}
#line 8503 "./out/parser.cc"
    break;


#line 8507 "./out/parser.cc"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yytoken, &yylloc};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (&yylloc, parser, retval, yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          goto yyexhaustedlab;
      }
    }

  yyerror_range[1] = yylloc;
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= END_OF_FILE)
        {
          /* Return failure if at end of input.  */
          if (yychar == END_OF_FILE)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc, parser, retval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, yylsp, parser, retval);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  ++yylsp;
  YYLLOC_DEFAULT (*yylsp, yyerror_range, 2);

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if 1
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, parser, retval, YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, parser, retval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, yylsp, parser, retval);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

#line 4222 "parser.yy"


void
Lily_parser::set_yydebug (bool x)
{
	yydebug = x;
}

SCM
Lily_parser::do_yyparse ()
{
	return scm_c_with_fluid (Lily::f_parser,
				 self_scm (),
				 do_yyparse_trampoline,
				 static_cast <void *>(this));
}

SCM
Lily_parser::do_yyparse_trampoline (void *parser)
{
	SCM retval = SCM_UNDEFINED;
	yyparse (static_cast <Lily_parser *>(parser), &retval);
	return retval;
}



/*

It is a little strange to have this function in this file, but
otherwise, we have to import music classes into the lexer.

*/
int
Lily_lexer::try_special_identifiers (SCM *destination, SCM sid)
{
	if (unsmob<Book> (sid)) {
		Book *book =  unsmob<Book> (sid)->clone ();
		*destination = book->self_scm ();
		book->unprotect ();

		return BOOK_IDENTIFIER;
	} else if (scm_is_number (sid)) {
		*destination = sid;
		return NUMBER_IDENTIFIER;
	} else if (unsmob<Context_def> (sid))
	{
		*destination = unsmob<Context_def> (sid)->clone ()->unprotect ();
		return SCM_IDENTIFIER;
        } else if (unsmob<Context_mod> (sid)) {
                *destination = unsmob<Context_mod> (sid)->smobbed_copy ();
                return SCM_IDENTIFIER;
	} else if (Music *mus = unsmob<Music> (sid)) {
		mus = mus->clone ();
		*destination = mus->self_scm ();
		bool is_event = mus->is_mus_type ("post-event");
		mus->unprotect ();
		return is_event ? EVENT_IDENTIFIER : MUSIC_IDENTIFIER;
	} else if (unsmob<Pitch> (sid)) {
		*destination = unsmob<Pitch> (sid)->smobbed_copy ();
		return PITCH_IDENTIFIER;
	} else if (unsmob<Duration> (sid)) {
		*destination = unsmob<Duration> (sid)->smobbed_copy ();
		return DURATION_IDENTIFIER;
	} else if (unsmob<Output_def> (sid)) {
		*destination = unsmob<Output_def> (sid)->clone ()->unprotect ();
		return SCM_IDENTIFIER;
	} else if (unsmob<Score> (sid)) {
		*destination = unsmob<Score> (sid)->clone ()->unprotect ();
		return SCM_IDENTIFIER;
	} else if (scm_is_pair (sid)
		   && scm_is_pair (scm_car (sid))
		   && scm_is_true (Lily::key_p (scm_caar (sid)))) {
		*destination = sid;
		return LOOKUP_IDENTIFIER;
	}
	return -1;
}

// check_scheme_arg checks one argument with a given predicate for use
// in an argument list and throws a syntax error if it is unusable.
// The argument is prepended to the argument list in any case.  After
// throwing a syntax error, the argument list is terminated with #f as
// its last cdr in order to mark it as uncallable while not losing
// track of its total length.
//
// There are a few special considerations: if optional argument disp
// is given (otherwise it defaults to SCM_UNDEFINED), it will be used
// instead of arg in a prospective error message.  This is useful if
// arg is not the actual argument but rather a transformation of it.
//
// If arg itself is SCM_UNDEFINED, the predicate is considered false
// and an error message using disp is produced unconditionally.

SCM check_scheme_arg (Lily_parser *parser, Input loc,
		      SCM arg, SCM args, SCM pred, SCM disp)
{
	if (SCM_UNBNDP (arg))
		args = scm_cons (disp, args);
	else {
		args = scm_cons (arg, args);
		if (scm_is_true (scm_call_1 (pred, arg)))
			return args;
	}
	scm_set_cdr_x (scm_last_pair (args), SCM_EOL);
	MAKE_SYNTAX (argument_error, loc, scm_length (args), pred,
		     SCM_UNBNDP (disp) ? arg : disp);
	scm_set_cdr_x (scm_last_pair (args), SCM_BOOL_F);
	return args;
}

SCM loc_on_copy (Lily_parser *parser, Input loc, SCM arg)
{
	if (Music *m = unsmob<Music> (arg))
	{
		m = m->clone ();
		m->set_spot (parser->lexer_->override_input (loc));
		return m->unprotect ();
	}
	if (Book *b = unsmob<Book> (arg))
	{
		b = b->clone ();
		b->origin ()->set_spot (parser->lexer_->override_input (loc));
		return b->unprotect ();
	}
	if (Context_def *cd = unsmob<Context_def> (arg))
	{
		cd = cd->clone ();
		cd->origin ()->set_spot (parser->lexer_->override_input (loc));
		return cd->unprotect ();
	}
	if (Output_def *od = unsmob<Output_def> (arg))
	{
		od = od->clone ();
		od->input_origin_ = parser->lexer_->override_input (loc);
		return od->unprotect ();
	}
	if (Score *s = unsmob<Score> (arg))
	{
		s = s->clone ();
		s->origin ()->set_spot (parser->lexer_->override_input (loc));
		return s->unprotect ();
	}
	if (Context_mod *cm = unsmob<Context_mod> (arg))
	{
		return cm->smobbed_copy ();
	}
	return arg;
}

SCM
make_reverse_key_list (SCM keys)
{
	if (scm_is_true (Lily::key_p (keys)))
		return scm_list_1 (keys);
	if (scm_is_string (keys))
		return scm_list_1 (scm_string_to_symbol (keys));
	if (!ly_is_list (keys))
		return SCM_UNDEFINED;
	SCM res = SCM_EOL;
	for (; scm_is_pair (keys); keys = scm_cdr (keys))
	{
		SCM elt = scm_car (keys);
		if (scm_is_true (Lily::key_p (elt)))
			res = scm_cons (elt, res);
		else if (scm_is_string (elt))
			res = scm_cons (scm_string_to_symbol (elt), res);
		else return SCM_UNDEFINED;
	}
	return res;
}

SCM
try_string_variants (SCM pred, SCM str)
{
	// a matching predicate is always ok
	if (scm_is_true (scm_call_1 (pred, str)))
		return str;
	// a key may be interpreted as a list of keys if it helps
	if (scm_is_true (Lily::key_p (str))) {
		str = scm_list_1 (str);
		if (scm_is_true (scm_call_1 (pred, str)))
			return str;
		return SCM_UNDEFINED;
	}

	if (!scm_is_string (str))
		return SCM_UNDEFINED;

	// Let's attempt the symbol list interpretation first.

	str = scm_string_to_symbol (str);

	SCM lst = scm_list_1 (str);

	if (scm_is_true (scm_call_1 (pred, lst)))
		return lst;

	// Try the single symbol interpretation

	if (scm_is_true (scm_call_1 (pred, str)))
		return str;

	return SCM_UNDEFINED;
}

SCM
try_word_variants (SCM pred, SCM str)
{
	// str is always a string when we come here

	if (scm_is_true (scm_call_1 (pred, str)))
		return str;

	// If this cannot be a string representation of a symbol list,
	// we are through.

	if (!is_regular_identifier (str, true))
		return SCM_UNDEFINED;

	str = scm_string_split (str, SCM_MAKE_CHAR ('.'));
	for (SCM &p : as_ly_scm_list (str))
		p = scm_string_split (p, SCM_MAKE_CHAR (','));
	str = scm_append_x (str);
	for (SCM &p : as_ly_scm_list (str))
		p = scm_string_to_symbol (p);

	// Let's attempt the symbol list interpretation first.

	if (scm_is_true (scm_call_1 (pred, str)))
		return str;

	// If there is just one symbol in the list, we might interpret
	// it as a single symbol

	if (scm_is_null (scm_cdr (str)))
	{
		str = scm_car (str);
		if (scm_is_true (scm_call_1 (pred, str)))
			return str;
	}

	return SCM_UNDEFINED;
}

bool
is_regular_identifier (SCM id, bool multiple)
{
  if (!scm_is_string (id))
	  return false;

  string str = ly_scm2string (id);

  bool middle = false;

  for (string::iterator it=str.begin(); it != str.end (); it++)
  {
	  int c = *it & 0xff;
	  if ((c >= 'a' && c <= 'z')
	      || (c >= 'A' && c <= 'Z')
	      || c > 0x7f)
		  middle = true;
	  else if (middle && (c == '-' || c == '_' || (multiple &&
						       (c == '.' || c == ','))))
		  middle = false;
	  else
		  return false;
  }
  return middle;
}

SCM
make_music_from_simple (Lily_parser *parser, Input loc, SCM simple)
{
	if (unsmob<Music> (simple))
		return simple;

	if (scm_is_symbol (simple))
	{
		SCM out = SCM_UNDEFINED;
		switch (parser->lexer_->scan_word (out, simple))
		{
		case DRUM_PITCH:
		{
			Music *n = MY_MAKE_MUSIC ("NoteEvent", loc);
			set_property (n, "duration", parser->default_duration_.smobbed_copy ());
			set_property (n, "drum-type", out);
			return n->unprotect ();
		}
		case NOTENAME_PITCH:
		case TONICNAME_PITCH:
			// Take the parsed pitch
			simple = out;
			break;
		// Don't scan CHORD_MODIFIER etc.
		}
	}

	if (parser->lexer_->is_note_state ()) {
		if (unsmob<Pitch> (simple)) {
			Music *n = MY_MAKE_MUSIC ("NoteEvent", loc);
			set_property (n, "duration", parser->default_duration_.smobbed_copy ());
			set_property (n, "pitch", simple);
			return n->unprotect ();
		}
		SCM d = simple;
		if (scm_is_integer (simple))
			d = make_duration (simple);
		if (unsmob<Duration> (d)) {
			Music *n = MY_MAKE_MUSIC ("NoteEvent", loc);
			set_property (n, "duration", d);
			return n->unprotect ();
		}
		return simple;
	} else if (parser->lexer_->is_lyric_state ()) {
		if (Text_interface::is_markup (simple))
			return MAKE_SYNTAX (lyric_event, loc, simple,
					    parser->default_duration_.smobbed_copy ());
	} else if (parser->lexer_->is_chord_state ()) {
		if (unsmob<Pitch> (simple))
			return MAKE_SYNTAX
				(event_chord,
				 loc,
				 make_chord_elements (loc, simple,
						      parser->default_duration_.smobbed_copy (),
						      SCM_EOL));
	}
	return simple;
}

Music *
make_music_with_input (SCM name, Input where)
{
       Music *m = make_music_by_name (name);
       m->set_spot (where);
       return m;
}

SCM
make_simple_markup (SCM a)
{
	return a;
}

SCM
make_duration (SCM d, int dots, SCM factor)
{
	Duration k;

	if (Duration *dur = unsmob<Duration> (d)) {
		if (!dots && SCM_UNBNDP (factor))
			return d;
		k = *dur;
		if (dots)
			k = Duration (k.duration_log (), k.dot_count () + dots)
				.compressed (k.factor ());
	} else {
		int t = scm_to_int (d);
		if (t > 0 && (t & (t-1)) == 0)
			k = Duration (intlog2 (t), dots);
		else
			return SCM_UNDEFINED;
	}

	if (!SCM_UNBNDP (factor))
		k = k.compressed (from_scm<Rational> (factor));

	return k.smobbed_copy ();
}

SCM
make_chord_step (SCM step_scm, Rational alter)
{
	Pitch m (0, scm_to_int (step_scm) - 1, alter);

	// Notename/octave are normalized
	if (m.get_notename () == 6)
		m = m.transposed (Pitch (0, 0, FLAT_ALTERATION));

	return m.smobbed_copy ();
}


SCM
make_chord_elements (Input loc, SCM pitch, SCM dur, SCM modification_list)
{
	SCM res = Lily::construct_chord_elements (pitch, dur, modification_list);
	for (SCM s = res; scm_is_pair (s); s = scm_cdr (s))
	{
		unsmob<Music> (scm_car (s))->set_spot (loc);
	}
	return res;
}

// Return true if there are post events unaccounted for
bool
add_post_events (Music *m, SCM events)
{
	if (!scm_is_pair (events))
		return false;	// successfully added -- nothing

	while (m) {
		if (m->is_mus_type ("rhythmic-event")) {
			set_property
				(m, "articulations",
				 scm_append_x (scm_list_2
					       (get_property (m, "articulations"),
						events)));
			return false;
		}
		if (m->is_mus_type ("event-chord")) {
			set_property
				(m, "elements",
				 scm_append_x (scm_list_2
					       (get_property (m, "elements"),
						events)));
			return false;
		}
		if (m->is_mus_type ("sequential-music")) {
			SCM lp = scm_last_pair (get_property (m, "elements"));
			if (scm_is_pair (lp)) {
				m = unsmob<Music> (scm_car (lp));
				continue;
			}
			return true;
		}
		if (m->is_mus_type ("music-wrapper-music")
		    || m->is_mus_type ("time-scaled-music")) {
			m = unsmob<Music> (get_property (m, "element"));
			continue;
		}
		break;
	}
	return true;
}

// Returns either a list or a post-event
//
// If PRESERVE is true, unattachable post-events are not thrown away
// but rather added attached to empty chords.  If COMPRESS is true, a
// sequence consisting only of post-events may be returned as a single
// post-event.
SCM reverse_music_list (Lily_parser *parser, Input loc, SCM lst, bool preserve, bool compress)
{
	SCM res = SCM_EOL;	// Resulting reversed list
	SCM bad = SCM_EOL;	// Bad post events
	SCM post = SCM_EOL;	// current unattached events
	for (; scm_is_pair (lst); lst = scm_cdr (lst)) {
		SCM elt = scm_car (lst);
		Music *m = unsmob<Music> (elt);
		assert (m);
		if (m->is_mus_type ("post-event")) {
			post = post_event_cons (elt, post);
			continue;
		}
		if (add_post_events (m, post)) {
			bad = scm_cons (scm_car (post), bad);
			if (preserve) {
				Music *p = unsmob<Music> (scm_car (post));
				res = scm_cons (MAKE_SYNTAX (event_chord,
							     *p->origin (),
							     post),
						res);
			}
		}
		post = SCM_EOL;
		res = scm_cons (elt, res);
	}
	if (scm_is_pair (post)) {
		if (scm_is_null (res) && compress) { // pure postevent list
			if (scm_is_null (scm_cdr (post)))
				return scm_car (post);
			Music *m = MY_MAKE_MUSIC ("PostEvents", loc);
			set_property (m, "elements", post);
			return m->unprotect ();
		}
		bad = ly_append2 (post, bad);
		if (preserve) {
			Music *p = unsmob<Music> (scm_car (post));
			res = scm_cons (MAKE_SYNTAX (event_chord,
						     *p->origin (),
						     post),
					res);
		}
	}
	for (; scm_is_pair (bad); bad = scm_cdr (bad))
	{
		Music *what = unsmob<Music> (scm_car (bad));
		if (preserve)
			what->warning (_f ("Unattached %s", what->name ()));
		else
			what->warning (_f ("Dropping unattachable %s", what->name ()));
	}
	return res;
}

SCM post_event_cons (SCM post_event, SCM tail)
{
	Music *ev = unsmob<Music> (post_event);
	if (!ev)
		return tail;
	if (!ev->is_mus_type ("post-event-wrapper"))
		return scm_cons (post_event, tail);
	SCM elts = SCM_UNDEFINED;
	SCM props = SCM_EOL;
	SCM tweaks = SCM_UNDEFINED;
	for (SCM p = ev->get_property_alist (true);
	     scm_is_pair (p);
	     p = scm_cdr (p))
	{
		SCM pair = scm_car (p);
		SCM sym = scm_car (pair);
		if (scm_is_eq (sym, ly_symbol2scm ("origin")))
			continue;
		else if (scm_is_eq (sym, ly_symbol2scm ("elements"))
			 && SCM_UNBNDP (elts))
			elts = scm_cdr (pair);
		else if (scm_is_eq (sym, ly_symbol2scm ("tweaks"))
			 && SCM_UNBNDP (tweaks))
			tweaks = scm_cdr (pair);
		else
			props = scm_cons (pair, props);
	}
	if (!scm_is_pair (elts))
		return tail;
	for (SCM p = elts; scm_is_pair (p); p = scm_cdr (p))
	{
		Music *ev = unsmob<Music> (scm_car (p));
		// tweaks are always collected in-order, newer tweaks
		// nearer to the front of the list
		if (scm_is_pair (tweaks))
			set_property (ev, "tweaks",
					  scm_reverse_x (tweaks, get_property (ev, "tweaks")));
		// other properties are applied last to first so that
		// in case of duplicate properties, the actually
		// current one survives
		for (SCM q = props; scm_is_pair (q); q = scm_cdr (q))
			set_property (ev, scm_caar (q), scm_cdar (q));
	}
	return ly_append2 (elts, tail);
}

int
yylex (YYSTYPE *s, YYLTYPE *loc, Lily_parser *parser)
{
	Lily_lexer *lex = parser->lexer_;

	lex->lexval_ = s;
	lex->lexloc_ = loc;
	int tok = lex->pop_extra_token ();
	if (tok >= 0)
		return tok;
	lex->prepare_for_next_token ();
	return lex->yylex ();
}
